searchData={"items":[{"type":"task","title":"mix pow","doc":"Prints Pow tasks and their information.\n\n    mix pow","ref":"Mix.Tasks.Pow.html"},{"type":"task","title":"mix pow.ecto.gen.migration","doc":"Generates a user migration file.\n\n    mix pow.ecto.gen.migration -r MyApp.Repo\n\n    mix pow.ecto.gen.migration -r MyApp.Repo Accounts.Account accounts\n\nThis generator will add a migration file in `priv/repo/migrations` for the\n`users` table","ref":"Mix.Tasks.Pow.Ecto.Gen.Migration.html"},{"type":"task","title":"Arguments - mix pow.ecto.gen.migration","doc":"* `-r`, `--repo` - the repo module\n  * `--binary-id` - use binary id for primary key","ref":"Mix.Tasks.Pow.Ecto.Gen.Migration.html#module-arguments"},{"type":"task","title":"mix pow.ecto.gen.schema","doc":"Generates a user schema.\n\n    mix pow.ecto.gen.schema\n\n    mix pow.ecto.gen.schema --context-app my_app Accounts.Account accounts\n\nThis generator will add a schema module file in `lib/my_app/users/user.ex`.","ref":"Mix.Tasks.Pow.Ecto.Gen.Schema.html"},{"type":"task","title":"Arguments - mix pow.ecto.gen.schema","doc":"* `--binary-id` - use binary id for primary key and references\n  * `--context-app` - context app to use for path and module names","ref":"Mix.Tasks.Pow.Ecto.Gen.Schema.html#module-arguments"},{"type":"task","title":"mix pow.ecto.install","doc":"Generates a user schema module and migration file(s).\n\n    mix pow.ecto.install -r MyApp.Repo\n\n    mix pow.ecto.install -r MyApp.Repo Accounts.Account accounts\n\nSee `Mix.Tasks.Pow.Ecto.Gen.Schema`, `Mix.Tasks.Pow.Ecto.Gen.Migration`\nand `Mix.Tasks.Pow.Extension.Ecto.Gen.Migrations` for more.","ref":"Mix.Tasks.Pow.Ecto.Install.html"},{"type":"task","title":"Arguments - mix pow.ecto.install","doc":"* `--no-migrations` - don't generate migration files\n  * `--no-schema` - don't generate schema file\n  * `--extension` - extensions to generate migrations for","ref":"Mix.Tasks.Pow.Ecto.Install.html#module-arguments"},{"type":"task","title":"mix pow.extension.ecto.gen.migrations","doc":"Generates user migration files for extensions.\n\n    mix pow.extension.ecto.gen.migrations -r MyApp.Repo --extension PowEmailConfirmation --extension PowResetPassword\n\n    mix pow.extension.ecto.gen.migrations -r MyApp.Repo --extension PowEmailConfirmation Accounts.Account accounts","ref":"Mix.Tasks.Pow.Extension.Ecto.Gen.Migrations.html"},{"type":"task","title":"Arguments - mix pow.extension.ecto.gen.migrations","doc":"* `-r`, `--repo` - the repo module\n  * `--extension` - the extension to generate the migration for\n  * `--binary-id` - use binary id for primary key","ref":"Mix.Tasks.Pow.Extension.Ecto.Gen.Migrations.html#module-arguments"},{"type":"task","title":"mix pow.extension.phoenix.gen.templates","doc":"Generates templates for extensions.\n\n    mix pow.extension.phoenix.gen.templates --extension PowResetPassword --extension PowEmailConfirmation\n\n    mix pow.extension.phoenix.gen.templates --context-app my_app --extension PowResetPassword","ref":"Mix.Tasks.Pow.Extension.Phoenix.Gen.Templates.html"},{"type":"task","title":"Arguments - mix pow.extension.phoenix.gen.templates","doc":"* `--extension` - extension to generate templates for\n  * `--context-app` - context app to use for path and module names","ref":"Mix.Tasks.Pow.Extension.Phoenix.Gen.Templates.html#module-arguments"},{"type":"task","title":"mix pow.extension.phoenix.mailer.gen.templates","doc":"Generates mailer templates for extensions.\n\n    mix pow.extension.phoenix.mailer.gen.templates --extension PowEmailConfirmation --extension PowResetPassword","ref":"Mix.Tasks.Pow.Extension.Phoenix.Mailer.Gen.Templates.html"},{"type":"task","title":"Arguments - mix pow.extension.phoenix.mailer.gen.templates","doc":"* `--extension` - extension to generate templates for\n  * `--context-app` - app to use for path and module names","ref":"Mix.Tasks.Pow.Extension.Phoenix.Mailer.Gen.Templates.html#module-arguments"},{"type":"task","title":"mix pow.install","doc":"Runs install mix tasks for Ecto and Phoenix.\n\n    mix pow.install -r MyApp.Repo\n\n    mix pow.install -r MyApp.Repo Accounts.Account accounts\n\nSee `Mix.Tasks.Pow.Ecto.Install` and `Mix.Tasks.Pow.Phoenix.Install` for\nmore.","ref":"Mix.Tasks.Pow.Install.html"},{"type":"task","title":"mix pow.phoenix.gen.templates","doc":"Generates templates.\n\n    mix pow.phoenix.gen.templates\n\n    mix pow.phoenix.gen.templates --context-app my_app","ref":"Mix.Tasks.Pow.Phoenix.Gen.Templates.html"},{"type":"task","title":"Arguments - mix pow.phoenix.gen.templates","doc":"* `--context-app` - app to use for path and module names","ref":"Mix.Tasks.Pow.Phoenix.Gen.Templates.html#module-arguments"},{"type":"task","title":"mix pow.phoenix.install","doc":"Prints instructions fo setting up Pow with Phoenix.\n\n    mix pow.phoenix.install -r MyApp.Repo\n\n    mix pow.phoenix.install -r MyApp.Repo --context-app :my_app\n\n    mix pow.phoenix.install -r MyApp.Repo --templates --extension PowResetPassword\n\nTemplates are only generated when `--templates` argument is provided.\n\nSee `Mix.Tasks.Pow.Phoenix.Gen.Templates` and\n`Mix.Tasks.Pow.Extension.Phoenix.Gen.Templates` for more.","ref":"Mix.Tasks.Pow.Phoenix.Install.html"},{"type":"task","title":"Arguments - mix pow.phoenix.install","doc":"* `--context-app` - app to use for path and module names\n  * `--templates` - generate templates\n  * `--extension` - extensions to generate templates for","ref":"Mix.Tasks.Pow.Phoenix.Install.html#module-arguments"},{"type":"module","title":"Pow.Config","doc":"Functions to parse and modify configurations.","ref":"Pow.Config.html"},{"type":"function","title":"Pow.Config.get/3","doc":"Gets the key value from the configuration.\n\nIf not found, it'll fall back to environment config, and lastly to the\ndefault value which is `nil` if not specified.","ref":"Pow.Config.html#get/3"},{"type":"function","title":"Pow.Config.merge/2","doc":"Merges two configurations.","ref":"Pow.Config.html#merge/2"},{"type":"function","title":"Pow.Config.put/3","doc":"Puts a new key value to the configuration.","ref":"Pow.Config.html#put/3"},{"type":"function","title":"Pow.Config.raise_error/1","doc":"Raise a ConfigError exception.","ref":"Pow.Config.html#raise_error/1"},{"type":"function","title":"Pow.Config.repo!/1","doc":"Retrieves the repo module from the config, or raises an exception.","ref":"Pow.Config.html#repo!/1"},{"type":"function","title":"Pow.Config.user!/1","doc":"Retrieves the user schema module from the config, or raises an exception.","ref":"Pow.Config.html#user!/1"},{"type":"type","title":"Pow.Config.t/0","doc":"","ref":"Pow.Config.html#t:t/0"},{"type":"behaviour","title":"Pow.Context","doc":"Used to set up context API.","ref":"Pow.Context.html"},{"type":"callback","title":"Pow.Context.authenticate/1","doc":"","ref":"Pow.Context.html#c:authenticate/1"},{"type":"callback","title":"Pow.Context.create/1","doc":"","ref":"Pow.Context.html#c:create/1"},{"type":"callback","title":"Pow.Context.delete/1","doc":"","ref":"Pow.Context.html#c:delete/1"},{"type":"callback","title":"Pow.Context.get_by/1","doc":"","ref":"Pow.Context.html#c:get_by/1"},{"type":"callback","title":"Pow.Context.update/2","doc":"","ref":"Pow.Context.html#c:update/2"},{"type":"type","title":"Pow.Context.changeset/0","doc":"","ref":"Pow.Context.html#t:changeset/0"},{"type":"type","title":"Pow.Context.user/0","doc":"","ref":"Pow.Context.html#t:user/0"},{"type":"behaviour","title":"Pow.Extension.Base","doc":"Used to set up extensions to enable parts of extension for auto-discovery.\n\nThis exists to prevent unnecessary `Code.ensure_compiled/1` calls, and will\nlet the extension define what modules it has.","ref":"Pow.Extension.Base.html"},{"type":"behaviour","title":"Usage - Pow.Extension.Base","doc":"defmodule MyCustomExtension do\n      use Pow.Extension.Base\n\n      @impl true\n      def ecto_schema?(), do: true\n    end","ref":"Pow.Extension.Base.html#module-usage"},{"type":"callback","title":"Pow.Extension.Base.ecto_schema?/0","doc":"","ref":"Pow.Extension.Base.html#c:ecto_schema?/0"},{"type":"function","title":"Pow.Extension.Base.has?/2","doc":"Checks whether an extension has a certain module.\n\nIf a base extension module doesn't exist, or is configured improperly,\n`Code.ensure_compiled/1` will be used instead to see whether the module\nexists for the extension.","ref":"Pow.Extension.Base.html#has?/2"},{"type":"callback","title":"Pow.Extension.Base.phoenix_controller_callbacks?/0","doc":"","ref":"Pow.Extension.Base.html#c:phoenix_controller_callbacks?/0"},{"type":"callback","title":"Pow.Extension.Base.phoenix_messages?/0","doc":"","ref":"Pow.Extension.Base.html#c:phoenix_messages?/0"},{"type":"callback","title":"Pow.Extension.Base.phoenix_router?/0","doc":"","ref":"Pow.Extension.Base.html#c:phoenix_router?/0"},{"type":"callback","title":"Pow.Extension.Base.phoenix_templates/0","doc":"","ref":"Pow.Extension.Base.html#c:phoenix_templates/0"},{"type":"function","title":"Pow.Extension.Base.use?/2","doc":"Checks whether an extension has a certain module that has a `__using__/1`\nmacro.\n\nThis calls `has?/2` first, If a base extension module doesn't exist, or is\nconfigured improperly, `Kernel.macro_exported?/3` will be used instead to\ncheck if the module has a `__using__/1` macro.","ref":"Pow.Extension.Base.html#use?/2"},{"type":"callback","title":"Pow.Extension.Base.use_ecto_schema?/0","doc":"","ref":"Pow.Extension.Base.html#c:use_ecto_schema?/0"},{"type":"module","title":"Pow.Extension.Config","doc":"Configuration helpers for extensions.","ref":"Pow.Extension.Config.html"},{"type":"function","title":"Pow.Extension.Config.discover_modules/2","doc":"","ref":"Pow.Extension.Config.html#discover_modules/2"},{"type":"function","title":"Pow.Extension.Config.extension_modules/2","doc":"Finds all existing extension modules that matches the extensions and module\nlist.\n\nThis will iterate through all extensions appending the module list to the\nextension module and return a list of all modules that exists in the project.","ref":"Pow.Extension.Config.html#extension_modules/2"},{"type":"function","title":"Pow.Extension.Config.extensions/1","doc":"Fetches the `:extensions` key from the configuration.","ref":"Pow.Extension.Config.html#extensions/1"},{"type":"function","title":"Pow.Extension.Config.underscore_extension/1","doc":"Returns a binary of the extension atom.\n\nThis is usually used to create extension namespaces for functions to be used\nin shared modules.","ref":"Pow.Extension.Config.html#underscore_extension/1"},{"type":"module","title":"Pow.Operations","doc":"Operation functions that glues operation calls to context module.\n\nA custom context module can be used instead of the default `Pow.Ecto.Context`\nif a `:users_context` key is passed in the configuration.","ref":"Pow.Operations.html"},{"type":"function","title":"Pow.Operations.authenticate/2","doc":"Authenticate a user.\n\nThis calls `Pow.Ecto.Context.authenticate/2` or `authenticate/1` on a custom\ncontext module.","ref":"Pow.Operations.html#authenticate/2"},{"type":"function","title":"Pow.Operations.changeset/2","doc":"Build a changeset from a blank user struct.\n\nIt'll use the schema module fetched from the config through\n`Pow.Config.user!/1`.","ref":"Pow.Operations.html#changeset/2"},{"type":"function","title":"Pow.Operations.changeset/3","doc":"Build a changeset from existing user struct.\n\nIt'll call the `changeset/2` function on the user struct.","ref":"Pow.Operations.html#changeset/3"},{"type":"function","title":"Pow.Operations.create/2","doc":"Create a new user.\n\nThis calls `Pow.Ecto.Context.create/2` or `create/1` on a custom context\nmodule.","ref":"Pow.Operations.html#create/2"},{"type":"function","title":"Pow.Operations.delete/2","doc":"Delete an existing user.\n\nThis calls `Pow.Ecto.Context.delete/2` or `delete/1` on a custom context\nmodule.","ref":"Pow.Operations.html#delete/2"},{"type":"function","title":"Pow.Operations.fetch_primary_key_values/2","doc":"Retrieve a keyword list of primary key value(s) from the provided struct.\n\nThe keys will be fetched from the `__schema__/1` function in the struct\nmodule. If no `__schema__/1` function exists, then it's expected that the\nstruct has `:id` as its only primary key.","ref":"Pow.Operations.html#fetch_primary_key_values/2"},{"type":"function","title":"Pow.Operations.get_by/2","doc":"Retrieve a user with the provided clauses.\n\nThis calls `Pow.Ecto.Context.get_by/2` or `get_by/1` on a custom context\nmodule.","ref":"Pow.Operations.html#get_by/2"},{"type":"function","title":"Pow.Operations.reload/2","doc":"Takes a struct and will reload it.\n\nThe clauses are fetched with `fetch_primary_key_values/2`, and the struct\nloaded with `get_by/2`. A `RuntimeError` exception will be raised if the clauses\ncould not be fetched.","ref":"Pow.Operations.html#reload/2"},{"type":"function","title":"Pow.Operations.update/3","doc":"Update an existing user.\n\nThis calls `Pow.Ecto.Context.update/3` or `update/2` on a custom context\nmodule.","ref":"Pow.Operations.html#update/3"},{"type":"module","title":"Pow.UUID","doc":"Module to generate UUID binary.\n\nThe token generation code is pulled from\nhttps://github.com/elixir-ecto/ecto/blob/v2.2.10/lib/ecto/uuid.ex#L1, and is\nunder Apache 2 license.","ref":"Pow.UUID.html"},{"type":"function","title":"Pow.UUID.generate/0","doc":"Generates a UUID binary.","ref":"Pow.UUID.html#generate/0"},{"type":"module","title":"Pow.Plug","doc":"Plug helper functions.","ref":"Pow.Plug.html"},{"type":"function","title":"Pow.Plug.assign_current_user/3","doc":"Assign an authenticated user to the connection.\n\nThis will assign the user to the conn. The key is by default `:current_user`,\nbut it can be overridden with `:current_user_assigns_key` configuration\noption.","ref":"Pow.Plug.html#assign_current_user/3"},{"type":"function","title":"Pow.Plug.authenticate_user/2","doc":"Authenticates a user.\n\nIf successful, a new session will be created.","ref":"Pow.Plug.html#authenticate_user/2"},{"type":"function","title":"Pow.Plug.change_user/2","doc":"Creates a changeset from the current authenticated user.","ref":"Pow.Plug.html#change_user/2"},{"type":"function","title":"Pow.Plug.create/2","doc":"Call `create/3` for the Pow plug set for the `conn`.","ref":"Pow.Plug.html#create/2"},{"type":"function","title":"Pow.Plug.create/3","doc":"","ref":"Pow.Plug.html#create/3"},{"type":"function","title":"Pow.Plug.create_user/2","doc":"Creates a new user.\n\nIf successful, a new session will be created.","ref":"Pow.Plug.html#create_user/2"},{"type":"function","title":"Pow.Plug.current_user/1","doc":"Get the current user assigned to the conn.\n\nThe config is fetched from the conn. See `current_user/2` for more.","ref":"Pow.Plug.html#current_user/1"},{"type":"function","title":"Pow.Plug.current_user/2","doc":"Get the current user assigned to the conn.\n\nThis will fetch the user from the assigns map in the conn. The key is by\ndefault `:current_user`, but it can be overridden with\n`:current_user_assigns_key` configuration option.","ref":"Pow.Plug.html#current_user/2"},{"type":"function","title":"Pow.Plug.delete/1","doc":"Call `delete/2` for the Pow plug set for the `conn`.","ref":"Pow.Plug.html#delete/1"},{"type":"function","title":"Pow.Plug.delete/2","doc":"","ref":"Pow.Plug.html#delete/2"},{"type":"function","title":"Pow.Plug.delete_user/1","doc":"Deletes the current authenticated user.\n\nIf successful, the user authentication will be cleared from the session.","ref":"Pow.Plug.html#delete_user/1"},{"type":"function","title":"Pow.Plug.fetch_config/1","doc":"Fetch configuration from the private key in the connection.\n\nIt'll raise an error if configuration hasn't been set as a private key.","ref":"Pow.Plug.html#fetch_config/1"},{"type":"function","title":"Pow.Plug.get_plug/1","doc":"","ref":"Pow.Plug.html#get_plug/1"},{"type":"function","title":"Pow.Plug.prepend_with_namespace/2","doc":"Prepend namespace found in Plug Pow configuration to binary.\n\nWill prepend `:otp_app` if exists in configuration.","ref":"Pow.Plug.html#prepend_with_namespace/2"},{"type":"function","title":"Pow.Plug.put_config/2","doc":"Put the provided config as a private key in the connection.","ref":"Pow.Plug.html#put_config/2"},{"type":"function","title":"Pow.Plug.sign_token/4","doc":"Signs a token for public consumption.\n\nUsed to prevent timing attacks with token lookup.\n\nThis uses `Pow.Plug.MessageVerifier` by default, but can be changed if the\nPow configuration is set with `:message_verifier`. `Pow.Plug.MessageVerifier`\ncan also be configured in this way if `:message_verifier` is set to\n`{Pow.Plug.MessageVerifier, key_generator_opts: [length: 64]}`","ref":"Pow.Plug.html#sign_token/4"},{"type":"function","title":"Pow.Plug.update_user/2","doc":"Updates the current authenticated user.\n\nIf successful, a new session will be created.","ref":"Pow.Plug.html#update_user/2"},{"type":"function","title":"Pow.Plug.verify_token/4","doc":"Decodes and verifies a token.\n\nUsed to prevent timing attacks with token lookup.\n\nThis uses `Pow.Plug.MessageVerifier` by default, but can be changed if the\nPow configuration is set with `:message_verifier`. `Pow.Plug.MessageVerifier`\ncan also be configured in this way if `:message_verifier` is set to\n`{Pow.Plug.MessageVerifier, key_generator_opts: [length: 64]}`","ref":"Pow.Plug.html#verify_token/4"},{"type":"behaviour","title":"Pow.Plug.Base","doc":"This plug macro will set `:pow_config` as private, and attempt to fetch and\nassign a user in the connection if it has not already been assigned. The user\nwill be assigned automatically in any of the operations.\n\nAny writes to backend store or client should occur in `:before_send` callback\nas defined in `Plug.Conn`. To ensure that the callbacks are called in the\norder they were set, a `register_before_send/2` function is used to set\ncallbacks instead of `Plug.Conn.register_before_send/2`.","ref":"Pow.Plug.Base.html"},{"type":"behaviour","title":"Configuration options - Pow.Plug.Base","doc":"* `:credentials_cache_store` - the credentials cache store. This value defaults to\n    `{Pow.Store.CredentialsCache, backend: Pow.Store.Backend.EtsCache}`. The\n    `Pow.Store.Backend.EtsCache` backend store can be changed with the\n    `:cache_store_backend` option.\n\n  * `:cache_store_backend` - the backend cache store. This value defaults to\n    `Pow.Store.Backend.EtsCache`.","ref":"Pow.Plug.Base.html#module-configuration-options"},{"type":"behaviour","title":"Example - Pow.Plug.Base","doc":"defmodule MyAppWeb.Pow.CustomPlug do\n      use Pow.Plug.Base\n\n      @impl true\n      def fetch(conn, _config) do\n        user = fetch_user_from_cookie(conn)\n\n        {conn, user}\n      end\n\n      @impl true\n      def create(conn, user, _config) do\n        conn = update_cookie(conn, user)\n\n        {conn, user}\n      end\n\n      @impl true\n      def delete(conn, _config) do\n        delete_cookie(conn)\n      end\n    end","ref":"Pow.Plug.Base.html#module-example"},{"type":"callback","title":"Pow.Plug.Base.call/2","doc":"","ref":"Pow.Plug.Base.html#c:call/2"},{"type":"callback","title":"Pow.Plug.Base.create/3","doc":"","ref":"Pow.Plug.Base.html#c:create/3"},{"type":"callback","title":"Pow.Plug.Base.delete/2","doc":"","ref":"Pow.Plug.Base.html#c:delete/2"},{"type":"callback","title":"Pow.Plug.Base.fetch/2","doc":"","ref":"Pow.Plug.Base.html#c:fetch/2"},{"type":"callback","title":"Pow.Plug.Base.init/1","doc":"","ref":"Pow.Plug.Base.html#c:init/1"},{"type":"function","title":"Pow.Plug.Base.store/1","doc":"","ref":"Pow.Plug.Base.html#store/1"},{"type":"behaviour","title":"Pow.Plug.MessageVerifier","doc":"This module can sign and verify messages.\n\nBased on `Phoenix.Token`.","ref":"Pow.Plug.MessageVerifier.html"},{"type":"function","title":"Pow.Plug.MessageVerifier.sign/4","doc":"Signs a message.\n\n`Plug.Crypto.MessageVerifier.sign/2` is used. The secret is derived from the\n`salt` and `conn.secret_key_base` using\n`Plug.Crypto.KeyGenerator.generate/3`. If `:key_generator_opts` is set in the\nconfig, this will be passed on to `Plug.Crypto.KeyGenerator`.","ref":"Pow.Plug.MessageVerifier.html#sign/4"},{"type":"callback","title":"Pow.Plug.MessageVerifier.sign/4","doc":"","ref":"Pow.Plug.MessageVerifier.html#c:sign/4"},{"type":"function","title":"Pow.Plug.MessageVerifier.verify/4","doc":"Verifies a message.\n\n`Plug.Crypto.MessageVerifier.sign/2` is used. The secret is derived from the\n`salt` and `conn.secret_key_base` using\n`Plug.Crypto.KeyGenerator.generate/3`. If `:key_generator_opts` is set in the\nconfig, this will be passed on to `Plug.Crypto.KeyGenerator`.","ref":"Pow.Plug.MessageVerifier.html#verify/4"},{"type":"callback","title":"Pow.Plug.MessageVerifier.verify/4","doc":"","ref":"Pow.Plug.MessageVerifier.html#c:verify/4"},{"type":"module","title":"Pow.Plug.RequireAuthenticated","doc":"This plug ensures that a user has been authenticated.\n\nYou can see `Pow.Phoenix.PlugErrorHandler` for an example of the error\nhandler module.","ref":"Pow.Plug.RequireAuthenticated.html"},{"type":"module","title":"Example - Pow.Plug.RequireAuthenticated","doc":"plug Pow.Plug.RequireAuthenticated,\n      error_handler: MyApp.CustomErrorHandler","ref":"Pow.Plug.RequireAuthenticated.html#module-example"},{"type":"module","title":"Pow.Plug.RequireNotAuthenticated","doc":"This plug ensures that a user hasn't already been authenticated.\n\nYou can see `Pow.Phoenix.PlugErrorHandler` for an example of the error\nhandler module.","ref":"Pow.Plug.RequireNotAuthenticated.html"},{"type":"module","title":"Example - Pow.Plug.RequireNotAuthenticated","doc":"plug Pow.Plug.RequireNotAuthenticated,\n      error_handler: MyAppWeb.Pow.ErrorHandler","ref":"Pow.Plug.RequireNotAuthenticated.html#module-example"},{"type":"module","title":"Pow.Plug.Session","doc":"This plug will handle user authorization using session.\n\nThe plug will store user and session metadata in the cache store backend. The\nsession metadata has at least an `:inserted_at` and a `:fingerprint` key. The\n`:inserted_at` value is used to determine if the session has to be renewed,\nand is set each time a session is created. The `:fingerprint` will be a random\nunique id and will stay the same if a session is renewed.\n\nWhen a session is renewed the old session is deleted and a new created.\n\nYou can add additional metadata to sessions by setting or updated the\nassigned private `:pow_session_metadata` key in the conn. The value has to be\na keyword list.\n\nThe session id used in the client is signed using `Pow.Plug.sign_token/4` to\nprevent timing attacks.","ref":"Pow.Plug.Session.html"},{"type":"module","title":"Example - Pow.Plug.Session","doc":"@pow_config [\n      repo: MyApp.Repo,\n      user: MyApp.User,\n      current_user_assigns_key: :current_user,\n      session_key: \"auth\",\n      credentials_cache_store: {Pow.Store.CredentialsCache,\n                                ttl: :timer.minutes(30),\n                                namespace: \"credentials\"},\n      session_ttl_renewal: :timer.minutes(15),\n      cache_store_backend: Pow.Store.Backend.EtsCache,\n      users_context: Pow.Ecto.Users\n    ]\n\n    # ...\n\n    plug Plug.Session, @session_options\n    plug Pow.Plug.Session, @pow_config","ref":"Pow.Plug.Session.html#module-example"},{"type":"module","title":"Configuration options - Pow.Plug.Session","doc":"* `:credentials_cache_store` - see `Pow.Plug.Base`.\n\n  * `:cache_store_backend` - see `Pow.Plug.Base`.\n\n  * `:session_key` - session key name, defaults to \"auth\". If `:otp_app` is\n    used it'll automatically prepend the key with the `:otp_app` value.\n\n  * `:session_ttl_renewal` - the ttl in milliseconds to trigger renewal of\n    sessions. Defaults to 15 minutes in miliseconds.","ref":"Pow.Plug.Session.html#module-configuration-options"},{"type":"module","title":"Custom metadata - Pow.Plug.Session","doc":"The assigned private `:pow_session_metadata` key in the conn can be populated\nwith custom metadata. This data will be stored in the session metadata when\nthe session is created, and fetched in subsequent requests.\n\nHere's an example of how one could add sign in timestamp, IP, and user agent\ninformation to the session metadata:\n\n    def append_to_session_metadata(conn) do\n      client_ip  = to_string(:inet_parse.ntoa(conn.remote_ip))\n      user_agent = get_req_header(conn, \"user-agent\")\n\n      metadata =\n        conn.private\n        |> Map.get(:pow_session_metadata, [])\n        |> Keyword.put_new(:first_seen_at, DateTime.utc_now())\n        |> Keyword.put(:ip, client_ip)\n        |> Keyword.put(:user_agent, user_agent)\n\n      Plug.Conn.put_private(conn, :pow_session_metadata, metadata)\n    end\n\nThe `:first_seen_at` will only be set if it doesn't already exist in the\nsession metadata, while `:ip` and `:user_agent` will be updated each time the\nsession is created.\n\nThe function should be called after `Pow.Plug.Session.call/2` has been called\nto ensure that the metadata, if any, has been fetched.","ref":"Pow.Plug.Session.html#module-custom-metadata"},{"type":"module","title":"Session expiration - Pow.Plug.Session","doc":"`Pow.Store.CredentialsCache` will, by default, invalidate any session token\n30 minutes after it has been generated. To keep sessions alive the\n`:session_ttl_renewal` option is used to determine when a session token\nbecomes stale and a new session ID has to be generated for the user (deleting\nthe previous one in the process).\n\nIf `:session_ttl_renewal` is set to zero, a new session token will be\ngenerated on every request.\n\nTo change the amount of time a session can be alive, both the TTL for\n`Pow.Store.CredentialsCache` and `:session_ttl_renewal` option should be\nchanged:\n\n    plug Pow.Plug.Session, otp_app: :my_app,\n      session_ttl_renewal: :timer.minutes(1),\n      credentials_cache_store: {Pow.Store.CredentialsCache, ttl: :timer.minutes(15)}\n\nIn the above, a new session token will be generated when a request occurs\nmore than a minute after the current session token was generated. The\nsession is invalidated if there is no request for the next 14 minutes.\n\nThere are no absolute session timeout; sessions can be kept alive\nindefinitely.","ref":"Pow.Plug.Session.html#module-session-expiration"},{"type":"function","title":"Pow.Plug.Session.call/2","doc":"Configures the connection for Pow, and fetches user.\n\nIf no options have been passed to the plug, the existing configuration\nwill be pulled with `Pow.Plug.fetch_config/1`\n\n`:plug` is appended to the passed configuration, so the current plug will\nbe used in any subsequent calls to create, update and delete user\ncredentials from the connection. The configuration is then set for the\nconn with `Pow.Plug.put_config/2`.\n\nIf a user can't be fetched with `Pow.Plug.current_user/2`, `do_fetch/2`\nwill be called.","ref":"Pow.Plug.Session.html#call/2"},{"type":"function","title":"Pow.Plug.Session.create/3","doc":"Create new session with a randomly generated unique session id.\n\nThis will store the unique session id with user credentials in the\ncredentials cache. The session id will be stored in the connection with\n`Plug.Conn.put_session/3`. Any existing sessions will be deleted first with\n`delete/2`.\n\nThe unique session id will be prepended by the `:otp_app` configuration\nvalue, if present.\n\nIf an assigned private `:pow_session_metadata` key exists in the conn, it'll\nbe passed on as the metadata for the session. However the `:inserted_at` value\nwill always be overridden. If no `:fingerprint` exists in the metadata a\nrandom UUID value will be generated as its value.\n\nThe session id will be signed for public consumption with\n`Pow.Plug.sign_token/4`.\n\nSee `do_create/3` for more.","ref":"Pow.Plug.Session.html#create/3"},{"type":"function","title":"Pow.Plug.Session.delete/2","doc":"Delete an existing session in the credentials cache.\n\nThis will delete a session in the credentials cache with the session id\nfetched through `Plug.Conn.get_session/2`. The session in the connection is\ndeleted too with `Plug.Conn.delete_session/2`.\n\nSee `do_delete/2` for more.","ref":"Pow.Plug.Session.html#delete/2"},{"type":"function","title":"Pow.Plug.Session.do_create/3","doc":"Calls `create/3` and assigns the current user.\n\nThe user is assigned to the conn with `Pow.Plug.assign_current_user/3`.","ref":"Pow.Plug.Session.html#do_create/3"},{"type":"function","title":"Pow.Plug.Session.do_delete/2","doc":"Calls `delete/2` and removes the current user assigned to the conn.\n\nThe user assigned is removed from the conn with\n`Pow.Plug.assign_current_user/3`.","ref":"Pow.Plug.Session.html#do_delete/2"},{"type":"function","title":"Pow.Plug.Session.do_fetch/2","doc":"Calls `fetch/2` and assigns the current user to the conn.\n\nThe user is assigned to the conn with `Pow.Plug.assign_current_user/3`.","ref":"Pow.Plug.Session.html#do_fetch/2"},{"type":"function","title":"Pow.Plug.Session.fetch/2","doc":"Fetches session from credentials cache.\n\nThis will fetch a session from the credentials cache with the session id\nfetched through `Plug.Conn.get_session/2` session. If the credentials are\nstale (timestamp is older than the `:session_ttl_renewal` value), a global\nlock will be set, and the session will be regenerated with `create/3`.\nNothing happens if setting the lock failed.\n\nThe metadata of the session will be assigned as a private\n`:pow_session_metadata` key in the conn so it may be used in `create/3`.\n\nIf the credentials cache returns a `nil` value the session will be\nimmediately deleted as it means the context function could not find the\nassociated user.\n\nThe session id will be decoded and verified with `Pow.Plug.verify_token/4`.\n\nSee `do_fetch/2` for more.","ref":"Pow.Plug.Session.html#fetch/2"},{"type":"module","title":"Pow.Ecto.Context","doc":"Handles pow users context for user.","ref":"Pow.Ecto.Context.html"},{"type":"module","title":"Usage - Pow.Ecto.Context","doc":"This module will be used by pow by default. If you\nwish to have control over context functions, you can\ndo configure `lib/my_project/users/users.ex`\nthe following way:\n\n    defmodule MyApp.Users do\n      use Pow.Ecto.Context,\n        repo: MyApp.Repo,\n        user: MyApp.Users.User\n\n      def create(params) do\n        pow_create(params)\n      end\n    end\n\nRemember to update configuration with `users_context: MyApp.Users`.\n\nThe following Pow functions can be accessed:\n\n  * `pow_authenticate/1`\n  * `pow_create/1`\n  * `pow_update/2`\n  * `pow_delete/1`\n  * `pow_get_by/1`","ref":"Pow.Ecto.Context.html#module-usage"},{"type":"module","title":"Configuration options - Pow.Ecto.Context","doc":"* `:repo` - the ecto repo module (required)\n  * `:user` - the user schema module (required)\n  * `:repo_opts` - keyword list options for the repo, `:prefix` can be set here","ref":"Pow.Ecto.Context.html#module-configuration-options"},{"type":"function","title":"Pow.Ecto.Context.authenticate/2","doc":"Finds a user based on the user id, and verifies the password on the user.\n\nUser schema module and repo module will be fetched from the config. The user\nid field is fetched from the user schema module.\n\nThe function will return nil if either the fetched user or password is nil.\n\nTo prevent timing attacks, a blank user struct will be passed to the\n`verify_password/2` function for the user schema module to ensure that the\nthe response time will be equal as when a password is verified.","ref":"Pow.Ecto.Context.html#authenticate/2"},{"type":"function","title":"Pow.Ecto.Context.create/2","doc":"Creates a new user.\n\nUser schema module and repo module will be fetched from config.","ref":"Pow.Ecto.Context.html#create/2"},{"type":"function","title":"Pow.Ecto.Context.delete/2","doc":"Deletes the user.\n\nRepo module will be fetched from the config.","ref":"Pow.Ecto.Context.html#delete/2"},{"type":"function","title":"Pow.Ecto.Context.do_insert/2","doc":"Inserts a changeset to the database.\n\nIf succesful, the returned row will be reloaded from the database.","ref":"Pow.Ecto.Context.html#do_insert/2"},{"type":"function","title":"Pow.Ecto.Context.do_update/2","doc":"Updates a changeset in the database.\n\nIf succesful, the returned row will be reloaded from the database.","ref":"Pow.Ecto.Context.html#do_update/2"},{"type":"function","title":"Pow.Ecto.Context.get_by/2","doc":"Retrieves an user by the provided clauses.\n\nUser schema module and repo module will be fetched from the config.","ref":"Pow.Ecto.Context.html#get_by/2"},{"type":"function","title":"Pow.Ecto.Context.repo/1","doc":"","ref":"Pow.Ecto.Context.html#repo/1"},{"type":"function","title":"Pow.Ecto.Context.update/3","doc":"Updates the user.\n\nUser schema module will be fetched from provided user and repo will be\nfetched from the config.","ref":"Pow.Ecto.Context.html#update/3"},{"type":"function","title":"Pow.Ecto.Context.user_schema_mod/1","doc":"","ref":"Pow.Ecto.Context.html#user_schema_mod/1"},{"type":"type","title":"Pow.Ecto.Context.changeset/0","doc":"","ref":"Pow.Ecto.Context.html#t:changeset/0"},{"type":"type","title":"Pow.Ecto.Context.user/0","doc":"","ref":"Pow.Ecto.Context.html#t:user/0"},{"type":"behaviour","title":"Pow.Ecto.Schema","doc":"Handles the Ecto schema for user.\n\nThe macro will create a `@pow_fields` module attribute, and append fields to\nit using the attributes from `Pow.Ecto.Schema.Fields.attrs/1`. Likewise, a\n`@pow_assocs` module attribute is also generated for associations. The\n`pow_user_fields/0` macro will use these attributes to create fields and\nassociations in the ecto schema.\n\nThe macro will add two overridable functions to your module; `changeset/2`\nand `verify_password/2`. See the customization section below for more.\n\nThe following helper functions are added for changeset customization:\n\n  - `pow_changeset/2`,\n  - `pow_verify_password/2`\n  - `pow_user_id_field_changeset/2`\n  - `pow_password_changeset/2`,\n  - `pow_current_password_changeset/2`,\n\nFinally `pow_user_id_field/0` function is added to the module that is used to\nfetch the user id field name.\n\nA `@pow_config` module attribute is created containing the options that were\npassed to the macro with the `use Pow.Ecto.Schema, ...` call.\n\nSee `Pow.Ecto.Schema.Changeset` for more.","ref":"Pow.Ecto.Schema.html"},{"type":"behaviour","title":"Usage - Pow.Ecto.Schema","doc":"Configure `lib/my_project/users/user.ex` the following way:\n\n    defmodule MyApp.Users.User do\n      use Ecto.Schema\n      use Pow.Ecto.Schema,\n        user_id_field: :email,\n        password_hash_verify: {&Pow.Ecto.Schema.Password.pbkdf2_hash/1,\n                                &Pow.Ecto.Schema.Password.pbkdf2_verify/2},\n        password_min_length: 8,\n        password_max_length: 4096\n\n      schema \"users\" do\n        field :custom_field, :string\n\n        pow_user_fields()\n\n        timestamps()\n      end\n\n      def changeset(user_or_changeset, attrs) do\n        pow_changeset(user_or_changeset, attrs)\n      end\n    end\n\nRemember to add `user: MyApp.Users.User` to your configuration.","ref":"Pow.Ecto.Schema.html#module-usage"},{"type":"behaviour","title":"Configuration options - Pow.Ecto.Schema","doc":"* `:user_id_field` - the field to use for user id. This value defaults to\n  `:email`, and the changeset will automatically validate it as an e-mail.","ref":"Pow.Ecto.Schema.html#module-configuration-options"},{"type":"behaviour","title":"Customize Pow fields - Pow.Ecto.Schema","doc":"Pow fields can be overridden if the field name and type matches:\n\n    defmodule MyApp.Users.User do\n      use Ecto.Schema\n      use Pow.Ecto.Schema\n\n      schema \"users\" do\n        field :encrypted_password, :string\n        field :password_hash, :string, source: :encrypted_password\n\n        pow_user_fields()\n\n        timestamps()\n      end\n    end\n\nThe same holds true for associations:\n\n    defmodule MyApp.Users.User do\n      use Ecto.Schema\n      use Pow.Ecto.Schema\n\n      @pow_assocs {:belongs_to, :invited_by, __MODULE__, []}\n      @pow_assocs {:has_many, :invited, __MODULE__, []}\n\n      schema \"users\" do\n        belongs_to :invited_by, __MODULE__, foreign_key: :user_id\n\n        pow_user_fields()\n\n        timestamps()\n      end\n    end\n\nAn `@after_compile` callback will emit IO warning if there are missing fields\nor associations. You can forego the `pow_user_fields/0` call, and write out\nthe whole schema instead:\n\n    defmodule MyApp.Users.User do\n      use Ecto.Schema\n      use Pow.Ecto.Schema, user_id_field: :email\n\n      schema \"users\" do\n        field :email,            :string\n        field :password_hash,    :string\n        field :current_password, :string, virtual: true\n        field :password,         :string, virtual: true\n        field :confirm_password, :string, virtual: true\n\n        timestamps()\n      end\n    end\n\nIf you would like these warnings to be raised during compilation you can add\n`elixirc_options: [warnings_as_errors: true]` to the project options in\n`mix.exs`.\n\nThe warning is also emitted if the field has an invalid primitive Ecto type.\nIt'll not be emitted for custom Ecto types.","ref":"Pow.Ecto.Schema.html#module-customize-pow-fields"},{"type":"behaviour","title":"Customize Pow changeset - Pow.Ecto.Schema","doc":"You can extract individual changeset functions to modify the changeset flow\nentirely. As an example, this is how you can remove the validation check for\nconfirm password in the changeset function:\n\n    defmodule MyApp.Users.User do\n      use Ecto.Schema\n      use Pow.Ecto.Schema\n\n      import Pow.Ecto.Schema.Changeset, only: [new_password_changeset: 3]\n\n      # ...\n\n      def changeset(user_or_changeset, attrs) do\n        user_or_changeset\n        |> pow_user_id_field_changeset(attrs)\n        |> pow_current_password_changeset(attrs)\n        |> new_password_changeset(attrs, @pow_config)\n      end\n    end\n\nNote that the changeset functions in `Pow.Ecto.Schema.Changeset` require the\nPow ecto module configuration that is passed to the\n`use Pow.Ecto.Schema, ...` call. This can be fetched by using the\n`@pow_config` module attribute.","ref":"Pow.Ecto.Schema.html#module-customize-pow-changeset"},{"type":"callback","title":"Pow.Ecto.Schema.changeset/2","doc":"","ref":"Pow.Ecto.Schema.html#c:changeset/2"},{"type":"function","title":"Pow.Ecto.Schema.filter_new_fields/2","doc":"","ref":"Pow.Ecto.Schema.html#filter_new_fields/2"},{"type":"function","title":"Pow.Ecto.Schema.normalize_user_id_field_value/1","doc":"Normalizes the user id field.\n\nKeeps the user id field value case insensitive and removes leading and\ntrailing whitespace.","ref":"Pow.Ecto.Schema.html#normalize_user_id_field_value/1"},{"type":"macro","title":"Pow.Ecto.Schema.pow_user_fields/0","doc":"A macro to add fields from the `@pow_fields` module attribute generated in\n`__using__/1`.\n\nThe `@pow_fields` are populated by `Pow.Ecto.Schema.Fields.attrs/1`, and will\nhave at minimum the following fields:\n\n  * `:email` (if not changed with `:user_id_field` option)\n  * `:password_hash`\n  * `:current_password` (virtual)\n  * `:password` (virtual)","ref":"Pow.Ecto.Schema.html#pow_user_fields/0"},{"type":"function","title":"Pow.Ecto.Schema.user_id_field/1","doc":"Get user id field key from changeset or configuration.\n\nDefaults to `:email`.","ref":"Pow.Ecto.Schema.html#user_id_field/1"},{"type":"callback","title":"Pow.Ecto.Schema.verify_password/2","doc":"","ref":"Pow.Ecto.Schema.html#c:verify_password/2"},{"type":"module","title":"Pow.Ecto.Schema.Changeset","doc":"Handles changesets functions for Pow schema.\n\nThese functions should never be called directly, but instead the functions\nbuild in macros in `Pow.Ecto.Schema` should be used. This is to ensure\nthat only compile time configuration is used.\n\n`Pow.Ecto.Schema.Password` is by default used to hash and verify passwords.","ref":"Pow.Ecto.Schema.Changeset.html"},{"type":"module","title":"Configuration options - Pow.Ecto.Schema.Changeset","doc":"* `:password_min_length`   - minimum password length, defaults to 8\n  * `:password_max_length`   - maximum password length, defaults to 4096\n  * `:password_hash_verify`  - the password hash and verify anonymous\n    functions or MFAs, defaults to:\n\n        {&Pow.Ecto.Schema.Password.pbkdf2_hash/1,\n        &Pow.Ecto.Schema.Password.pbkdf2_verify/2}\n\n    It may be anonymous functions of MFAs.\n  * `:email_validator`       - the email validation anonymous function or\n    MFA, defaults to:\n\n\n        &Pow.Ecto.Schema.Changeset.validate_email/1\n\n      The function should either return `:ok`, `:error`, or\n      `{:error, reason}`.","ref":"Pow.Ecto.Schema.Changeset.html#module-configuration-options"},{"type":"function","title":"Pow.Ecto.Schema.Changeset.confirm_password_changeset/3","doc":"Validates the confirm password field.\n\nRequires `password` and `confirm_password` params to be equal. Validation is\nonly performed if a change for `:password` exists and the change is not\n`nil`.","ref":"Pow.Ecto.Schema.Changeset.html#confirm_password_changeset/3"},{"type":"function","title":"Pow.Ecto.Schema.Changeset.current_password_changeset/3","doc":"Validates the current password field.\n\nIt's only required to provide a current password if the `password_hash`\nvalue exists in the data struct.","ref":"Pow.Ecto.Schema.Changeset.html#current_password_changeset/3"},{"type":"function","title":"Pow.Ecto.Schema.Changeset.new_password_changeset/3","doc":"Validates the password field.\n\nA password hash is generated by using `:password_hash_verify` in the\nconfiguration. The password is always required if the password hash is `nil`,\nand it's required to be between `:password_min_length` to\n`:password_max_length` characters long.\n\nThe password hash is only generated if the changeset is valid, but always\nrequired.","ref":"Pow.Ecto.Schema.Changeset.html#new_password_changeset/3"},{"type":"function","title":"Pow.Ecto.Schema.Changeset.password_changeset/3","doc":"Validates the password field.\n\nCalls `confirm_password_changeset/3` and `new_password_changeset/3`.","ref":"Pow.Ecto.Schema.Changeset.html#password_changeset/3"},{"type":"function","title":"Pow.Ecto.Schema.Changeset.user_id_field_changeset/3","doc":"Validates the user id field.\n\nThe user id field is always required. It will be treated as case insensitive,\nand it's required to be unique. If the user id field is `:email`, the value\nwill be validated as an e-mail address too.","ref":"Pow.Ecto.Schema.Changeset.html#user_id_field_changeset/3"},{"type":"function","title":"Pow.Ecto.Schema.Changeset.validate_email/1","doc":"Validates an e-mail.\n\nThis implementation has the following rules:\n\n- Split into local-part and domain at last `@` occurance\n- Local-part should;\n  - be at most 64 octets\n  - separate quoted and unquoted content with a single dot\n  - only have letters, digits, and the following characters outside quoted\n    content:\n```text\n!#$%&'*+-/=?^_`{|}~.\n```\n  - not have any consecutive dots outside quoted content\n- Domain should;\n  - be at most 255 octets\n  - only have letters, digits, hyphen, and dots\n\nUnicode characters are permitted in both local-part and domain.\n\nThe implementation is based on\n[RFC 3696](https://tools.ietf.org/html/rfc3696#section-3).\n\nIP addresses are not allowed as per the RFC 3696 specification: \"The domain\nname can also be replaced by an IP address in square brackets, but that form\nis strongly discouraged except for testing and troubleshooting purposes.\".","ref":"Pow.Ecto.Schema.Changeset.html#validate_email/1"},{"type":"function","title":"Pow.Ecto.Schema.Changeset.verify_password/3","doc":"Verifies a password in a struct.\n\nThe password will be verified by using the `:password_hash_verify` in the\nconfiguration.\n\nTo prevent timing attacks, a blank password will be passed to the hash method\nin the `:password_hash_verify` configuration option if the `:password_hash`\nis `nil`.","ref":"Pow.Ecto.Schema.Changeset.html#verify_password/3"},{"type":"module","title":"Pow.Ecto.Schema.Fields","doc":"Handles the Ecto schema fields for user.","ref":"Pow.Ecto.Schema.Fields.html"},{"type":"function","title":"Pow.Ecto.Schema.Fields.attrs/1","doc":"List of attributes for the ecto schema.","ref":"Pow.Ecto.Schema.Fields.html#attrs/1"},{"type":"function","title":"Pow.Ecto.Schema.Fields.indexes/1","doc":"List of indexes for the ecto schema.","ref":"Pow.Ecto.Schema.Fields.html#indexes/1"},{"type":"module","title":"Pow.Ecto.Schema.Migration","doc":"Generates schema migration content.","ref":"Pow.Ecto.Schema.Migration.html"},{"type":"module","title":"Configuration options - Pow.Ecto.Schema.Migration","doc":"* `:repo` - the ecto repo to use. This value defaults to the derrived\n    context base repo from the `context_base` argument in `gen/2`.\n\n  * `:table` - the ecto table name, defaults to \"users\".\n\n  * `:attrs` - list of attributes, defaults to the results from\n    `Pow.Ecto.Schema.Fields.attrs/1`.\n\n  * `:indexes` - list of indexes, defaults to the results from\n    `Pow.Ecto.Schema.Fields.indexes/1`.","ref":"Pow.Ecto.Schema.Migration.html#module-configuration-options"},{"type":"function","title":"Pow.Ecto.Schema.Migration.gen/1","doc":"Generates migration file content.","ref":"Pow.Ecto.Schema.Migration.html#gen/1"},{"type":"function","title":"Pow.Ecto.Schema.Migration.new/3","doc":"Generates migration schema map.","ref":"Pow.Ecto.Schema.Migration.html#new/3"},{"type":"function","title":"Pow.Ecto.Schema.Migration.schema/7","doc":"Generates a schema map to be used with the schema template.","ref":"Pow.Ecto.Schema.Migration.html#schema/7"},{"type":"module","title":"Pow.Ecto.Schema.Module","doc":"Generates schema module content.","ref":"Pow.Ecto.Schema.Module.html"},{"type":"module","title":"Configuration options - Pow.Ecto.Schema.Module","doc":"* `:binary_id` - if the schema module should use binary id, default nil.\n\n  * `:user_id_field` - the user id field to use in the schema module,\n    defaults nil.","ref":"Pow.Ecto.Schema.Module.html#module-configuration-options"},{"type":"function","title":"Pow.Ecto.Schema.Module.gen/1","doc":"Generates schema module file content.","ref":"Pow.Ecto.Schema.Module.html#gen/1"},{"type":"function","title":"Pow.Ecto.Schema.Module.new/4","doc":"Generates a schema module map.","ref":"Pow.Ecto.Schema.Module.html#new/4"},{"type":"module","title":"Pow.Ecto.Schema.Password","doc":"Simple wrapper for password hash and verification.\n\nThe password hash format is based on [Pbkdf2](https://github.com/riverrun/pbkdf2_elixir)","ref":"Pow.Ecto.Schema.Password.html"},{"type":"module","title":"Configuration - Pow.Ecto.Schema.Password","doc":"This module can be configured by setting the `Pow.Ecto.Schema.Password` key\nfor the `:pow` app:\n\n    config :pow, Pow.Ecto.Schema.Password,\n      iterations: 100_000,\n      length: 64,\n      digest: :sha512,\n      salt_length: 16\n\nFor test environment it's recommended to set the iteration to 1:\n\n    config :pow, Pow.Ecto.Schema.Password, iterations: 1","ref":"Pow.Ecto.Schema.Password.html#module-configuration"},{"type":"function","title":"Pow.Ecto.Schema.Password.pbkdf2_hash/2","doc":"Generates an encoded PBKDF2 hash.\n\nBy default this is a `PBKDF2-SHA512` hash with 100,000 iterations, with a\nrandom salt. The hash, salt, iterations and digest method will be part of\nthe returned binary. The hash and salt are Base64 encoded.","ref":"Pow.Ecto.Schema.Password.html#pbkdf2_hash/2"},{"type":"function","title":"Options - Pow.Ecto.Schema.Password.pbkdf2_hash/2","doc":"* `:iterations`  - defaults to 100_000;\n  * `:length`      - a length in octets for the derived key. Defaults to 64;\n  * `:digest`      - an hmac function to use as the pseudo-random function. Defaults to `:sha512`;\n  * `:salt`        - a salt binary to use. Defaults to a randomly generated binary;\n  * `:salt_length` - a length for the random salt binary. Defaults to 16;","ref":"Pow.Ecto.Schema.Password.html#pbkdf2_hash/2-options"},{"type":"function","title":"Pow.Ecto.Schema.Password.pbkdf2_verify/3","doc":"Verifies that the secret matches the encoded binary.\n\nA PBKDF2 hash will be generated from the secret with the same options as\nfound in the encoded binary. The hash, salt, iterations and digest method\nis parsed from the encoded binary. The hash and salt decoded as Base64\nencoded binaries.","ref":"Pow.Ecto.Schema.Password.html#pbkdf2_verify/3"},{"type":"function","title":"Options - Pow.Ecto.Schema.Password.pbkdf2_verify/3","doc":"* `:length` - a length in octets for the derived key. Defaults to 64;","ref":"Pow.Ecto.Schema.Password.html#pbkdf2_verify/3-options"},{"type":"module","title":"Pow.Ecto.Schema.Password.Pbkdf2","doc":"The Pbkdf2 hash generation code is pulled from\n[Plug.Crypto.KeyGenerator](https://github.com/elixir-plug/plug_crypto/blob/v1.2.1/lib/plug/crypto/key_generator.ex)\nand is under Apache 2 license.","ref":"Pow.Ecto.Schema.Password.Pbkdf2.html"},{"type":"function","title":"Pow.Ecto.Schema.Password.Pbkdf2.compare/2","doc":"Compares the two binaries in constant-time to avoid timing attacks.","ref":"Pow.Ecto.Schema.Password.Pbkdf2.html#compare/2"},{"type":"function","title":"Pow.Ecto.Schema.Password.Pbkdf2.generate/5","doc":"Returns a derived key suitable for use.","ref":"Pow.Ecto.Schema.Password.Pbkdf2.html#generate/5"},{"type":"module","title":"Pow.Phoenix.Controller","doc":"Used with Pow Phoenix controllers to handle messages, routes and callbacks.","ref":"Pow.Phoenix.Controller.html"},{"type":"module","title":"Usage - Pow.Phoenix.Controller","doc":"defmodule MyPowExtension.Phoenix.MyController do\n      use Pow.Phoenix.Controller\n\n      def process_new(conn, _params) do\n        {:ok, :response, conn}\n      end\n\n      def respond_new({:ok, :response, conn}) do\n        render(conn, \"new.html\")\n      end\n    end","ref":"Pow.Phoenix.Controller.html#module-usage"},{"type":"module","title":"Configuration options - Pow.Phoenix.Controller","doc":"* `:messages_backend` - See `Pow.Phoenix.Messages` for more.\n\n  * `:routes_backend` - See `Pow.Phoenix.Routes` for more.\n\n  * `:controller_callbacks` - See\n    `Pow.Extension.Phoenix.ControllerCallbacks` for more.","ref":"Pow.Phoenix.Controller.html#module-configuration-options"},{"type":"function","title":"Pow.Phoenix.Controller.action/3","doc":"Handles the controller action call.\n\nIf a `:controller_callbacks` module has been set in the configuration,\nthen `before_process` and `before_respond` will be called on this module\non all actions.","ref":"Pow.Phoenix.Controller.html#action/3"},{"type":"function","title":"Pow.Phoenix.Controller.messages/2","doc":"Fetches messages backend from configuration, or use fallback.","ref":"Pow.Phoenix.Controller.html#messages/2"},{"type":"function","title":"Pow.Phoenix.Controller.put_no_cache_header/2","doc":"Ensures that the page can't be cached in browser.\n\nThis will add a \"cache-control\" header with\n\"no-cache, no-store, must-revalidate\" if the cache control header hasn't\nbeen changed from the default value in the `Plug.Conn` struct.","ref":"Pow.Phoenix.Controller.html#put_no_cache_header/2"},{"type":"function","title":"Pow.Phoenix.Controller.require_authenticated/2","doc":"Ensures that user has been authenticated.\n\n`Pow.Phoenix.PlugErrorHandler` is used as error handler. See\n`Pow.Plug.RequireAuthenticated` for more.","ref":"Pow.Phoenix.Controller.html#require_authenticated/2"},{"type":"function","title":"Pow.Phoenix.Controller.require_not_authenticated/2","doc":"Ensures that user hasn't been authenticated.\n\n`Pow.Phoenix.PlugErrorHandler` is used as error handler. See\n`Pow.Plug.RequireNotAuthenticated` for more.","ref":"Pow.Phoenix.Controller.html#require_not_authenticated/2"},{"type":"function","title":"Pow.Phoenix.Controller.route_helper/1","doc":"","ref":"Pow.Phoenix.Controller.html#route_helper/1"},{"type":"function","title":"Pow.Phoenix.Controller.routes/2","doc":"Fetches routes backend from configuration, or use fallback.","ref":"Pow.Phoenix.Controller.html#routes/2"},{"type":"behaviour","title":"Pow.Phoenix.Mailer","doc":"This module provides an API for mails to be sent by Pow.\n\nPow mails is build with `Pow.Phoenix.Mailer.Mail` structs, and consists of\n`:subject`, `:text`, `:html` and `:user` keys.","ref":"Pow.Phoenix.Mailer.html"},{"type":"behaviour","title":"Usage - Pow.Phoenix.Mailer","doc":"defmodule MyAppWeb.Pow.Mailer do\n      use Pow.Phoenix.Mailer\n      require Logger\n\n      @impl true\n      def cast(%{user: user, subject: subject, text: text, html: html, assigns: _assigns}) do\n        # Build email struct to be used in `process/1`\n\n        %{to: user.email, subject: subject, text: text, html: html}\n      end\n\n      @impl true\n      def process(email) do\n        # Send email\n\n        Logger.debug(\"E-mail sent: #{inspect email}\")\n      end\n    end\n\nRemember to update configuration with `mailer_backend: MyAppWeb.Pow.Mailer`","ref":"Pow.Phoenix.Mailer.html#module-usage"},{"type":"callback","title":"Pow.Phoenix.Mailer.cast/1","doc":"","ref":"Pow.Phoenix.Mailer.html#c:cast/1"},{"type":"function","title":"Pow.Phoenix.Mailer.deliver/2","doc":"","ref":"Pow.Phoenix.Mailer.html#deliver/2"},{"type":"callback","title":"Pow.Phoenix.Mailer.process/1","doc":"","ref":"Pow.Phoenix.Mailer.html#c:process/1"},{"type":"module","title":"Pow.Phoenix.Mailer.Component","doc":"Compnent macros for `Pow.Phoenix.Mailer`.","ref":"Pow.Phoenix.Mailer.Component.html"},{"type":"module","title":"Usage - Pow.Phoenix.Mailer.Component","doc":"defmodule MyAppWeb.Web do\n      @moduledoc false\n      use Pow.Phoenix.Mailer.Component\n\n      @html ~H\"\"\"\n       Hi, <% @user %>, this is  HTML ! \n      \"\"\"\n\n      @text ~P\"\"\"\n      Hi, <%= @user %>, this is plain text!\n      \"\"\"\n    end","ref":"Pow.Phoenix.Mailer.Component.html#module-usage"},{"type":"macro","title":"Pow.Phoenix.Mailer.Component.sigil_H/2","doc":"","ref":"Pow.Phoenix.Mailer.Component.html#sigil_H/2"},{"type":"macro","title":"Pow.Phoenix.Mailer.Component.sigil_P/2","doc":"","ref":"Pow.Phoenix.Mailer.Component.html#sigil_P/2"},{"type":"module","title":"Pow.Phoenix.Mailer.Mail","doc":"Module that renders html and text version of e-mails.","ref":"Pow.Phoenix.Mailer.Mail.html"},{"type":"module","title":"Custom layout - Pow.Phoenix.Mailer.Mail","doc":"By default no layout is used to render the templates. You can set\n`:pow_mailer_layout` in `conn.private` the same way as you set\n`:phoenix_layout` to render a layout for the template.\n\nThis is how you can set the mailer layout:\n\n    defmodule MyAppWeb.Router do\n      # ...\n\n      pipeline :pow_email_layouts do\n        plug :put_pow_mailer_layouts, html: {MyAppWeb.Layouts, :email}, text: {MyAppWeb.Layouts, :email_text}\n      end\n\n      # ...\n\n      scope \"/\" do\n        pipe_through [:browser, :pow_email_layouts]\n\n        pow_routes()\n      end\n\n      # ...\n\n      defp put_pow_mailer_layouts(conn, layout), do: put_private(conn, :put_pow_mailer_layouts, layouts)\n    end\n\nIf a specific format is specified, such as `html: {MyAppWeb.Layouts, :email}`\nthen only the html format will use layout, while text will not.","ref":"Pow.Phoenix.Mailer.Mail.html#module-custom-layout"},{"type":"function","title":"Pow.Phoenix.Mailer.Mail.new/4","doc":"Returns a populated `%Pow.Phoenix.Mailer.Mail{}` map.\n\nIf the configuration has `:web_mailer_module`, it will be used to find the\ntemplate module to call.","ref":"Pow.Phoenix.Mailer.Mail.html#new/4"},{"type":"function","title":"Pow.Phoenix.Mailer.Mail.put_layout/3","doc":"","ref":"Pow.Phoenix.Mailer.Mail.html#put_layout/3"},{"type":"type","title":"Pow.Phoenix.Mailer.Mail.t/0","doc":"","ref":"Pow.Phoenix.Mailer.Mail.html#t:t/0"},{"type":"module","title":"Pow.Phoenix.Mailer.Template","doc":"Module that builds mailer templates for Phoenix templates using EEx with\n`Phoenix.HTML.Engine`.","ref":"Pow.Phoenix.Mailer.Template.html"},{"type":"module","title":"Usage - Pow.Phoenix.Mailer.Template","doc":"defmodule PowExtension.Phoenix.Mailer.MailTemplate do\n      use Pow.Phoenix.Mailer.Template\n\n      template :mail, \"Subject line\", \"Text content\", \" HTML content \"\n    end","ref":"Pow.Phoenix.Mailer.Template.html#module-usage"},{"type":"macro","title":"Pow.Phoenix.Mailer.Template.template/4","doc":"Generate template functions.\n\nThis macro that will compile a mailer template from the provided binaries,\nand add the compiled versions to `render/2` functions. The `text/1` and\n`html/1` outputs the binaries. A `subject/1` function will be added too.","ref":"Pow.Phoenix.Mailer.Template.html#template/4"},{"type":"behaviour","title":"Pow.Phoenix.Messages","doc":"Module that handles messages.","ref":"Pow.Phoenix.Messages.html"},{"type":"behaviour","title":"Usage - Pow.Phoenix.Messages","doc":"defmodule MyAppWeb.Pow.Messages do\n      use Pow.Phoenix.Messages\n      import MyAppWeb.Gettext\n\n      def signed_out(_conn), do: gettext(\"Signed out successfullly.\")\n    end\n\nRemember to add `messages_backend: MyAppWeb.Pow.Messages` to your\nconfiguration.","ref":"Pow.Phoenix.Messages.html#module-usage"},{"type":"function","title":"Pow.Phoenix.Messages.invalid_credentials/1","doc":"Message for when user couldn't be signed in.","ref":"Pow.Phoenix.Messages.html#invalid_credentials/1"},{"type":"callback","title":"Pow.Phoenix.Messages.invalid_credentials/1","doc":"","ref":"Pow.Phoenix.Messages.html#c:invalid_credentials/1"},{"type":"function","title":"Pow.Phoenix.Messages.signed_in/1","doc":"Message for when user has signed in.\n\nDefaults to nil.","ref":"Pow.Phoenix.Messages.html#signed_in/1"},{"type":"callback","title":"Pow.Phoenix.Messages.signed_in/1","doc":"","ref":"Pow.Phoenix.Messages.html#c:signed_in/1"},{"type":"function","title":"Pow.Phoenix.Messages.signed_out/1","doc":"Message for when user has signed out.\n\nDefaults to nil.","ref":"Pow.Phoenix.Messages.html#signed_out/1"},{"type":"callback","title":"Pow.Phoenix.Messages.signed_out/1","doc":"","ref":"Pow.Phoenix.Messages.html#c:signed_out/1"},{"type":"function","title":"Pow.Phoenix.Messages.user_already_authenticated/1","doc":"Message for when user is already authenticated.\n\nDefaults to nil.","ref":"Pow.Phoenix.Messages.html#user_already_authenticated/1"},{"type":"callback","title":"Pow.Phoenix.Messages.user_already_authenticated/1","doc":"","ref":"Pow.Phoenix.Messages.html#c:user_already_authenticated/1"},{"type":"function","title":"Pow.Phoenix.Messages.user_could_not_be_deleted/1","doc":"Message for when account could not be deleted.","ref":"Pow.Phoenix.Messages.html#user_could_not_be_deleted/1"},{"type":"callback","title":"Pow.Phoenix.Messages.user_could_not_be_deleted/1","doc":"","ref":"Pow.Phoenix.Messages.html#c:user_could_not_be_deleted/1"},{"type":"function","title":"Pow.Phoenix.Messages.user_has_been_created/1","doc":"Message for when user has signed up successfully.\n\nDefaults to nil.","ref":"Pow.Phoenix.Messages.html#user_has_been_created/1"},{"type":"callback","title":"Pow.Phoenix.Messages.user_has_been_created/1","doc":"","ref":"Pow.Phoenix.Messages.html#c:user_has_been_created/1"},{"type":"function","title":"Pow.Phoenix.Messages.user_has_been_deleted/1","doc":"Message for when user has deleted their account successfully.","ref":"Pow.Phoenix.Messages.html#user_has_been_deleted/1"},{"type":"callback","title":"Pow.Phoenix.Messages.user_has_been_deleted/1","doc":"","ref":"Pow.Phoenix.Messages.html#c:user_has_been_deleted/1"},{"type":"function","title":"Pow.Phoenix.Messages.user_has_been_updated/1","doc":"Message for when user has updated their account successfully.","ref":"Pow.Phoenix.Messages.html#user_has_been_updated/1"},{"type":"callback","title":"Pow.Phoenix.Messages.user_has_been_updated/1","doc":"","ref":"Pow.Phoenix.Messages.html#c:user_has_been_updated/1"},{"type":"function","title":"Pow.Phoenix.Messages.user_not_authenticated/1","doc":"Message for when user is not authenticated.\n\nDefaults to nil.","ref":"Pow.Phoenix.Messages.html#user_not_authenticated/1"},{"type":"callback","title":"Pow.Phoenix.Messages.user_not_authenticated/1","doc":"","ref":"Pow.Phoenix.Messages.html#c:user_not_authenticated/1"},{"type":"type","title":"Pow.Phoenix.Messages.message/0","doc":"","ref":"Pow.Phoenix.Messages.html#t:message/0"},{"type":"module","title":"Pow.Phoenix.PlugErrorHandler","doc":"Used with `Pow.Plug.RequireAuthenticated` and\n`Pow.Plug.RequireNotAuthenticated`.","ref":"Pow.Phoenix.PlugErrorHandler.html"},{"type":"function","title":"Pow.Phoenix.PlugErrorHandler.call/2","doc":"Redirect user and add error flash message.\n\nFor `:not_authenticated` calls, the flash message defaults to\n`Pow.Phoenix.Messages.user_not_authenticated/1` and the user is redirected to\n`Pow.Phoenix.Routes.user_not_authenticated_path/1`.\n\nFor `:already_authenticated` calls, the flash message defaults to\n`Pow.Phoenix.Messages.user_already_authenticated/1` and the user is redirected to\n`Pow.Phoenix.Routes.user_already_authenticated_path/1`.","ref":"Pow.Phoenix.PlugErrorHandler.html#call/2"},{"type":"module","title":"Pow.Phoenix.Router","doc":"Handles Phoenix routing for Pow.\n\nResources are build with `pow_resources/3` and individual routes are build\nwith `pow_route/5`. The Pow routes will be filtered if a route has already\nbeen defined with the same action, router helper alias, and number of\nbindings. This makes it easy to override pow routes with no conflicts.\n\nThe scope will be validated to ensure that there is no aliases. An exception\nwill be raised if an alias was defined in any scope around the pow routes.","ref":"Pow.Phoenix.Router.html"},{"type":"module","title":"Usage - Pow.Phoenix.Router","doc":"Configure `lib/my_project_web/router.ex` the following way:\n\n    defmodule MyAppWeb.Router do\n      use MyAppWeb, :router\n      use Pow.Phoenix.Router\n\n      pipeline :browser do\n        plug :accepts, [\"html\"]\n        plug :fetch_session\n        plug :fetch_flash\n        plug :protect_from_forgery\n        plug :put_secure_browser_headers\n      end\n\n      scope \"/\" do\n        pipe_through :browser\n\n        pow_routes()\n      end\n\n      # ...\n    end","ref":"Pow.Phoenix.Router.html#module-usage"},{"type":"module","title":"Disable registration routes - Pow.Phoenix.Router","doc":"`pow_routes/0` will call `pow_session_routes/0` and\n`pow_registration_routes/0`. Registration of new accounts can be disabled\njust by calling `pow_session_routes/0` instead of `pow_routes/0`:\n\n    defmodule MyAppWeb.Router do\n      use MyAppWeb, :router\n      use Pow.Phoenix.Router\n\n      # ...\n\n      # Uncomment to permit update and deletion of user accounts:\n      # scope \"/\", Pow.Phoenix, as: \"pow\" do\n      #   pipe_through :browser\n      #\n      #   resources \"/registration\", RegistrationController, singleton: true, only: [:edit, :update, :delete]\n      # end\n\n      scope \"/\" do\n        pipe_through :browser\n\n        pow_session_routes()\n      end\n\n      # ...\n    end","ref":"Pow.Phoenix.Router.html#module-disable-registration-routes"},{"type":"module","title":"Customize Pow routes - Pow.Phoenix.Router","doc":"Pow routes can be overridden by defining them before the `pow_routes/0` call.\nAs an example, this can be used to change path:\n\n    defmodule MyAppWeb.Router do\n      use MyAppWeb, :router\n      use Pow.Phoenix.Router\n\n      # ...\n\n      scope \"/\", Pow.Phoenix, as: \"pow\" do\n        pipe_through :browser\n\n        get \"/sign_up\", RegistrationController, :new\n        post \"/sign_up\", RegistrationController, :create\n\n        get \"/login\", SessionController, :new\n        post \"/login\", SessionController, :create\n      end\n\n      scope \"/\" do\n        pipe_through :browser\n\n        pow_routes()\n      end\n\n      # ...\n    end","ref":"Pow.Phoenix.Router.html#module-customize-pow-routes"},{"type":"function","title":"Pow.Phoenix.Router.exprs/2","doc":"","ref":"Pow.Phoenix.Router.html#exprs/2"},{"type":"macro","title":"Pow.Phoenix.Router.pow_route/5","doc":"","ref":"Pow.Phoenix.Router.html#pow_route/5"},{"type":"macro","title":"Pow.Phoenix.Router.pow_routes/0","doc":"Pow routes macro.\n\nUse this macro to define the Pow routes. This will call\n`pow_session_routes/0` and `pow_registration_routes/0`.","ref":"Pow.Phoenix.Router.html#pow_routes/0"},{"type":"macro","title":"Example - Pow.Phoenix.Router.pow_routes/0","doc":"scope \"/\" do\n      pow_routes()\n    end","ref":"Pow.Phoenix.Router.html#pow_routes/0-example"},{"type":"function","title":"Pow.Phoenix.Router.validate_scope!/1","doc":"","ref":"Pow.Phoenix.Router.html#validate_scope!/1"},{"type":"behaviour","title":"Pow.Phoenix.Routes","doc":"Module that handles routes.","ref":"Pow.Phoenix.Routes.html"},{"type":"behaviour","title":"Usage - Pow.Phoenix.Routes","doc":"defmodule MyAppWeb.Pow.Routes do\n      use Pow.Phoenix.Routes\n      use MyAppWeb, :verified_routes\n\n      @impl true\n      def after_sign_out_path(conn), do: ~p\"/some-path\"\n    end\n\nUpdate configuration with `routes_backend: MyAppWeb.Pow.Routes`.\n\nYou can also customize path generation:\n\n    defmodule MyAppWeb.Pow.Routes do\n      use Pow.Phoenix.Routes\n      use MyAppWeb, :verified_routes\n\n      @impl true\n      def url_for(conn, verb, vars \\ [], query_params \\ [])\n      def url_for(conn, PowEmailConfirmation.Phoenix.ConfirmationController, :show, [token], _query_params),\n        do: ~p\"/custom-confirmation/#{token}\"\n      def url_for(conn, plug, verb, vars, query_params),\n        do: Pow.Phoenix.Routes.url_for(conn, plug, verb, vars, query_params)\n    end","ref":"Pow.Phoenix.Routes.html#module-usage"},{"type":"callback","title":"Pow.Phoenix.Routes.after_registration_path/1","doc":"","ref":"Pow.Phoenix.Routes.html#c:after_registration_path/1"},{"type":"function","title":"Pow.Phoenix.Routes.after_registration_path/2","doc":"Path to redirect user to when user has signed up.\n\nBy default this is the same as `after_sign_in_path/1`.","ref":"Pow.Phoenix.Routes.html#after_registration_path/2"},{"type":"callback","title":"Pow.Phoenix.Routes.after_sign_in_path/1","doc":"","ref":"Pow.Phoenix.Routes.html#c:after_sign_in_path/1"},{"type":"function","title":"Pow.Phoenix.Routes.after_sign_in_path/2","doc":"Path to redirect user to when user has signed in.\n\nThis will look for a `:request_path` assigns key, and redirect to this value\nif it exists.","ref":"Pow.Phoenix.Routes.html#after_sign_in_path/2"},{"type":"callback","title":"Pow.Phoenix.Routes.after_sign_out_path/1","doc":"","ref":"Pow.Phoenix.Routes.html#c:after_sign_out_path/1"},{"type":"function","title":"Pow.Phoenix.Routes.after_sign_out_path/2","doc":"Path to redirect user to when user has signed out.","ref":"Pow.Phoenix.Routes.html#after_sign_out_path/2"},{"type":"callback","title":"Pow.Phoenix.Routes.after_user_deleted_path/1","doc":"","ref":"Pow.Phoenix.Routes.html#c:after_user_deleted_path/1"},{"type":"function","title":"Pow.Phoenix.Routes.after_user_deleted_path/2","doc":"Path to redirect user to when user has deleted their account.\n\nBy default this is the same as `after_sign_out_path/1`.","ref":"Pow.Phoenix.Routes.html#after_user_deleted_path/2"},{"type":"callback","title":"Pow.Phoenix.Routes.after_user_updated_path/1","doc":"","ref":"Pow.Phoenix.Routes.html#c:after_user_updated_path/1"},{"type":"function","title":"Pow.Phoenix.Routes.after_user_updated_path/2","doc":"Path to redirect user to when user has updated their account.","ref":"Pow.Phoenix.Routes.html#after_user_updated_path/2"},{"type":"function","title":"Pow.Phoenix.Routes.path_for/5","doc":"Generates a path route.","ref":"Pow.Phoenix.Routes.html#path_for/5"},{"type":"callback","title":"Pow.Phoenix.Routes.path_for/5","doc":"","ref":"Pow.Phoenix.Routes.html#c:path_for/5"},{"type":"callback","title":"Pow.Phoenix.Routes.registration_path/2","doc":"","ref":"Pow.Phoenix.Routes.html#c:registration_path/2"},{"type":"callback","title":"Pow.Phoenix.Routes.session_path/3","doc":"","ref":"Pow.Phoenix.Routes.html#c:session_path/3"},{"type":"function","title":"Pow.Phoenix.Routes.url_for/5","doc":"Generates a url route.","ref":"Pow.Phoenix.Routes.html#url_for/5"},{"type":"callback","title":"Pow.Phoenix.Routes.url_for/5","doc":"","ref":"Pow.Phoenix.Routes.html#c:url_for/5"},{"type":"callback","title":"Pow.Phoenix.Routes.user_already_authenticated_path/1","doc":"","ref":"Pow.Phoenix.Routes.html#c:user_already_authenticated_path/1"},{"type":"function","title":"Pow.Phoenix.Routes.user_already_authenticated_path/2","doc":"Path to redirect user to when user has already been authenticated.\n\nBy default this is the same as `after_sign_in_path/1`.","ref":"Pow.Phoenix.Routes.html#user_already_authenticated_path/2"},{"type":"callback","title":"Pow.Phoenix.Routes.user_not_authenticated_path/1","doc":"","ref":"Pow.Phoenix.Routes.html#c:user_not_authenticated_path/1"},{"type":"function","title":"Pow.Phoenix.Routes.user_not_authenticated_path/2","doc":"Path to redirect user to when user is not authenticated.\n\nThis will put a `:request_path` param into the path that can be used to\nredirect users back the the page they first attempted to visit. See\n`after_sign_in_path/1` for how `:request_path` is handled.\n\nThe `:request_path` will only be added if the request uses \"GET\" method.\n\nSee `Pow.Phoenix.SessionController` for more on how this value is handled.","ref":"Pow.Phoenix.Routes.html#user_not_authenticated_path/2"},{"type":"module","title":"Pow.Phoenix.SessionController","doc":"Controller actions for session.\n\nThe `:request_path` param will automatically be assigned in `:new` and\n`:create` actions, and used for the `pow_session_path(conn, :create)` path.","ref":"Pow.Phoenix.SessionController.html"},{"type":"function","title":"Pow.Phoenix.SessionController.messages/1","doc":"","ref":"Pow.Phoenix.SessionController.html#messages/1"},{"type":"function","title":"Pow.Phoenix.SessionController.routes/1","doc":"","ref":"Pow.Phoenix.SessionController.html#routes/1"},{"type":"module","title":"Pow.Phoenix.Template","doc":"Module that can builds templates for Phoenix using EEx with\n`Phoenix.HTML.Engine`.","ref":"Pow.Phoenix.Template.html"},{"type":"module","title":"Example - Pow.Phoenix.Template","doc":"defmodule MyApp.ResourceTemplate do\n      use Pow.Phoenix.Template\n\n      template :new, :html, \"<%= content_tag(:span, \"Template\") %>\"\n    end\n\n    MyApp.ResourceTemplate.new(assigns)","ref":"Pow.Phoenix.Template.html#module-example"},{"type":"macro","title":"Pow.Phoenix.Template.template/3","doc":"Generates HTML template functions.\n\nThis macro that will compile a phoenix template from the provided binary, and\nadd the compiled version to a `:action/2` function. The `html/1` function\noutputs the binary.","ref":"Pow.Phoenix.Template.html#template/3"},{"type":"module","title":"Pow.Phoenix.ViewHelpers","doc":"Module that renders templates.\n\nBy default, the controller templates in this library will be used, and the\nlayout templates will be based on the module namespace of the Endpoint\nmodule.\n\nBy setting the `:web_module` key in config, the controller and layout\ntemplates can be used from this context app.\n\nSo if you set up your endpoint like this:\n\n    defmodule MyAppWeb.Endpoint do\n      plug Pow.Plug.Session\n    end\n\nOnly `MyAppWeb.Layouts` will be used from your app. However, if you set up\nthe endpoint with a `:web_module` key:\n\n    defmodule MyAppWeb.Endpoint do\n      plug Pow.Plug.Session, web_module: MyAppWeb\n    end\n\nThe following modules will be used from your app:\n\n  * `MyAppWeb.Layouts`\n  * `MyAppWeb.Pow.RegistrationHTML`\n  * `MyAppWeb.Pow.SessionHTML`\n\nAnd also the following templates has to exist in\n`lib/my_project_web/controllers/pow`:\n\n  * `registration_html/new.html.heex`\n  * `registration_html/edit.html.heex`\n  * `session_html/new.html.heex`","ref":"Pow.Phoenix.ViewHelpers.html"},{"type":"function","title":"Pow.Phoenix.ViewHelpers.build_view_module/2","doc":"Generates the template module atom.\n\nIf no `web_module` is provided, the Pow template module is returned.\n\nWhen `web_module` is provided, the template module will be changed from\n`Pow.Phoenix.RegistrationHTML` to `CustomWeb.Pow.RegistrationHTML`","ref":"Pow.Phoenix.ViewHelpers.html#build_view_module/2"},{"type":"function","title":"Pow.Phoenix.ViewHelpers.layout/1","doc":"Updates the layout module in the connection.\n\nThe layout template is always updated. If `:web_module` is not provided,\nit'll be computed from the Endpoint module, and the default Pow template\nmodule is returned.\n\nWhen `:web_module` is provided, both the template module and the layout\ntemplate module will be computed. See `build_view_module/2` for more.","ref":"Pow.Phoenix.ViewHelpers.html#layout/1"},{"type":"module","title":"Pow.Extension.Ecto.Schema","doc":"Handles extensions for the user Ecto schema.\n\nThe macro will append fields to the `@pow_fields` module attribute using the\nattributes from `[Pow Extension].Ecto.Schema.attrs/1`, so they can be used in\nthe `Pow.Ecto.Schema.pow_user_fields/0` function call.\n\nAfter module compilation `[Pow Extension].Ecto.Schema.validate!/2` will run.","ref":"Pow.Extension.Ecto.Schema.html"},{"type":"module","title":"Usage - Pow.Extension.Ecto.Schema","doc":"Configure `lib/my_project/users/user.ex` the following way:\n\n    defmodule MyApp.Users.User do\n      use Ecto.Schema\n      use Pow.Ecto.Schema\n      use Pow.Extension.Ecto.Schema,\n        extensions: [PowExtensionOne, PowExtensionTwo]\n\n      schema \"users\" do\n        pow_user_fields()\n\n        timestamps()\n      end\n\n      def changeset(user_or_changeset, attrs) do\n        user\n        |> pow_changeset(attrs)\n        |> pow_extension_changeset(attrs)\n      end\n    end","ref":"Pow.Extension.Ecto.Schema.html#module-usage"},{"type":"function","title":"Pow.Extension.Ecto.Schema.assocs/1","doc":"Merge all extension associations together to one list.\n\nThe extension ecto schema modules is discovered through the `:extensions` key\nin the configuration, and the attribute list will be in the same order as the\nextensions list.","ref":"Pow.Extension.Ecto.Schema.html#assocs/1"},{"type":"function","title":"Pow.Extension.Ecto.Schema.attrs/1","doc":"Merge all extension attributes together to one list.\n\nThe extension ecto schema modules is discovered through the `:extensions` key\nin the configuration, and the attribute list will be in the same order as the\nextensions list.","ref":"Pow.Extension.Ecto.Schema.html#attrs/1"},{"type":"function","title":"Pow.Extension.Ecto.Schema.changeset/3","doc":"This will run `changeset/3` on all extension ecto schema modules.\n\nThe extension ecto schema modules is discovered through the `:extensions` key\nin the configuration, and the changesets will be piped in the same order\nas the extensions list.","ref":"Pow.Extension.Ecto.Schema.html#changeset/3"},{"type":"function","title":"Pow.Extension.Ecto.Schema.indexes/1","doc":"Merge all extension indexes together to one list.\n\nThe extension ecto schema modules is discovered through the `:extensions` key\nin the configuration, and the index list will be in the same order as the\nextensions list.","ref":"Pow.Extension.Ecto.Schema.html#indexes/1"},{"type":"function","title":"Pow.Extension.Ecto.Schema.require_schema_field!/3","doc":"Validates that the ecto schema has the specified field.\n\nIf the field doesn't exist, it'll raise an exception.","ref":"Pow.Extension.Ecto.Schema.html#require_schema_field!/3"},{"type":"function","title":"Pow.Extension.Ecto.Schema.validate!/2","doc":"This will run `validate!/2` on all extension ecto schema modules.\n\nIt's used to ensure certain fields are available, e.g. an `:email` field. The\nfunction should either raise an exception, or return `:ok`. Compilation will\nfail when the exception is raised.","ref":"Pow.Extension.Ecto.Schema.html#validate!/2"},{"type":"behaviour","title":"Pow.Extension.Ecto.Schema.Base","doc":"Used for extensions to extend user schemas.\n\nThe macro will add fallback functions to the module, that can be overridden.","ref":"Pow.Extension.Ecto.Schema.Base.html"},{"type":"behaviour","title":"Usage - Pow.Extension.Ecto.Schema.Base","doc":"defmodule MyPowExtension.Ecto.Schema do\n      use Pow.Extension.Ecto.Schema.Base\n\n      @impl true\n      def attrs(_config) do\n        [{:custom_field, :string}]\n      end\n\n      @impl true\n      def changeset(changeset, _config) do\n        Ecto.Changeset.validate_required(changeset, [:custom_field])\n      end\n    end","ref":"Pow.Extension.Ecto.Schema.Base.html#module-usage"},{"type":"macrocallback","title":"Pow.Extension.Ecto.Schema.Base.__using__/1","doc":"","ref":"Pow.Extension.Ecto.Schema.Base.html#c:__using__/1"},{"type":"callback","title":"Pow.Extension.Ecto.Schema.Base.assocs/1","doc":"","ref":"Pow.Extension.Ecto.Schema.Base.html#c:assocs/1"},{"type":"callback","title":"Pow.Extension.Ecto.Schema.Base.attrs/1","doc":"","ref":"Pow.Extension.Ecto.Schema.Base.html#c:attrs/1"},{"type":"callback","title":"Pow.Extension.Ecto.Schema.Base.changeset/3","doc":"","ref":"Pow.Extension.Ecto.Schema.Base.html#c:changeset/3"},{"type":"callback","title":"Pow.Extension.Ecto.Schema.Base.indexes/1","doc":"","ref":"Pow.Extension.Ecto.Schema.Base.html#c:indexes/1"},{"type":"callback","title":"Pow.Extension.Ecto.Schema.Base.validate!/2","doc":"","ref":"Pow.Extension.Ecto.Schema.Base.html#c:validate!/2"},{"type":"module","title":"Pow.Extension.Ecto.Schema.Migration","doc":"Generates schema migration content for extensions.","ref":"Pow.Extension.Ecto.Schema.Migration.html"},{"type":"function","title":"Pow.Extension.Ecto.Schema.Migration.gen/1","doc":"Generates migration file content.","ref":"Pow.Extension.Ecto.Schema.Migration.html#gen/1"},{"type":"function","title":"Pow.Extension.Ecto.Schema.Migration.new/4","doc":"Generates migration schema map.","ref":"Pow.Extension.Ecto.Schema.Migration.html#new/4"},{"type":"module","title":"Pow.Extension.Phoenix.Controller.Base","doc":"Used with Pow Extension Phoenix controllers to handle messages and routes.","ref":"Pow.Extension.Phoenix.Controller.Base.html"},{"type":"module","title":"Usage - Pow.Extension.Phoenix.Controller.Base","doc":"defmodule MyPowExtension.Phoenix.CustomController do\n      use Pow.Extension.Phoenix.Controller.Base\n\n      # ...\n    end","ref":"Pow.Extension.Phoenix.Controller.Base.html#module-usage"},{"type":"module","title":"Pow.Extension.Phoenix.ControllerCallbacks","doc":"Module that adds controller callbacks for extensions.\n\nIt'll automatically trigger all extension callbacks.","ref":"Pow.Extension.Phoenix.ControllerCallbacks.html"},{"type":"module","title":"Usage - Pow.Extension.Phoenix.ControllerCallbacks","doc":"use Pow.Plug.Session,\n      controller_callbacks: Pow.Extension.Phoenix.ControllerCallbacks,\n      extensions: [PowExtensionA, PowExtensionB]","ref":"Pow.Extension.Phoenix.ControllerCallbacks.html#module-usage"},{"type":"behaviour","title":"Pow.Extension.Phoenix.ControllerCallbacks.Base","doc":"Used for the Phoenix Controller Callbacks module in extensions.","ref":"Pow.Extension.Phoenix.ControllerCallbacks.Base.html"},{"type":"behaviour","title":"Usage - Pow.Extension.Phoenix.ControllerCallbacks.Base","doc":"defmodule MyPowExtension.Phoenix.ControllerCallbacks do\n      use Pow.Extension.Phoenix.ControllerCallbacks.Base\n\n      @impl true\n      def before_respond(Pow.Phoenix.RegistrationController, :create, {:ok, user, conn}, _config) do\n        {:ok, user, conn}\n      end\n    end","ref":"Pow.Extension.Phoenix.ControllerCallbacks.Base.html#module-usage"},{"type":"callback","title":"Pow.Extension.Phoenix.ControllerCallbacks.Base.before_process/4","doc":"","ref":"Pow.Extension.Phoenix.ControllerCallbacks.Base.html#c:before_process/4"},{"type":"callback","title":"Pow.Extension.Phoenix.ControllerCallbacks.Base.before_respond/4","doc":"","ref":"Pow.Extension.Phoenix.ControllerCallbacks.Base.html#c:before_respond/4"},{"type":"module","title":"Pow.Extension.Phoenix.Messages","doc":"Module that handles messages for extensions.\n\nTo override messages from extensions, the function name has to start with the\nsnake cased extension name. So the `a_message/1` function from\n`PowExtensionOne`, should be written as `pow_extension_one_a_message/1`.","ref":"Pow.Extension.Phoenix.Messages.html"},{"type":"module","title":"Usage - Pow.Extension.Phoenix.Messages","doc":"defmodule MyAppWeb.Pow.Messages do\n      use Pow.Phoenix.Messages\n      use Pow.Extension.Phoenix.Messages,\n        extensions: [PowExtensionOne, PowExtensionTwo]\n\n      import MyAppWeb.Gettext\n\n      def pow_extension_one_a_message(_conn), do: gettext(\"A message.\")\n\n      def pow_extension_two_a_message(_conn), do: gettext(\"A message.\")\n    end\n\nRemember to update configuration with `messages_backend: MyAppWeb.Pow.Messages`.","ref":"Pow.Extension.Phoenix.Messages.html#module-usage"},{"type":"module","title":"Pow.Extension.Phoenix.Router","doc":"Handles extensions for the phonix router.","ref":"Pow.Extension.Phoenix.Router.html"},{"type":"module","title":"Usage - Pow.Extension.Phoenix.Router","doc":"Configure `lib/my_project_web/router.ex` the following way:\n\n    defmodule MyAppWeb.Router do\n      use MyAppWeb, :router\n      use Pow.Phoenix.Router\n      use Pow.Extension.Phoenix.Router,\n        extensions: [PowExtensionOne, PowExtensionTwo]\n\n      pipeline :browser do\n        plug :accepts, [\"html\"]\n        plug :fetch_session\n        plug :fetch_flash\n        plug :protect_from_forgery\n        plug :put_secure_browser_headers\n      end\n\n      scope \"/\" do\n        pipe_through :browser\n\n        pow_routes()\n        pow_extension_routes()\n      end\n    end","ref":"Pow.Extension.Phoenix.Router.html#module-usage"},{"type":"module","title":"Customize Pow extension routes - Pow.Extension.Phoenix.Router","doc":"Pow extension routes can be overridden by defining them before the\n`pow_extension_routes/0` call. As an example, this can be used to change\npath:\n\n    defmodule MyAppWeb.Router do\n      use MyAppWeb, :router\n      use Pow.Phoenix.Router\n      use Pow.Extension.Phoenix.Router,\n        extensions: [PowExtensionOne, PowExtensionTwo]\n\n      # ...\n\n      scope \"/\", PowExtensionOne.Phoenix, as: \"pow_extension_one\" do\n        pipe_through [:browser]\n\n        resources \"/pow_extension_one\", SomeController, only: [:new, :create]\n      end\n\n      scope \"/\" do\n        pipe_through :browser\n\n        pow_routes()\n        pow_extension_routes()\n      end\n\n      # ...\n    end","ref":"Pow.Extension.Phoenix.Router.html#module-customize-pow-extension-routes"},{"type":"macro","title":"Pow.Extension.Phoenix.Router.pow_extension_routes/0","doc":"A macro that will call the routes function in all extension router modules.","ref":"Pow.Extension.Phoenix.Router.html#pow_extension_routes/0"},{"type":"behaviour","title":"Pow.Extension.Phoenix.Router.Base","doc":"Used for extensions to extend routes.","ref":"Pow.Extension.Phoenix.Router.Base.html"},{"type":"behaviour","title":"Usage - Pow.Extension.Phoenix.Router.Base","doc":"defmodule MyPowExtension.Phoenix.Router do\n      use Pow.Extension.Phoenix.Router.Base\n\n      defmacro routes(_config) do\n        quote location: :keep do\n          resources \"/reset-password\", TestController, only: [:new]\n        end\n      end\n    end\n\nA macro `MyPowExtension.Phoenix.Router.scoped_routes/1` will be created that\nwraps the routes inside a scope with the extension as namespace similar to:\n\n    scope \"/\", MyPowExtension.Phoenix, as: \"my_pow_extension\" do\n      MyPowExtension.Phoenix.Router.routes(config)\n    end","ref":"Pow.Extension.Phoenix.Router.Base.html#module-usage"},{"type":"macrocallback","title":"Pow.Extension.Phoenix.Router.Base.routes/1","doc":"","ref":"Pow.Extension.Phoenix.Router.Base.html#c:routes/1"},{"type":"behaviour","title":"Pow.Store.Backend.Base","doc":"Used to set up API for key-value cache store.\n\n[Erlang match specification](https://erlang.org/doc/apps/erts/match_spec.html)\nformat is used for the second argument `all/2` callback. The second argument\nis only for the key match, and will look like\n`[:namespace_1, :namespace_2, :_]` or `[:namespace_1, :_, :namespace_2]`.","ref":"Pow.Store.Backend.Base.html"},{"type":"behaviour","title":"Usage - Pow.Store.Backend.Base","doc":"This is an example using [Cachex](https://hex.pm/packages/cachex):\n\n    defmodule MyAppWeb.Pow.CachexCache do\n      @behaviour Pow.Store.Backend.Base\n\n      alias Pow.Config\n\n      @cachex_tab __MODULE__\n\n      @impl true\n      def put(config, record_or_records) do\n        records =\n          record_or_records\n          |> List.wrap()\n          |> Enum.map(fn {key, value} ->\n            {wrap_namespace(config, key), value}\n          end)\n\n        {:ok, true} = Cachex.put_many(@cachex_tab, records, ttl: Config.get(config, :ttl))\n\n        :ok\n      end\n\n      @impl true\n      def delete(config, key) do\n        key = wrap_namespace(config, key)\n\n        {:ok, _value} = Cachex.del(@cachex_tab, key)\n\n        :ok\n      end\n\n      @impl true\n      def get(config, key) do\n        key = wrap_namespace(config, key)\n\n        case Cachex.get(@cachex_tab, key) do\n          {:ok, nil}   -> :not_found\n          {:ok, value} -> value\n        end\n      end\n\n      @impl true\n      def all(config, key_match) do\n        query =\n          [{\n            {:_, wrap_namespace(config, key_match), :\"$2\", :\"$3\", :\"$4\"},\n            [Cachex.Query.unexpired_clause()],\n            [ :\"$_\" ]\n          }]\n\n        @cachex_tab\n        |> Cachex.stream!(query)\n        |> Enum.map(fn {_, key, _, _, value} -> {unwrap_namespace(key), value} end)\n      end\n\n      defp wrap_namespace(config, key) do\n        namespace = Config.get(config, :namespace, \"cache\")\n\n        [namespace | List.wrap(key)]\n      end\n\n      defp unwrap_namespace([_namespace, key]), do: key\n      defp unwrap_namespace([_namespace | key]), do: key\n    end","ref":"Pow.Store.Backend.Base.html#module-usage"},{"type":"callback","title":"Pow.Store.Backend.Base.all/2","doc":"","ref":"Pow.Store.Backend.Base.html#c:all/2"},{"type":"callback","title":"Pow.Store.Backend.Base.delete/2","doc":"","ref":"Pow.Store.Backend.Base.html#c:delete/2"},{"type":"callback","title":"Pow.Store.Backend.Base.get/2","doc":"","ref":"Pow.Store.Backend.Base.html#c:get/2"},{"type":"callback","title":"Pow.Store.Backend.Base.put/2","doc":"","ref":"Pow.Store.Backend.Base.html#c:put/2"},{"type":"type","title":"Pow.Store.Backend.Base.config/0","doc":"","ref":"Pow.Store.Backend.Base.html#t:config/0"},{"type":"type","title":"Pow.Store.Backend.Base.key/0","doc":"","ref":"Pow.Store.Backend.Base.html#t:key/0"},{"type":"type","title":"Pow.Store.Backend.Base.key_match/0","doc":"","ref":"Pow.Store.Backend.Base.html#t:key_match/0"},{"type":"type","title":"Pow.Store.Backend.Base.record/0","doc":"","ref":"Pow.Store.Backend.Base.html#t:record/0"},{"type":"module","title":"Pow.Store.Backend.EtsCache","doc":"GenServer based key value ETS cache store with auto expiration.\n\nThis module is not recommended for production, but mostly used as an example\nfor how to build a cache. All data is stored in-memory, so cached values are\nnot shared between machines.","ref":"Pow.Store.Backend.EtsCache.html"},{"type":"module","title":"Configuration options - Pow.Store.Backend.EtsCache","doc":"* `:ttl` - integer value in milliseconds for ttl of records. If this value\n    is not provided, or is set to nil, the records will never expire.\n\n  * `:namespace` - value to use for namespacing keys. Defaults to \"cache\".\n\n  * `:writes` - set to `:async` to do asynchronous writes. Defaults to\n    `:sync`.","ref":"Pow.Store.Backend.EtsCache.html#module-configuration-options"},{"type":"function","title":"Pow.Store.Backend.EtsCache.child_spec/1","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"Pow.Store.Backend.EtsCache.html#child_spec/1"},{"type":"function","title":"Pow.Store.Backend.EtsCache.start_link/1","doc":"","ref":"Pow.Store.Backend.EtsCache.html#start_link/1"},{"type":"module","title":"Pow.Store.Backend.MnesiaCache","doc":"GenServer based key value Mnesia cache store with auto expiration.\n\nWhen the MnesiaCache starts, it will initialize invalidators for all stored\nkeys using the `expire` value. If the `expire` datetime is past, it will\ncall the invalidator immediately.\n\nMnesia will create a `Mnesia.Node` directory in the current working directory\nto write files to. This can be changed by setting the `-mnesia dir` config:\n\n    config :mnesia, dir: '/path/to/dir'\n\nThe directory path should be accessible, otherwise MnesiaCache will crash on\nstartup.\n\n`:mnesia` should be added to `:extra_applications` in `mix.exs` for it to be\nincluded in releases.","ref":"Pow.Store.Backend.MnesiaCache.html"},{"type":"module","title":"Distribution - Pow.Store.Backend.MnesiaCache","doc":"The MnesiaCache is built to handle multi-node setup.\n\nIf you initialize with `extra_db_nodes: Node.list()`, it will automatically\nconnect to the cluster. You can also use MFA:\n`extra_db_nodes: {Node, :list, []}`. This is useful for when nodes are\ndynamically connected before MnesiaCache startup in the supervision tree.\n\nIf there is no other nodes available, the data persisted to disk will be\nloaded, but if a cluster is running, the data in the existing cluster nodes\nwill be loaded instead of the local data. This could potentially cause data\nloss, but is an accepted risk as all data stored by Pow should be ephemeral.\n\nWhen a cache key expires, the expiration will be verified before deletion to\nensure that it hasn't been updated by another node. When a key is updated on\na node, the node will ping all other nodes to refresh their invalidators so\nthe new TTL is used.\n\nAll nodes spun up will by default persist to disk. If you start up multiple\nnodes from the same physical directory you have to make sure that each node\nhas a unique directory path configured. This can be done using different\nconfig files, or by using a system environment variable:\n\n    config :mnesia, dir: to_charlist(System.get_env(\"MNESIA_DIR\"))\n\nYou can use `Pow.Store.Backend.MnesiaCache.Unsplit` to automatically recover\nfrom network split issues. All partitioned nodes will have their table\nflushed and reloaded from the oldest node in the cluster.","ref":"Pow.Store.Backend.MnesiaCache.html#module-distribution"},{"type":"module","title":"Usage - Pow.Store.Backend.MnesiaCache","doc":"To start the GenServer, add it to your application `start/2` function:\n\n    defmodule MyApp.Application do\n      use Application\n\n      def start(_type, _args) do\n        children = [\n          MyApp.Repo,\n          MyAppWeb.Endpoint,\n          Pow.Store.Backend.MnesiaCache\n          # # Or in a distributed system:\n          # {Pow.Store.Backend.MnesiaCache, extra_db_nodes: {Node, :list, []}},\n          # Pow.Store.Backend.MnesiaCache.Unsplit # Recover from netsplit\n        ]\n\n        opts = [strategy: :one_for_one, name: MyAppWeb.Supervisor]\n        Supervisor.start_link(children, opts)\n      end\n\n      # ...\n    end\n\nUpdate configuration with `cache_store_backend: Pow.Store.Backend.MnesiaCache`.","ref":"Pow.Store.Backend.MnesiaCache.html#module-usage"},{"type":"module","title":"Initialization options - Pow.Store.Backend.MnesiaCache","doc":"* `:extra_db_nodes` - list of nodes or MFA returning a list of nodes in\n    cluster to connect to.\n\n  * `:table_opts` - options to add to table definition. This value defaults\n    to `[disc_copies: [node()]]`.\n\n  * `:timeout` - timeout value in milliseconds for how long to wait until the\n    cache table has initiated. Defaults to 15 seconds.","ref":"Pow.Store.Backend.MnesiaCache.html#module-initialization-options"},{"type":"module","title":"Configuration options - Pow.Store.Backend.MnesiaCache","doc":"* `:ttl` - integer value in milliseconds for ttl of records (required).\n\n  * `:namespace` - string value to use for namespacing keys, defaults to\n    \"cache\".\n\n  * `:writes` - set to `:async` to do asynchronous writes. Defaults to\n    `:sync`.","ref":"Pow.Store.Backend.MnesiaCache.html#module-configuration-options"},{"type":"function","title":"Pow.Store.Backend.MnesiaCache.child_spec/1","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"Pow.Store.Backend.MnesiaCache.html#child_spec/1"},{"type":"function","title":"Pow.Store.Backend.MnesiaCache.start_link/1","doc":"","ref":"Pow.Store.Backend.MnesiaCache.html#start_link/1"},{"type":"module","title":"Pow.Store.Backend.MnesiaCache.Unsplit","doc":"GenServer that handles network split recovery for\n`Pow.Store.Backend.MnesiaCache`.\n\nThis should be run on node(s) that has the `Pow.Store.Backend.MnesiaCache`\nGenServer running. It'll subscribe to the Mnesia system messages, and listen\nfor `:inconsistent_database` system events. The first node to set the global\nlock will find the island with the oldest node and restore that nodes table\ninto all the partitioned nodes.\n\nIf a table unrelated to Pow is also affected, an error will be logged and the\nnetwork will stay partitioned. If you don't mind potential data loss for any\nof your tables in Mnesia, you can set `flush_tables: :all` to restore all the\naffected tables from the oldest node in the cluster.\n\nFor better control, you can use\n[`unsplit`](https://github.com/uwiger/unsplit) instead of this module.","ref":"Pow.Store.Backend.MnesiaCache.Unsplit.html"},{"type":"module","title":"Usage - Pow.Store.Backend.MnesiaCache.Unsplit","doc":"To start the GenServer, add it to your application `start/2` function:\n\n    defmodule MyApp.Application do\n      use Application\n\n      def start(_type, _args) do\n        children = [\n          MyApp.Repo,\n          MyAppWeb.Endpoint,\n          {Pow.Store.Backend.MnesiaCache, extra_db_nodes: {Node, :list, []}},\n          Pow.Store.Backend.MnesiaCache.Unsplit\n        ]\n\n        opts = [strategy: :one_for_one, name: MyAppWeb.Supervisor]\n        Supervisor.start_link(children, opts)\n      end\n\n      # ...\n    end","ref":"Pow.Store.Backend.MnesiaCache.Unsplit.html#module-usage"},{"type":"module","title":"Auto initialize cluster - Pow.Store.Backend.MnesiaCache.Unsplit","doc":"If nodes are lazily connected a race condition can occur in which the\n`Pow.Store.Backend.MnesiaCache` is running on each node without being\nconnected in a Mnesia cluster.\n\nTo ensure that cluster will automatically initialize,\n`Pow.Store.Backend.MnesiaCache.Unsplit` will reset the most recent node's\nMnesia schema when connecting to another node or a cluster. This will only\noccur if the Mnesia node has never been connected to the other node(s) and\nthe other node currently runs the Mnesia cache GenServer.\n\nThe `Pow.Store.Backend.MnesiaCache` GenServer will be restarted, using the same\n`:extra_db_nodes` configuration as when it was first initialized. Therefor\nit's important that a MFA is used like `{Node, :list, []}` for the auto\ninitialization to succeed.\n\nPlease be aware the reset of the Mnesia node will result in data loss for the\nnode.","ref":"Pow.Store.Backend.MnesiaCache.Unsplit.html#module-auto-initialize-cluster"},{"type":"module","title":"Strategy for multiple libraries using the Mnesia instance - Pow.Store.Backend.MnesiaCache.Unsplit","doc":"It's strongly recommended to take into account any libraries that will be\nusing Mnesia for storage before using this module.\n\nA common example would be a job queue, where a potential solution to prevent\ndata loss is to simply keep the job queue table on only one server instead of\nreplicating it among all nodes. When a network partition occurs, it won't be\npart of the affected tables so this module can self-heal without the job\nqueue table set in `:flush_tables`.\n\nThere may still be data loss if nodes are lazily connected. Please read the\n\"Auto initialize cluster\" section above.","ref":"Pow.Store.Backend.MnesiaCache.Unsplit.html#module-strategy-for-multiple-libraries-using-the-mnesia-instance"},{"type":"module","title":"Initialization options - Pow.Store.Backend.MnesiaCache.Unsplit","doc":"* `:flush_tables` - list of tables that may be flushed and restored from\n    the oldest node in the cluster. Defaults to `false` when only the\n    MnesiaCache table will be flushed. Use `:all` if you want to flush all\n    affected tables. Be aware that this may cause data loss.\n\n  * `:auto_initialize_cluster` - a boolean value to automatically initialize\n    the Mnesia cluster by resetting the node Mnesia schema when new nodes are\n    connected, defaults to `true`.","ref":"Pow.Store.Backend.MnesiaCache.Unsplit.html#module-initialization-options"},{"type":"function","title":"Pow.Store.Backend.MnesiaCache.Unsplit.child_spec/1","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"Pow.Store.Backend.MnesiaCache.Unsplit.html#child_spec/1"},{"type":"function","title":"Pow.Store.Backend.MnesiaCache.Unsplit.start_link/1","doc":"","ref":"Pow.Store.Backend.MnesiaCache.Unsplit.html#start_link/1"},{"type":"behaviour","title":"Pow.Store.Base","doc":"Used to set up API for key-value stores.","ref":"Pow.Store.Base.html"},{"type":"behaviour","title":"Usage - Pow.Store.Base","doc":"defmodule MyApp.CustomCache do\n      use Pow.Store.Base,\n        ttl: :timer.minutes(30),\n        namespace: \"credentials\"\n\n      @impl true\n      def put(config, key, value) do\n        Pow.Store.Base.put(config, backend_config(config), {key, value})\n      end\n    end","ref":"Pow.Store.Base.html#module-usage"},{"type":"callback","title":"Pow.Store.Base.all/2","doc":"","ref":"Pow.Store.Base.html#c:all/2"},{"type":"callback","title":"Pow.Store.Base.delete/2","doc":"","ref":"Pow.Store.Base.html#c:delete/2"},{"type":"callback","title":"Pow.Store.Base.get/2","doc":"","ref":"Pow.Store.Base.html#c:get/2"},{"type":"function","title":"Pow.Store.Base.put/3","doc":"","ref":"Pow.Store.Base.html#put/3"},{"type":"callback","title":"Pow.Store.Base.put/3","doc":"","ref":"Pow.Store.Base.html#c:put/3"},{"type":"type","title":"Pow.Store.Base.config/0","doc":"","ref":"Pow.Store.Base.html#t:config/0"},{"type":"type","title":"Pow.Store.Base.key/0","doc":"","ref":"Pow.Store.Base.html#t:key/0"},{"type":"type","title":"Pow.Store.Base.key_match/0","doc":"","ref":"Pow.Store.Base.html#t:key_match/0"},{"type":"type","title":"Pow.Store.Base.record/0","doc":"","ref":"Pow.Store.Base.html#t:record/0"},{"type":"behaviour","title":"Pow.Store.CredentialsCache","doc":"Default module for credentials session storage.\n\nA key (session id) is used to store, fetch, or delete credentials. The\ncredentials are expected to take the form of\n`{credentials, session_metadata}`, where session metadata is data exclusive\nto the session id.\n\nThis module also adds two utility functions:\n\n  * `users/2` - to list all current users\n  * `sessions/2` - to list all current sessions\n\nThe `:ttl` should be maximum 30 minutes per\n[OWASP recommendations](https://cheatsheetseries.owasp.org/cheatsheets/Session_Management_Cheat_Sheet.html#session-expiration).\nA warning will be output for any sessions created with a longer TTL.","ref":"Pow.Store.CredentialsCache.html"},{"type":"behaviour","title":"Custom credentials cache module - Pow.Store.CredentialsCache","doc":"Pow may use the utility functions in this module. To ensure all required\nfunctions has been implemented in a custom credentials cache module, the\n`@behaviour` of this module should be used:\n\n    defmodule MyApp.CredentialsStore do\n      use Pow.Store.Base,\n        ttl: :timer.minutes(30),\n        namespace: \"credentials\"\n\n      @behaviour Pow.Store.CredentialsCache\n\n      @impl Pow.Store.CredentialsCache\n      def users(config, struct) do\n        # ...\n      end\n\n      @impl Pow.Store.CredentialsCache\n      def put(config, key, value) do\n        # ...\n      end\n    end","ref":"Pow.Store.CredentialsCache.html#module-custom-credentials-cache-module"},{"type":"behaviour","title":"Configuration options - Pow.Store.CredentialsCache","doc":"* `:reload` - boolean value for whether the user object should be loaded\n    from the context. Defaults false.","ref":"Pow.Store.CredentialsCache.html#module-configuration-options"},{"type":"function","title":"Pow.Store.CredentialsCache.backend_config/1","doc":"","ref":"Pow.Store.CredentialsCache.html#backend_config/1"},{"type":"function","title":"Pow.Store.CredentialsCache.delete/2","doc":"Delete the user credentials data from the backend store.\n\nThis following two key-value will be deleted:\n\n- `{session_id, {[user_struct, :user, user_id], metadata}}`\n- `{[user_struct, :user, user_id, :session, session_id], inserted_at}`\n\nThe `{[user_struct, :user, user_id], user}` key-value is expected to expire\nwhen reaching its TTL.","ref":"Pow.Store.CredentialsCache.html#delete/2"},{"type":"function","title":"Pow.Store.CredentialsCache.get/2","doc":"Fetch user credentials from the backend store from session id.","ref":"Pow.Store.CredentialsCache.html#get/2"},{"type":"function","title":"Pow.Store.CredentialsCache.put/3","doc":"Add user credentials with the session id to the backend store.\n\nThe credentials are expected to be in the format of\n`{credentials, metadata}`.\n\nThis following three key-value will be inserted:\n\n  - `{session_id, {[user_struct, :user, user_id], metadata}}`\n  - `{[user_struct, :user, user_id], user}`\n  - `{[user_struct, :user, user_id, :session, session_id], inserted_at}`\n\nIf metadata has `:fingerprint` any active sessions for the user with the same\n`:fingerprint` in metadata will be deleted.","ref":"Pow.Store.CredentialsCache.html#put/3"},{"type":"callback","title":"Pow.Store.CredentialsCache.put/3","doc":"","ref":"Pow.Store.CredentialsCache.html#c:put/3"},{"type":"function","title":"Pow.Store.CredentialsCache.sessions/2","doc":"List all existing sessions for the user fetched from the backend store.","ref":"Pow.Store.CredentialsCache.html#sessions/2"},{"type":"callback","title":"Pow.Store.CredentialsCache.sessions/2","doc":"","ref":"Pow.Store.CredentialsCache.html#c:sessions/2"},{"type":"function","title":"Pow.Store.CredentialsCache.users/2","doc":"List all user for a certain user struct.\n\nSessions for a user can be looked up with `sessions/3`.","ref":"Pow.Store.CredentialsCache.html#users/2"},{"type":"callback","title":"Pow.Store.CredentialsCache.users/2","doc":"","ref":"Pow.Store.CredentialsCache.html#c:users/2"},{"type":"module","title":"Mix.Pow","doc":"Utilities module for mix tasks.","ref":"Mix.Pow.html"},{"type":"function","title":"Mix.Pow.app_base/1","doc":"Fetches the context base module for the app.","ref":"Mix.Pow.html#app_base/1"},{"type":"function","title":"Mix.Pow.context_lib_path/2","doc":"Fetches the library path for the context app.","ref":"Mix.Pow.html#context_lib_path/2"},{"type":"function","title":"Mix.Pow.ensure_ecto!/2","doc":"Raises an exception if application doesn't have Ecto as dependency.","ref":"Mix.Pow.html#ensure_ecto!/2"},{"type":"function","title":"Mix.Pow.ensure_phoenix!/2","doc":"Raises an exception if application doesn't have Phoenix as dependency.","ref":"Mix.Pow.html#ensure_phoenix!/2"},{"type":"function","title":"Mix.Pow.inject_files/1","doc":"Injects files with inline content","ref":"Mix.Pow.html#inject_files/1"},{"type":"function","title":"Mix.Pow.no_umbrella!/1","doc":"Raises an exception if the project is an umbrella app.","ref":"Mix.Pow.html#no_umbrella!/1"},{"type":"function","title":"Mix.Pow.parse_options/3","doc":"Parses argument options into a map.","ref":"Mix.Pow.html#parse_options/3"},{"type":"function","title":"Mix.Pow.schema_options_from_args/1","doc":"Parses arguments into schema name and schema plural.","ref":"Mix.Pow.html#schema_options_from_args/1"},{"type":"module","title":"Mix.Pow.Ecto.Migration","doc":"Utilities module for ecto migrations in mix tasks.","ref":"Mix.Pow.Ecto.Migration.html"},{"type":"function","title":"Mix.Pow.Ecto.Migration.create_migration_file/3","doc":"Creates a migration file for a repo.","ref":"Mix.Pow.Ecto.Migration.html#create_migration_file/3"},{"type":"module","title":"Mix.Pow.Extension","doc":"Utilities module for mix extension tasks.","ref":"Mix.Pow.Extension.html"},{"type":"function","title":"Mix.Pow.Extension.extensions/2","doc":"","ref":"Mix.Pow.Extension.html#extensions/2"},{"type":"function","title":"Mix.Pow.Extension.no_extensions_error/1","doc":"","ref":"Mix.Pow.Extension.html#no_extensions_error/1"},{"type":"module","title":"Mix.Pow.Phoenix","doc":"Utilities module for mix phoenix tasks.","ref":"Mix.Pow.Phoenix.html"},{"type":"function","title":"Mix.Pow.Phoenix.create_template_module/4","doc":"Creates a HTML template file for the web module.","ref":"Mix.Pow.Phoenix.html#create_template_module/4"},{"type":"function","title":"Mix.Pow.Phoenix.create_templates/4","doc":"Creates templates for the web module.","ref":"Mix.Pow.Phoenix.html#create_templates/4"},{"type":"function","title":"Mix.Pow.Phoenix.parse_structure/1","doc":"Builds a map containing context and web module information.","ref":"Mix.Pow.Phoenix.html#parse_structure/1"},{"type":"module","title":"Mix.Pow.Phoenix.Mailer","doc":"Utilities module for mix phoenix mailer tasks.","ref":"Mix.Pow.Phoenix.Mailer.html"},{"type":"function","title":"Mix.Pow.Phoenix.Mailer.create_mail_module/4","doc":"Creates a mail template file.","ref":"Mix.Pow.Phoenix.Mailer.html#create_mail_module/4"},{"type":"module","title":"PowEmailConfirmation.Ecto.Context","doc":"Handles e-mail confirmation context for user.","ref":"PowEmailConfirmation.Ecto.Context.html"},{"type":"function","title":"PowEmailConfirmation.Ecto.Context.confirm_email/3","doc":"Confirms e-mail.\n\nSee `PowEmailConfirmation.Ecto.Schema.confirm_email_changeset/2`.","ref":"PowEmailConfirmation.Ecto.Context.html#confirm_email/3"},{"type":"function","title":"PowEmailConfirmation.Ecto.Context.current_email_unconfirmed?/2","doc":"Checks if the users current e-mail is unconfirmed.","ref":"PowEmailConfirmation.Ecto.Context.html#current_email_unconfirmed?/2"},{"type":"function","title":"PowEmailConfirmation.Ecto.Context.get_by_confirmation_token/2","doc":"Finds a user by the `email_confirmation_token` column.","ref":"PowEmailConfirmation.Ecto.Context.html#get_by_confirmation_token/2"},{"type":"function","title":"PowEmailConfirmation.Ecto.Context.pending_email_change?/2","doc":"Checks if the user has a pending e-mail change.","ref":"PowEmailConfirmation.Ecto.Context.html#pending_email_change?/2"},{"type":"module","title":"PowEmailConfirmation.Ecto.Schema","doc":"Handles the e-mail confirmation schema for user.","ref":"PowEmailConfirmation.Ecto.Schema.html"},{"type":"module","title":"Customize PowEmailConfirmation fields - PowEmailConfirmation.Ecto.Schema","doc":"If you need to modify any of the fields that `PowEmailConfirmation` adds to\nthe user schema, you can override them by defining them before\n`pow_user_fields/0`:\n\n    defmodule MyApp.Users.User do\n      use Ecto.Schema\n      use Pow.Ecto.Schema\n      use Pow.Extension.Ecto.Schema,\n        extensions: [PowEmailConfirmation]\n\n      schema \"users\" do\n        field :email_confirmation_token, :string\n        field :email_confirmed_at, :utc_datetime\n        field :unconfirmed_email, :string\n\n        pow_user_fields()\n\n        timestamps()\n      end\n    end","ref":"PowEmailConfirmation.Ecto.Schema.html#module-customize-powemailconfirmation-fields"},{"type":"function","title":"PowEmailConfirmation.Ecto.Schema.changeset/3","doc":"Handles e-mail confirmation if e-mail is updated.\n\nThe `:email_confirmation_token` will always be set if the struct isn't\npersisted to the database.\n\nFor structs persisted to the database, no changes will happen if there is no\n`:email` in the params. Likewise, no changes will happen if the `:email`\nchange is the same as the persisted `:unconfirmed_email` value.\n\nIf the `:email` change is the same as the persisted `:email` value then both\n`:email_confirmation_token` and `:unconfirmed_email` will be set to nil.\n\nOtherwise the `:email` change will be copied over to `:unconfirmed_email` and\nthe `:email` change will be reverted back to the original persisted `:email`\nvalue. A unique `:email_confirmation_token` will be generated.","ref":"PowEmailConfirmation.Ecto.Schema.html#changeset/3"},{"type":"function","title":"PowEmailConfirmation.Ecto.Schema.confirm_email_changeset/2","doc":"Sets the e-mail as confirmed.\n\nThis updates `:email_confirmed_at` and sets `:email_confirmation_token` to\nnil.\n\nIf the struct has a `:unconfirmed_email` value, then the `:email` will be\nchanged to this value, and `:unconfirmed_email` will be set to nil.","ref":"PowEmailConfirmation.Ecto.Schema.html#confirm_email_changeset/2"},{"type":"module","title":"PowEmailConfirmation.Phoenix.ControllerCallbacks","doc":"Controller callback logic for e-mail confirmation.\n\n#","ref":"PowEmailConfirmation.Phoenix.ControllerCallbacks.html"},{"type":"module","title":"User hasn't confirmed e-mail - PowEmailConfirmation.Phoenix.ControllerCallbacks","doc":"Triggers on `Pow.Phoenix.RegistrationController.create/2` and\n`Pow.Phoenix.SessionController.create/2`.\n\nWhen a user is created or authenticated, and the current e-mail hasn't been\nconfirmed, a confirmation e-mail is sent, the session will be cleared, an\nerror flash is set for the `conn` and the user redirected back to\n`Pow.Phoenix.Routes.after_registration_path/1` or\n`Pow.Phoenix.Routes.after_sign_in_path/1` respectively.\n\n#","ref":"PowEmailConfirmation.Phoenix.ControllerCallbacks.html#module-user-hasn-t-confirmed-e-mail"},{"type":"module","title":"User updates e-mail - PowEmailConfirmation.Phoenix.ControllerCallbacks","doc":"Triggers on `Pow.Phoenix.RegistrationController.update/2` and\n`PowInvitation.Phoenix.InvitationController.update/2`\n\nWhen a user changes their e-mail, a confirmation e-mail is send to the new\ne-mail, and an error flash is set for the `conn`. The same happens if the\n`PowInvitation` extension is enabled, and a user updates their e-mail when\naccepting their invitation. It's assumed that the current e-mail for the\ninvited user has already been confirmed, see\n`PowInvitation.Ecto.Schema.invite_changeset/3` for more.\n\nSee `PowEmailConfirmation.Ecto.Schema` for more.\n\n#","ref":"PowEmailConfirmation.Phoenix.ControllerCallbacks.html#module-user-updates-e-mail"},{"type":"module","title":"Unique constraint error on `:email` - PowEmailConfirmation.Phoenix.ControllerCallbacks","doc":"Triggers on `Pow.Phoenix.RegistrationController.create/2`.\n\nWhen a user can't be created and the changeset has a unique constraint error\nfor the `:email` field, the user will experience the same success flow as if\nthe user could be created, but no e-mail is sent out. This prevents\nuser enumeration. If `pow_prevent_user_enumeration: false` is set in\n`conn.private` the form with error will be shown instead.","ref":"PowEmailConfirmation.Phoenix.ControllerCallbacks.html#module-unique-constraint-error-on-email"},{"type":"function","title":"PowEmailConfirmation.Phoenix.ControllerCallbacks.messages/1","doc":"","ref":"PowEmailConfirmation.Phoenix.ControllerCallbacks.html#messages/1"},{"type":"function","title":"PowEmailConfirmation.Phoenix.ControllerCallbacks.routes/1","doc":"","ref":"PowEmailConfirmation.Phoenix.ControllerCallbacks.html#routes/1"},{"type":"function","title":"PowEmailConfirmation.Phoenix.ControllerCallbacks.send_confirmation_email/2","doc":"Sends a confirmation e-mail to the user.\n\nThe user struct passed to the mailer will have the `:email` set to the\n`:unconfirmed_email` value if `:unconfirmed_email` is set.","ref":"PowEmailConfirmation.Phoenix.ControllerCallbacks.html#send_confirmation_email/2"},{"type":"module","title":"PowEmailConfirmation.Phoenix.Messages","doc":"Module that handles messages for PowEmailConfirmation.\n\nSee `Pow.Extension.Phoenix.Messages` for more.","ref":"PowEmailConfirmation.Phoenix.Messages.html"},{"type":"function","title":"PowEmailConfirmation.Phoenix.Messages.email_confirmation_failed/1","doc":"Flash message to show when email couldn't be confirmed.","ref":"PowEmailConfirmation.Phoenix.Messages.html#email_confirmation_failed/1"},{"type":"function","title":"PowEmailConfirmation.Phoenix.Messages.email_confirmation_required/1","doc":"Flash message to show when user is signs in or registers but e-mail is yet\nto be confirmed.","ref":"PowEmailConfirmation.Phoenix.Messages.html#email_confirmation_required/1"},{"type":"function","title":"PowEmailConfirmation.Phoenix.Messages.email_confirmation_required_for_update/1","doc":"Flash message to show when user updates their e-mail and requires\nconfirmation.","ref":"PowEmailConfirmation.Phoenix.Messages.html#email_confirmation_required_for_update/1"},{"type":"function","title":"PowEmailConfirmation.Phoenix.Messages.email_has_been_confirmed/1","doc":"Flash message to show when email has been confirmed.","ref":"PowEmailConfirmation.Phoenix.Messages.html#email_has_been_confirmed/1"},{"type":"function","title":"PowEmailConfirmation.Phoenix.Messages.invalid_token/1","doc":"Flash message to show when a invalid confirmation link is used.","ref":"PowEmailConfirmation.Phoenix.Messages.html#invalid_token/1"},{"type":"module","title":"PowEmailConfirmation.Plug","doc":"Plug helper functions.","ref":"PowEmailConfirmation.Plug.html"},{"type":"function","title":"PowEmailConfirmation.Plug.confirm_email/2","doc":"Confirms the e-mail for the user.\n\nExpects user to exist in `conn.assigns` for key `:confirm_email_user`.\n\nIf successful, and a session exists, the session will be regenerated.","ref":"PowEmailConfirmation.Plug.html#confirm_email/2"},{"type":"function","title":"PowEmailConfirmation.Plug.email_unconfirmed?/1","doc":"Check if the email for the current user is yet to be confirmed.","ref":"PowEmailConfirmation.Plug.html#email_unconfirmed?/1"},{"type":"function","title":"PowEmailConfirmation.Plug.load_user_by_token/2","doc":"Verifies the signed token and fetches user.\n\nIf a user is found, it'll be assigned to `conn.assigns` for key\n`:confirm_email_user`.\n\nThe token should have been signed with `sign_confirmation_token/2`. The token\nwill be decoded and verified with `Pow.Plug.verify_token/4`.","ref":"PowEmailConfirmation.Plug.html#load_user_by_token/2"},{"type":"function","title":"PowEmailConfirmation.Plug.pending_email_change?/1","doc":"Check if the there is a pending email change for the current user.","ref":"PowEmailConfirmation.Plug.html#pending_email_change?/1"},{"type":"function","title":"PowEmailConfirmation.Plug.sign_confirmation_token/2","doc":"Signs the e-mail confirmation token for public consumption.\n\nThe token will be signed using `Pow.Plug.sign_token/4`.","ref":"PowEmailConfirmation.Plug.html#sign_confirmation_token/2"},{"type":"module","title":"PowPersistentSession.Plug","doc":"Plug helper functions.","ref":"PowPersistentSession.Plug.html"},{"type":"function","title":"PowPersistentSession.Plug.create/2","doc":"Create a new persistent session in the connection for user.","ref":"PowPersistentSession.Plug.html#create/2"},{"type":"function","title":"PowPersistentSession.Plug.delete/1","doc":"Deletes the persistent session in the connection.","ref":"PowPersistentSession.Plug.html#delete/1"},{"type":"behaviour","title":"PowPersistentSession.Plug.Base","doc":"Base module for setting up persistent session plugs.\n\nAny writes to backend store or client should occur in `:before_send` callback\nas defined in `Plug.Conn`. To ensure that the callbacks are called in the\norder they were set, a `register_before_send/2` function is used to set\ncallbacks instead of `Plug.Conn.register_before_send/2`.\n\nSee `PowPersistentSession.Plug.Cookie` for an implementation example.","ref":"PowPersistentSession.Plug.Base.html"},{"type":"behaviour","title":"Configuration options - PowPersistentSession.Plug.Base","doc":"* `:persistent_session_store` - the persistent session store. This value\n    defaults to\n    `{PowPersistentSession.Store.PersistentSessionCache, backend: Pow.Store.Backend.EtsCache}`.\n    The `Pow.Store.Backend.EtsCache` backend store can be changed with the\n    `:cache_store_backend` option.\n\n  * `:cache_store_backend` - the backend cache store. This value defaults to\n    `Pow.Store.Backend.EtsCache`.\n\n  * `:persistent_session_ttl` - integer value in milliseconds for TTL of\n    persistent session in the backend store. This defaults to 30 days in\n    miliseconds.","ref":"PowPersistentSession.Plug.Base.html#module-configuration-options"},{"type":"callback","title":"PowPersistentSession.Plug.Base.authenticate/2","doc":"","ref":"PowPersistentSession.Plug.Base.html#c:authenticate/2"},{"type":"callback","title":"PowPersistentSession.Plug.Base.call/2","doc":"","ref":"PowPersistentSession.Plug.Base.html#c:call/2"},{"type":"callback","title":"PowPersistentSession.Plug.Base.create/3","doc":"","ref":"PowPersistentSession.Plug.Base.html#c:create/3"},{"type":"callback","title":"PowPersistentSession.Plug.Base.init/1","doc":"","ref":"PowPersistentSession.Plug.Base.html#c:init/1"},{"type":"function","title":"PowPersistentSession.Plug.Base.store/1","doc":"","ref":"PowPersistentSession.Plug.Base.html#store/1"},{"type":"module","title":"PowPersistentSession.Plug.Cookie","doc":"This plug will handle persistent user sessions with cookies.\n\nThe cookie and token will expire after 30 days. The token in the cookie can\nonly be used once to create a session.\n\nIf an assigned private `:pow_session_metadata` key exists in the conn with a\nkeyword list containing a `:fingerprint` key, that fingerprint value will be\nset along with the user as the persistent session value as\n`{user, session_metadata: [fingerprint: fingerprint]}`.\n\nThe token used in the client is signed using `Pow.Plug.sign_token/4` to\nprevent timing attacks.","ref":"PowPersistentSession.Plug.Cookie.html"},{"type":"module","title":"Example - PowPersistentSession.Plug.Cookie","doc":"defmodule MyAppWeb.Endpoint do\n    # ...\n\n    plug Pow.Plug.Session, otp_app: :my_app\n    plug PowPersistentSession.Plug.Cookie\n    #...\n  end","ref":"PowPersistentSession.Plug.Cookie.html#module-example"},{"type":"module","title":"Configuration options - PowPersistentSession.Plug.Cookie","doc":"* `:persistent_session_store` - see `PowPersistentSession.Plug.Base`\n\n  * `:cache_store_backend` - see `PowPersistentSession.Plug.Base`\n\n  * `:persistent_session_cookie_key` - cookie key name. This defaults to\n    \"persistent_session\". If `:otp_app` is used it'll automatically prepend\n    the key with the `:otp_app` value.\n\n  * `:persistent_session_ttl` - used for both backend store and max age for\n    cookie. See `PowPersistentSession.Plug.Base` for more.\n\n  * `:persistent_session_cookie_opts` - keyword list of cookie options, see\n    `Plug.Conn.put_resp_cookie/4` for options. The default options are\n    `[max_age: max_age, path: \"/\"]` where `:max_age` is the value defined in\n    `:persistent_session_ttl`.","ref":"PowPersistentSession.Plug.Cookie.html#module-configuration-options"},{"type":"module","title":"Custom metadata - PowPersistentSession.Plug.Cookie","doc":"You can assign a private `:pow_persistent_session_metadata` key in the conn\nwith custom metadata as a keyword list. The only current use this has is to\nset `:session_metadata` that'll be passed on as `:pow_session_metadata` for\nnew session generation.\n\n      session_metadata =\n        conn.private\n        |> Map.get(:pow_session_metadata, [])\n        |> Keyword.take([:first_seen_at])\n\n      Plug.Conn.put_private(conn, :pow_persistent_session_metadata, session_metadata: session_metadata)\n\nThis ensure that you are able to keep session metadata consistent between\nbrowser sessions.\n\nWhen a persistent session token is used, the\n`:pow_persistent_session_metadata` assigns key in the conn will be populated\nwith a `:session_metadata` keyword list so that the session metadata that was\npulled from the persistent session can be carried over to the new persistent\nsession. `:fingerprint` will always be ignored as to not record the old\nfingerprint.","ref":"PowPersistentSession.Plug.Cookie.html#module-custom-metadata"},{"type":"function","title":"PowPersistentSession.Plug.Cookie.authenticate/2","doc":"Authenticates a user with the persistent session cookie.\n\nIf a persistent session cookie exists, it'll fetch the credentials from the\npersistent session cache.\n\nIf credentials was fetched successfully, a global lock is set and the token\nin the cache is deleted, a new session is created, and `create/2` is called\nto create a new persistent session cookie. If setting the lock failed, the\nuser will fetched will be set for the `conn` with\n`Pow.Plug.assign_current_user/3`.\n\nIf a `:session_metadata` keyword list is fetched from the persistent session\nmetadata, all the values will be merged into the private\n`:pow_session_metadata` key in the conn.\n\nIf the persistent session cache returns a `nil` value the persistent session\nwill be deleted as it means the context function could not find the\nassociated user.\n\nThe persistent session token will be decoded and verified with\n`Pow.Plug.verify_token/4`.","ref":"PowPersistentSession.Plug.Cookie.html#authenticate/2"},{"type":"function","title":"PowPersistentSession.Plug.Cookie.create/3","doc":"Sets a persistent session cookie with a randomly generated unique token.\n\nThe token is set as a key in the persistent session cache with the id fetched\nfrom the struct. Any existing persistent session will be deleted first with\n`delete/2`.\n\nIf an assigned private `:pow_session_metadata` key exists in the conn with a\nkeyword list containing a `:fingerprint` value, then that value will be set\nin a `:session_metadata` keyword list in the persistent session metadata. The\nvalue will look like:\n`{user, session_metadata: [fingerprint: fingerprint]}`\n\nThe unique token will be prepended by the `:otp_app` configuration value, if\npresent.\n\nThe token will be signed for public consumption with `Pow.Plug.sign_token/4`.","ref":"PowPersistentSession.Plug.Cookie.html#create/3"},{"type":"function","title":"PowPersistentSession.Plug.Cookie.delete/2","doc":"Expires the persistent session.\n\nIf a persistent session cookie exists the token in the persistent session\ncache will be deleted, and cookie deleted with\n`Plug.Conn.delete_resp_cookie/3`.","ref":"PowPersistentSession.Plug.Cookie.html#delete/2"},{"type":"module","title":"PowResetPassword.Phoenix.Messages","doc":"Module that handles messages for PowResetPassword.\n\nSee `Pow.Extension.Phoenix.Messages` for more.","ref":"PowResetPassword.Phoenix.Messages.html"},{"type":"function","title":"PowResetPassword.Phoenix.Messages.email_has_been_sent/1","doc":"Flash message to show when a reset password e-mail has been sent. Falls back\nto `maybe_email_has_been_sent/1`","ref":"PowResetPassword.Phoenix.Messages.html#email_has_been_sent/1"},{"type":"function","title":"PowResetPassword.Phoenix.Messages.invalid_token/1","doc":"Flash message to show when a an invalid or expired reset password link is\nused.","ref":"PowResetPassword.Phoenix.Messages.html#invalid_token/1"},{"type":"function","title":"PowResetPassword.Phoenix.Messages.maybe_email_has_been_sent/1","doc":"Flash message to show generic response for reset password request.","ref":"PowResetPassword.Phoenix.Messages.html#maybe_email_has_been_sent/1"},{"type":"function","title":"PowResetPassword.Phoenix.Messages.password_has_been_reset/1","doc":"Flash message to show when password has been updated.","ref":"PowResetPassword.Phoenix.Messages.html#password_has_been_reset/1"},{"type":"function","title":"PowResetPassword.Phoenix.Messages.user_not_found/1","doc":"Flash message to show when no user exists for the provided e-mail.","ref":"PowResetPassword.Phoenix.Messages.html#user_not_found/1"},{"type":"module","title":"PowResetPassword.Plug","doc":"Plug helper functions.","ref":"PowResetPassword.Plug.html"},{"type":"function","title":"PowResetPassword.Plug.change_user/2","doc":"Creates a changeset from the user fetched in the connection.","ref":"PowResetPassword.Plug.html#change_user/2"},{"type":"function","title":"PowResetPassword.Plug.create_reset_token/2","doc":"Finds a user for the provided params, creates a token, and stores the user\nfor the token.\n\nThe returned `:token` is signed for public consumption using\n`Pow.Plug.sign_token/4`. Additionally `Pow.UUID.generate/0` is called whether\nthe user exists or not to prevent timing attacks.\n\n`:reset_password_token_store` can be passed in the config for the conn. This\nvalue defaults to\n`{PowResetPassword.Store.ResetTokenCache, backend: Pow.Store.Backend.EtsCache}`.\nThe `Pow.Store.Backend.EtsCache` backend store can be changed with the\n`:cache_store_backend` option.","ref":"PowResetPassword.Plug.html#create_reset_token/2"},{"type":"function","title":"PowResetPassword.Plug.load_user_by_token/2","doc":"Verifies the signed token and fetches user from store.\n\nIf a user is found, it'll be assigned to `conn.assigns` for key\n`:reset_password_user`.\n\nA `:pow_reset_password_decoded_token` key will be assigned in `conn.private`\nwith the decoded token. This is used to invalidate the token when calling\n`update_user_password/2`.\n\nThe token will be decoded and verified with `Pow.Plug.verify_token/4`.\n\nSee `create_reset_token/2` for more on `:reset_password_token_store` config\noption.","ref":"PowResetPassword.Plug.html#load_user_by_token/2"},{"type":"function","title":"PowResetPassword.Plug.update_user_password/2","doc":"Updates the password for the user fetched in the connection.\n\nThe user should exist in `conn.assigns` for key `:reset_password_user` and\nthe decoded token in `conn.private` for key\n`:pow_reset_password_decoded_token`. `load_user_by_token/2` will ensure this.\n\nSee `create_reset_token/2` for more on `:reset_password_token_store` config\noption.","ref":"PowResetPassword.Plug.html#update_user_password/2"},{"type":"module","title":"PowInvitation.Ecto.Context","doc":"Handles invitation context for user.","ref":"PowInvitation.Ecto.Context.html"},{"type":"function","title":"PowInvitation.Ecto.Context.create/3","doc":"Creates an invited user.\n\nSee `PowInvitation.Ecto.Schema.invite_changeset/3`.","ref":"PowInvitation.Ecto.Context.html#create/3"},{"type":"function","title":"PowInvitation.Ecto.Context.get_by_invitation_token/2","doc":"Finds an invited user by the `invitation_token` column.\n\nIgnores users with `:invitation_accepted_at` set.","ref":"PowInvitation.Ecto.Context.html#get_by_invitation_token/2"},{"type":"function","title":"PowInvitation.Ecto.Context.update/3","doc":"Updates an invited user and accepts invitation.\n\nSee `PowInvitation.Ecto.Schema.accept_invitation_changeset/2`.","ref":"PowInvitation.Ecto.Context.html#update/3"},{"type":"module","title":"PowInvitation.Ecto.Schema","doc":"Handles the invitation schema for user.","ref":"PowInvitation.Ecto.Schema.html"},{"type":"module","title":"Customize PowInvitation associations or fields - PowInvitation.Ecto.Schema","doc":"If you need to modify any of the associations or fields that `PowInvitation`\nadds to the user schema, you can override them by defining them before\n`pow_user_fields/0`:\n\n    defmodule MyApp.Users.User do\n      use Ecto.Schema\n      use Pow.Ecto.Schema\n      use Pow.Extension.Ecto.Schema,\n        extensions: [PowInvitation]\n\n      schema \"users\" do\n        belongs_to :invited_by, __MODULE__\n        has_many :invited_users __MODULE__, foreign_key: :invited_by_id, on_delete: delete_all\n\n        field :invitation_token, :string\n        field :invitation_accepted_at, :utc_datetime\n\n        pow_user_fields()\n\n        timestamps()\n      end\n    end","ref":"PowInvitation.Ecto.Schema.html#module-customize-powinvitation-associations-or-fields"},{"type":"module","title":"Customize PowInvitation changeset - PowInvitation.Ecto.Schema","doc":"You can extract individual changeset functions to modify the changeset flow\nentirely. As an example, this is how you can invite a user through email\nwhile using `username` as the user id field:\n\n    defmodule MyApp.Users.User do\n      use Ecto.Schema\n      use Pow.Ecto.Schema,\n        user_id_field: :username\n\n      import PowInvitation.Ecto.Schema,\n        only: [invitation_token_changeset: 1, invited_by_changeset: 2]\n\n      # ...\n\n      def invite_changeset(user_or_changeset, invited_by, attrs) do\n        user_or_changeset\n        |> cast(attrs, [:email])\n        |> validate_required([:email])\n        |> invitation_token_changeset()\n        |> invited_by_changeset(invited_by)\n      end\n    end","ref":"PowInvitation.Ecto.Schema.html#module-customize-powinvitation-changeset"},{"type":"function","title":"PowInvitation.Ecto.Schema.accept_invitation_changeset/2","doc":"Accepts an invitation.\n\nThe changeset function in user schema module is called, and\n`:invitation_accepted_at` will be updated. The password can be set, and the\nuser id updated.","ref":"PowInvitation.Ecto.Schema.html#accept_invitation_changeset/2"},{"type":"function","title":"PowInvitation.Ecto.Schema.invitation_token_changeset/1","doc":"Sets the invitation token.","ref":"PowInvitation.Ecto.Schema.html#invitation_token_changeset/1"},{"type":"function","title":"PowInvitation.Ecto.Schema.invite_changeset/3","doc":"Invites user.\n\nIt's important to note that this changeset should not include the changeset\nfunction in the user schema module if `PowEmailConfirmation` has been\nenabled. This is because the e-mail is assumed confirmed already if the user\ncan accept the invitation.\n\nA unique `:invitation_token` will be generated, and `invited_by` association\nwill be set. Only the user id will be set, and the persisted user won't have\nany password for authentication.\n\nCalls `invitation_token_changeset/1` and `invited_by_changeset/2`.","ref":"PowInvitation.Ecto.Schema.html#invite_changeset/3"},{"type":"function","title":"PowInvitation.Ecto.Schema.invited_by_changeset/2","doc":"Sets the invited by association.","ref":"PowInvitation.Ecto.Schema.html#invited_by_changeset/2"},{"type":"module","title":"PowInvitation.Phoenix.Messages","doc":"Module that handles messages for PowInvitation.\n\nSee `Pow.Extension.Phoenix.Messages` for more.","ref":"PowInvitation.Phoenix.Messages.html"},{"type":"function","title":"PowInvitation.Phoenix.Messages.invalid_invitation/1","doc":"Flash message to show when an invalid or expired invitation url is used.","ref":"PowInvitation.Phoenix.Messages.html#invalid_invitation/1"},{"type":"function","title":"PowInvitation.Phoenix.Messages.invitation_email_sent/1","doc":"Flash message to show when user has been invited and e-mail has been sent.","ref":"PowInvitation.Phoenix.Messages.html#invitation_email_sent/1"},{"type":"module","title":"PowInvitation.Plug","doc":"Plug helper functions.","ref":"PowInvitation.Plug.html"},{"type":"function","title":"PowInvitation.Plug.change_user/2","doc":"Creates a changeset from the user fetched in the connection.","ref":"PowInvitation.Plug.html#change_user/2"},{"type":"function","title":"PowInvitation.Plug.create_user/2","doc":"Creates a new invited user by the current user in the connection.","ref":"PowInvitation.Plug.html#create_user/2"},{"type":"function","title":"PowInvitation.Plug.load_invited_user_by_token/2","doc":"Verifies the signed token and fetches invited user.\n\nIf a user is found, it'll be assigned to `conn.assigns` for key\n`:invited_user`.\n\nThe token should have been signed with `sign_invitation_token/2`. The token\nwill be decoded and verified with `Pow.Plug.verify_token/4`.","ref":"PowInvitation.Plug.html#load_invited_user_by_token/2"},{"type":"function","title":"PowInvitation.Plug.sign_invitation_token/2","doc":"Signs the invitation token for public consumption.\n\nThe token will be signed using `Pow.Plug.sign_token/4`.","ref":"PowInvitation.Plug.html#sign_invitation_token/2"},{"type":"function","title":"PowInvitation.Plug.update_user/2","doc":"Updates current user in the connection with the params.\n\nExpects the invited user to exist in `conn.assigns` for key\n`:invited_user`.\n\nIf successful the session will be regenerated.","ref":"PowInvitation.Plug.html#update_user/2"},{"type":"extras","title":"","doc":"# ![Pow](assets/logo-full.svg)\n\n[![Github CI](https://github.com/pow-auth/pow/workflows/CI/badge.svg)](https://github.com/pow-auth/pow/actions?query=workflow%3ACI)\n[![hexdocs.pm](https://img.shields.io/badge/api-docs-green.svg?style=flat)](https://hexdocs.pm/pow)\n[![hex.pm](https://img.shields.io/hexpm/v/pow.svg?style=flat)](https://hex.pm/packages/pow)\n\nPow is a robust, modular, and extendable authentication and user management solution for Phoenix and Plug-based apps.","ref":"README.html"},{"type":"extras","title":"Features - ","doc":"* User registration\n* Session based authorization\n* [Per Endpoint/Plug configuration](#configuration)\n* [API token authorization](guides/api.md)\n* Mnesia cache with automatic cluster healing\n* [Multitenancy](guides/multitenancy.md)\n* [User roles](guides/user_roles.md)\n* [Extendable](#extensions)\n* [I18n](#i18n)\n* [And more](guides/why_pow.md)","ref":"README.html#features"},{"type":"extras","title":"Installation - ","doc":"Add Pow to your list of dependencies in `mix.exs`:\n\n```elixir\ndefp deps do\n  [\n    # ...\n    {:pow, \"~> 1.0.37\"}\n  ]\nend\n```\n\nRun `mix deps.get` to install it.","ref":"README.html#installation"},{"type":"extras","title":"Getting started - ","doc":"#","ref":"README.html#getting-started"},{"type":"extras","title":"Phoenix app - ","doc":"**Umbrella project**: Check out the [umbrella project guide](guides/umbrella_project.md).\n\nInstall the necessary files:\n\n```bash\nmix pow.install\n```\n\nThis will add the following files to your app:\n\n```bash\nLIB_PATH/users/user.ex\nPRIV_PATH/repo/migrations/TIMESTAMP_create_users.ex\n```\n\nAnd also update the following files:\n\n```bash\nconfig/config.exs\nWEB_PATH/endpoint.ex\nWEB_PATH/router.ex\n```\n\nRun migrations with `mix setup`, start the server with `mix phx.server`, and you can now visit `http://localhost:4000/registration/new` to create a user.\n\n#","ref":"README.html#phoenix-app"},{"type":"extras","title":"Modify templates - ","doc":"By default, Pow exposes as few files as possible.\n\nIf you wish to modify the templates, you can generate them using:\n\n```bash\nmix pow.phoenix.gen.templates\n```\n\nThis will also add `web_module: MyAppWeb` to the configuration in `config/config.exs`.","ref":"README.html#modify-templates"},{"type":"extras","title":"Extensions - ","doc":"Pow is made so it's easy to extend the functionality with your own complimentary library. The following extensions are included in this library:\n\n* [PowResetPassword](lib/extensions/reset_password/README.md)\n* [PowEmailConfirmation](lib/extensions/email_confirmation/README.md)\n* [PowPersistentSession](lib/extensions/persistent_session/README.md)\n* [PowInvitation](lib/extensions/invitation/README.md)\n\nCheck out the [\"Other libraries\"](#other-libraries) section for other extensions.\n\n#","ref":"README.html#extensions"},{"type":"extras","title":"Add extensions support - ","doc":"To keep it easy to understand and configure Pow, you'll have to enable the extensions yourself.\n\nLet's install the `PowResetPassword` and `PowEmailConfirmation` extensions.\n\nFirst, install extension migrations by running:\n\n```bash\nmix pow.extension.ecto.gen.migrations --extension PowResetPassword --extension PowEmailConfirmation\n```\n\nThen run the migrations with `mix ecto.migrate`. Now, update `config/config.ex` with the `:extensions` and `:controller_callbacks` key:\n\n```elixir\nconfig :my_app, :pow,\n  user: MyApp.Users.User,\n  repo: MyApp.Repo,\n  extensions: [PowResetPassword, PowEmailConfirmation],\n  controller_callbacks: Pow.Extension.Phoenix.ControllerCallbacks\n```\n\nUpdate `LIB_PATH/users/user.ex` with the extensions:\n\n```elixir\ndefmodule MyApp.Users.User do\n  use Ecto.Schema\n  use Pow.Ecto.Schema\n  use Pow.Extension.Ecto.Schema,\n    extensions: [PowResetPassword, PowEmailConfirmation]\n\n  # ...\n\n  def changeset(user_or_changeset, attrs) do\n    user_or_changeset\n    |> pow_changeset(attrs)\n    |> pow_extension_changeset(attrs)\n  end\nend\n```\n\nAdd Pow extension routes to `WEB_PATH/router.ex`:\n\n```elixir\ndefmodule MyAppWeb.Router do\n  use MyAppWeb, :router\n  use Pow.Phoenix.Router\n  use Pow.Extension.Phoenix.Router,\n    extensions: [PowResetPassword, PowEmailConfirmation]\n\n  # ...\n\n  scope \"/\" do\n    pipe_through :browser\n\n    pow_routes()\n    pow_extension_routes()\n  end\n\n  # ...\nend\n```\n\n##","ref":"README.html#add-extensions-support"},{"type":"extras","title":"Modify extension templates - ","doc":"Templates for extensions can be generated with:\n\n```bash\nmix pow.extension.phoenix.gen.templates --extension PowResetPassword --extension PowEmailConfirmation\n```\n\nPlease follow the instructions in [\"Modify templates\"](#modify-templates) to ensure that your custom templates will be used.\n\n#","ref":"README.html#modify-extension-templates"},{"type":"extras","title":"Mailer support - ","doc":"Many extensions require a mailer to have been set up. Let's create a mailer mock module in  `WEB_PATH/mails/pow/mailer.ex`:\n\n```elixir\ndefmodule MyAppWeb.Pow.Mailer do\n  use Pow.Phoenix.Mailer\n  require Logger\n\n  def cast(%{user: user, subject: subject, text: text, html: html, assigns: _assigns}) do\n    # Build email struct to be used in `process/1`\n\n    %{to: user.email, subject: subject, text: text, html: html}\n  end\n\n  def process(email) do\n    # Send email\n\n    Logger.debug(\"E-mail sent: #{inspect email}\")\n  end\nend\n```\n\nUpdate `config/config.ex` with `:mailer_backend` key:\n\n```elixir\nconfig :my_app, :pow,\n  # ...\n  mailer_backend: MyAppWeb.Pow.Mailer\n```\n\nThis mailer module will only output the mail to your log, so you can e.g. try out the reset password and email confirmation links. You should integrate the Pow mailer with your actual mailer system. For Swoosh or Bamboo integration, check out the [Configuring mailer guide](guides/configuring_mailer.md).\n\n##","ref":"README.html#mailer-support"},{"type":"extras","title":"Modify mailer templates - ","doc":"Generate the template files:\n\n```bash\nmix pow.extension.phoenix.mailer.gen.templates --extension PowResetPassword --extension PowEmailConfirmation\n```\n\nThis will generate template files in the `WEB_PATH/mails/` directory. This will also add the necessary `mail/0` macro to `WEB_PATH/my_app_web.ex` and update the pow config with `web_mailer_module: MyAppWeb`.","ref":"README.html#modify-mailer-templates"},{"type":"extras","title":"Configuration - ","doc":"Pow is built to be modular, and easy to configure. The configuration is passed to function calls as well as plug options, and they will take priority over any environment configuration. It's ideal in case you got an umbrella app with multiple separate user domains.\n\nThe easiest way to use Pow with Phoenix is to use a `:otp_app` in function calls and set the app environment configuration. It will keep a persistent fallback configuration that you configure in one place.\n\n#","ref":"README.html#configuration"},{"type":"extras","title":"Module groups - ","doc":"Pow has three main groups of modules that each can be used individually, or in conjunction with each other:\n\n##","ref":"README.html#module-groups"},{"type":"extras","title":"Pow.Plug - ","doc":"This group will handle the plug connection. The configuration will be assigned to `conn.private[:pow_config]` and passed through the controller to the users' context module. The Plug module has functions to authenticate, create, update, and delete users, and will generate/renew the session automatically.\n\n##","ref":"README.html#pow-plug"},{"type":"extras","title":"Pow.Ecto - ","doc":"This group contains all modules related to the Ecto based user schema and context. By default, Pow will use the `Pow.Ecto.Context` module to authenticate, create, update and delete users with lookups to the database. However, it's straightforward to extend or write your custom user context. You can do this by setting the `:users_context` configuration key.\n\n##","ref":"README.html#pow-ecto"},{"type":"extras","title":"Pow.Phoenix - ","doc":"This group contains the controllers and templates for Phoenix. You only need to set the (session) plug in `endpoint.ex` and add the routes to `router.ex`. Templates are not generated by default, instead, the compiled templates in Pow are used. You can generate the templates used by running `mix pow.phoenix.gen.templates`. You can also customize flash messages and callback routes by creating your own using `:messages_backend` and `:routes_backend`.\n\nThe registration and session controllers can be changed with your customized versions too, but since the routes are built on compile time, you'll have to set them up in `router.ex` with `:pow` namespace. For minor pre/post-processing of requests, you can use the `:controller_callbacks` option. It exists to make it easier to modify flow with extensions (e.g., send a confirmation email upon user registration).\n\n#","ref":"README.html#pow-phoenix"},{"type":"extras","title":"Pow.Extension - ","doc":"This module helps build extensions for Pow. There're three extension mix tasks to generate Ecto migrations and phoenix templates.\n\n```bash\nmix pow.extension.ecto.gen.migrations\n```\n\n```bash\nmix pow.extension.phoenix.gen.templates\n```\n\n```bash\nmix pow.extension.phoenix.mailer.gen.templates\n```\n\n#","ref":"README.html#pow-extension"},{"type":"extras","title":"Authorization plug - ","doc":"Pow ships with a session plug module. You can easily switch it out with a different one. As an example, here's how you do that with `Phoenix.Token`:\n\n```elixir\ndefmodule MyAppWeb.Pow.Plug do\n  use Pow.Plug.Base\n\n  @session_key :pow_user_token\n  @salt \"user salt\"\n  @max_age 86400\n\n  def fetch(conn, config) do\n    conn  = Plug.Conn.fetch_session(conn)\n    token = Plug.Conn.get_session(conn, @session_key)\n\n    MyAppWeb.Endpoint\n    |> Phoenix.Token.verify(@salt, token, max_age: @max_age)\n    |> maybe_load_user(conn)\n  end\n\n  defp maybe_load_user({:ok, user_id}, conn), do: {conn, MyApp.Repo.get(User, user_id)}\n  defp maybe_load_user({:error, _any}, conn), do: {conn, nil}\n\n  def create(conn, user, config) do\n    token = Phoenix.Token.sign(MyAppWeb.Endpoint, @salt, user.id)\n    conn  =\n      conn\n      |> Plug.Conn.fetch_session()\n      |> Plug.Conn.put_session(@session_key, token)\n\n    {conn, user}\n  end\n\n  def delete(conn, config) do\n    conn\n    |> Plug.Conn.fetch_session()\n    |> Plug.Conn.delete_session(@session_key)\n  end\nend\n\ndefmodule MyAppWeb.Endpoint do\n  # ...\n\n  plug MyAppWeb.Pow.Plug, otp_app: :my_app\nend\n```\n\n#","ref":"README.html#authorization-plug"},{"type":"extras","title":"Ecto changeset - ","doc":"The user module has a fallback `changeset/2` function. If you want to add custom validations, you can use the `pow_changeset/2` function like so:\n\n```elixir\ndefmodule MyApp.Users.User do\n  use Ecto.Schema\n  use Pow.Ecto.Schema\n\n  schema \"users\" do\n    field :custom, :string\n\n    pow_user_fields()\n\n    timestamps()\n  end\n\n  def changeset(user_or_changeset, attrs) do\n    user_or_changeset\n    |> pow_changeset(attrs)\n    |> Ecto.Changeset.cast(attrs, [:custom])\n    |> Ecto.Changeset.validate_required([:custom])\n  end\nend\n```\n\n#","ref":"README.html#ecto-changeset"},{"type":"extras","title":"Phoenix controllers - ","doc":"Controllers in Pow are very slim and consists of just one `Pow.Plug` function call with response functions. If you wish to change the flow of the `Pow.Phoenix.RegistrationController` and `Pow.Phoenix.SessionController`, the best way is to create your own and modify `router.ex`.\n\nHowever, to make it easier to integrate extension, you can add callbacks to the controllers that do some light pre/post-processing of the request:\n\n```elixir\ndefmodule MyCustomExtension.Phoenix.ControllerCallbacks do\n  use Pow.Extension.Phoenix.ControllerCallbacks.Base\n\n  def before_respond(Pow.Phoenix.RegistrationController, :create, {:ok, user, conn}, _config) do\n    # send email\n\n    {:ok, user, conn}\n  end\nend\n```\n\nYou can add functions for `before_process/4` (before the action happens) and `before_respond/4` (before parsing the results from the action).\n\n##","ref":"README.html#phoenix-controllers"},{"type":"extras","title":"Testing with authenticated users - ","doc":"To test with authenticated users in your controller tests, you just have to assign the user to the conn in your setup callback:\n\n```elixir\nsetup %{conn: conn} do\n  user = %User{email: \"test@example.com\"}\n  conn = Pow.Plug.assign_current_user(conn, user, otp_app: :my_app)\n\n  {:ok, conn: conn}\nend\n```\n\n#","ref":"README.html#testing-with-authenticated-users"},{"type":"extras","title":"I18n - ","doc":"All templates can be generated and modified to use your Gettext module.\n\nFor flash messages, you can create the following module:\n\n```elixir\ndefmodule MyAppWeb.Pow.Messages do\n  use Pow.Phoenix.Messages\n  use Pow.Extension.Phoenix.Messages,\n    extensions: [PowResetPassword]\n\n  import MyAppWeb.Gettext\n\n  def user_not_authenticated(_conn), do: gettext(\"You need to sign in to see this page.\")\n\n  # Message functions for extensions has to be prepended with the snake cased\n  # extension name. So the `email_has_been_sent/1` function from\n  # `PowResetPassword` is written as `pow_reset_password_email_has_been_sent/1`\n  # in your messages module.\n  def pow_reset_password_email_has_been_sent(_conn), do: gettext(\"An email with reset instructions has been sent to you. Please check your inbox.\")\nend\n```\n\nAdd `messages_backend: MyAppWeb.Pow.Messages` to your configuration. You can find all the messages in `Pow.Phoenix.Messages` and `[Pow Extension].Phoenix.Messages`.\n\n#","ref":"README.html#i18n"},{"type":"extras","title":"Callback routes - ","doc":"You can customize callback routes by creating the following module:\n\n```elixir\ndefmodule MyAppWeb.Pow.Routes do\n  use Pow.Phoenix.Routes\n  use MyAppWeb, :verified_routes\n\n  def after_sign_in_path(conn), do: ~p\"/home\"\nend\n```\n\nAdd `routes_backend: MyAppWeb.Pow.Routes` to your configuration. You can find all the routes in `Pow.Phoenix.Routes`.\n\n#","ref":"README.html#callback-routes"},{"type":"extras","title":"Password hashing function - ","doc":"`Pow.Ecto.Schema.Password` is used to hash and verify with Pbkdf2. It's highly recommended to lower the iterations count in your test environment to speed up your tests:\n\n```elixir\nconfig :pow, Pow.Ecto.Schema.Password, iterations: 1\n```\n\nYou can change the password hashing function easily. For example, this is how you use [comeonin with Argon2](https://github.com/riverrun/argon2_elixir):\n\n```elixir\ndefmodule MyApp.Users.User do\n  use Ecto.Schema\n  use Pow.Ecto.Schema,\n    password_hash_verify: {&Argon2.hash_pwd_salt/1,\n                           &Argon2.verify_pass/2}\n\n  # ...\nend\n```\n\n#","ref":"README.html#password-hashing-function"},{"type":"extras","title":"Current user and sign out link - ","doc":"You can use `Pow.Plug.current_user/1` to fetch the current user from the connection.\n\nThis can be used to show the sign in or sign out links in your Phoenix template:\n\n```elixir\n<.link :if={Pow.Plug.current_user(@conn)} href={~p\"/session\"} method=\"delete\">Sign out</.link>\n<.link :if={is_nil Pow.Plug.current_user(@conn)} navigate={~p\"/registration/new\"}>Registration</.link>\n<.link :if={is_nil Pow.Plug.current_user(@conn)} navigate={~p\"/session/new\"}>Sign In</.link>\n```\n\nThe current user can also be fetched by using the template assigns set in the configuration with `:current_user_assigns_key` (defaults to `@current_user`).","ref":"README.html#current-user-and-sign-out-link"},{"type":"extras","title":"Plugs - ","doc":"#","ref":"README.html#plugs"},{"type":"extras","title":"Pow.Plug.Session - ","doc":"Enables session-based authorization. The user struct will be collected from a cache store through a GenServer using a unique token generated for the session. The token will be reset every time the authorization level changes (handled by `Pow.Plug`) or after a certain interval (default 15 minutes).\n\nThe user struct fetched can be out of sync with the database if the row in the database is updated by actions outside Pow. In this case, it's recommended to [add a plug](guides/sync_user.md) that reloads the user struct and reassigns it to the connection.\n\nCustom metadata can be set for the session by assigning a private `:pow_session_metadata` key in the conn. Read the `Pow.Plug.Session` module docs for more details.\n\n##","ref":"README.html#pow-plug-session"},{"type":"extras","title":"Cache store - ","doc":"By default `Pow.Store.Backend.EtsCache` is started automatically and can be used in development and test environment.\n\nFor a production environment, you should use a distributed, persistent cache store. Pow makes this easy with `Pow.Store.Backend.MnesiaCache`. To start MnesiaCache in your Phoenix app, add it to your `application.ex` supervisor:\n\n```elixir\ndefmodule MyApp.Application do\n  use Application\n\n  def start(_type, _args) do\n    children = [\n      MyApp.Repo,\n      MyAppWeb.Endpoint,\n      Pow.Store.Backend.MnesiaCache\n      # # Or in a distributed system:\n      # {Pow.Store.Backend.MnesiaCache, extra_db_nodes: {Node, :list, []}},\n      # Pow.Store.Backend.MnesiaCache.Unsplit # Recover from netsplit\n    ]\n\n    opts = [strategy: :one_for_one, name: MyAppWeb.Supervisor]\n    Supervisor.start_link(children, opts)\n  end\n\n  # ...\nend\n```\n\nUpdate `config/config.ex` with `:cache_store_backend` key:\n\n```elixir\nconfig :my_app, :pow,\n  # ...\n  cache_store_backend: Pow.Store.Backend.MnesiaCache\n```\n\nRemember to add `:mnesia` to your `:extra_applications` so it'll be available for your release build. Mnesia will write files to the current working directory. The path can be changed with `config :mnesia, dir: '/path/to/dir'`.\n\nThe MnesiaCache requires write access. If you've got a read-only file system you should take a look at the [Redis cache backend store guide](guides/redis_cache_store_backend.md).\n\n#","ref":"README.html#cache-store"},{"type":"extras","title":"Pow.Plug.RequireAuthenticated - ","doc":"Will halt connection if no current user is not present in assigns. Expects an `:error_handler` option.\n\n#","ref":"README.html#pow-plug-requireauthenticated"},{"type":"extras","title":"Pow.Plug.RequireNotAuthenticated - ","doc":"Will halt connection if a current user is present in assigns. Expects an `:error_handler` option.","ref":"README.html#pow-plug-requirenotauthenticated"},{"type":"extras","title":"Pow security practices - ","doc":"See [security practices](guides/security_practices.md).","ref":"README.html#pow-security-practices"},{"type":"extras","title":"Other libraries - ","doc":"[PowAssent](https://github.com/pow-auth/pow_assent) - Multi-provider support for Pow with strategies for Twitter, Github, Google, Facebook and more","ref":"README.html#other-libraries"},{"type":"extras","title":"Contributing - ","doc":"Please read [CONTRIBUTING.md](CONTRIBUTING.md).","ref":"README.html#contributing"},{"type":"extras","title":"LICENSE - ","doc":"(The MIT License)\n\nCopyright (c) 2018-2019 Dan Schultzer & the Contributors\n\nPermission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the 'Software'), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:\n\nThe above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.\n\nTHE SOFTWARE IS PROVIDED 'AS IS', WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.","ref":"README.html#license"},{"type":"extras","title":"Contributing to Pow","doc":"# Contributing to Pow\n\nAll contributions to Pow are welcome!\n\nPostgres is required to test locally. The [test helper](test/test_helper.exs) will automatically set up the database for you when you run the tests. Run `mix credo` for static code analysing.","ref":"CONTRIBUTING.html"},{"type":"extras","title":"Postgres setup - Contributing to Pow","doc":"The test environment has minimal database configuration which means it'll by default use the current username in the OS. If no such role exists (common with older postgres setup where only `postgres` role exists), you can easily create the superuser user by running:\n\n```bash\ncreateuser -U postgres -s $(whoami)\n```","ref":"CONTRIBUTING.html#postgres-setup"},{"type":"extras","title":"Mocks - Contributing to Pow","doc":"As the default ETS cache store backend works asynchronously, a synchronous ETS cache store backend ([`Pow.Test.EtsCacheMock`](test/support/ets_cache_mock.ex)) is used instead.\n\nOnly Ecto modules are tested against the database. Plug and Phoenix modules uses [`Pow.Test.ContextMock`](test/support/context_mock.ex).","ref":"CONTRIBUTING.html#mocks"},{"type":"extras","title":"Extension test support - Contributing to Pow","doc":"Due to compile-time configuration of Phoenix modules and User schema modules, several modules are dynamically generated with [`Pow.Test.ExtensionMocks`](test/support/extensions/mock.ex).","ref":"CONTRIBUTING.html#extension-test-support"},{"type":"extras","title":"Releases - Contributing to Pow","doc":"Releases to hex are automatically handled in Travis CI, when a tag is pushed on Github (and a new version has been set in `mix.exs`).","ref":"CONTRIBUTING.html#releases"},{"type":"extras","title":"Changelog","doc":"# Changelog","ref":"CHANGELOG.html"},{"type":"extras","title":"v1.0.37 (2024-03-03) - Changelog","doc":"#","ref":"CHANGELOG.html#v1-0-37-2024-03-03"},{"type":"extras","title":"Bug fixes - Changelog","doc":"* [`Pow.Phoenix.Template`] Now sets the function annotation in caller environment to prevent compile error when `:debug_heex_annotations` is set to `true`","ref":"CHANGELOG.html#bug-fixes"},{"type":"extras","title":"v1.0.36 (2024-02-07) - Changelog","doc":"#","ref":"CHANGELOG.html#v1-0-36-2024-02-07"},{"type":"extras","title":"Bug fixes - Changelog","doc":"* [`Pow.Phoenix.ViewHelpers`] Now ensures format for layouts in Phoenix 1.7 is conformed to prevent `conflicting layouts found` warnings","ref":"CHANGELOG.html#bug-fixes"},{"type":"extras","title":"v1.0.35 (2024-01-04) - Changelog","doc":"Handles Elixir 1.16 deprecations.\n\n#","ref":"CHANGELOG.html#v1-0-35-2024-01-04"},{"type":"extras","title":"Enhancements - Changelog","doc":"* [`Pow.Ecto.Schema.Changeset`] Now handles MFA for `:password_hash_verify`\n* [`Pow.Ecto.Schema.Changeset`] Now handles MFA for `:email_validator`\n\n#","ref":"CHANGELOG.html#enhancements"},{"type":"extras","title":"Deprecations - Changelog","doc":"* [`Pow.Ecto.Schema.Changeset`] Deprecated `:password_hash_methods` in favor of `:password_hash_verify`","ref":"CHANGELOG.html#deprecations"},{"type":"extras","title":"v1.0.34 (2023-09-18) - Changelog","doc":"**Note:** This release contains an important security fix. It is recommended to update  immediately if you are using the `Pow.Store.Backend.MnesiaCache`.\n\n#","ref":"CHANGELOG.html#v1-0-34-2023-09-18"},{"type":"extras","title":"Bug fixes - Changelog","doc":"- [`Pow.Store.Backend.MnesiaCache`] Fixed bug where expired cached keys are not invalidated on startup","ref":"CHANGELOG.html#bug-fixes"},{"type":"extras","title":"v1.0.33 (2023-09-05) - Changelog","doc":"#","ref":"CHANGELOG.html#v1-0-33-2023-09-05"},{"type":"extras","title":"Bug fixes - Changelog","doc":"- [`Pow.Phoenix.Controller`] Fixed regression bug with `Phoenix.View` and `:namespace` option\n- [`Pow.Phoenix.ViewHelpers`] Now falls back to view named modules to prevent upgrade issues","ref":"CHANGELOG.html#bug-fixes"},{"type":"extras","title":"v1.0.32 (2023-08-30) - Changelog","doc":"Removed deprecation warnings for Elixir 1.15.\n\n#","ref":"CHANGELOG.html#v1-0-32-2023-08-30"},{"type":"extras","title":"Bug fixes - Changelog","doc":"- [`Pow.Phoenix.Controller`] Now uses `Phoenix.View` when it's available with `:namespace` option to prevent upgrade issues","ref":"CHANGELOG.html#bug-fixes"},{"type":"extras","title":"v1.0.31 (2023-06-09) - Changelog","doc":"#","ref":"CHANGELOG.html#v1-0-31-2023-06-09"},{"type":"extras","title":"Bug fixes - Changelog","doc":"- [`Pow.Phoenix.Mailer.Mail`] Now renders html and text correctly in fallback mode for deprecated MailView","ref":"CHANGELOG.html#bug-fixes"},{"type":"extras","title":"v1.0.30 (2023-04-28) - Changelog","doc":"#","ref":"CHANGELOG.html#v1-0-30-2023-04-28"},{"type":"extras","title":"Bug fixes - Changelog","doc":"- [`Pow`] Ensure the dependency is loaded before matching version in `Pow.dependency_vsn_match?/2`","ref":"CHANGELOG.html#bug-fixes"},{"type":"extras","title":"v1.0.29 (2023-03-21) - Changelog","doc":"This version is updated to work with Phoenix 1.7, in particular using the new template components structure. All views have been removed, and Pow no longer requires the `phoenix_view` dependency.\n\nNow requires Elixir 1.12+.\n\n#","ref":"CHANGELOG.html#v1-0-29-2023-03-21"},{"type":"extras","title":"Enhancements - Changelog","doc":"* [`Pow.Phoenix.Mailer.Mail`] Revamped to conform to template component structure of Phoenix 1.7\n* [`Pow.Phoenix.Template`] Now renders Tailwind based template components on Phoenix 1.7\n\n#","ref":"CHANGELOG.html#enhancements"},{"type":"extras","title":"Deprecations - Changelog","doc":"* [`Pow.Phoenix.Mailer.Mail`] Deprecated `:pow_mailer_layout` in favor of `:pow_mailer_layouts`\n* [`Mix.Pow.Phoenix.Mailer`] Removed `Mix.Pow.Phoenix.Mailer.create_view_file/5`\n* [`Mix.Pow.Phoenix.Mailer`] Removed `Mix.Pow.Phoenix.Mailer.create_templates/4`\n* [`Mix.Pow.Phoenix`] Removed `Mix.Pow.Phoenix.create_view_file/4`","ref":"CHANGELOG.html#deprecations"},{"type":"extras","title":"v1.0.28 (2023-03-17) - Changelog","doc":"#","ref":"CHANGELOG.html#v1-0-28-2023-03-17"},{"type":"extras","title":"Enhancements - Changelog","doc":"* [`Mix.Pow`] `Mix.Pow.parse_options/3` now merges option defaults with `:otp_app, :generators` configuration\n* [`Mix.Pow.Mix.Tasks.Pow.Phoenix.Mailer.Gen.Templates`] Now injects `config/config.exs` and `WEB_PATH/WEB_APP.ex`\n* [`Mix.Pow.Mix.Tasks.Pow.Phoenix.Gen.Templates`] Now injects `config/config.exs`\n* [`Mix.Tasks.Pow.Phoenix.Install`] Now injects `config/config.exs`, `WEB_PATH/endpoint.ex`, and `WEB_PATH/router.ex`\n* [`Pow.Phoenix.Router`] Updated to support Phoenix 1.7 breaking changes\n* [`Pow.Phoenix.Template`] Updated to support Phoenix 1.7 verified routes\n* [`Pow.Phoenix.Routes`] Updated to support Phoenix 1.7 verified routes\n* [`Pow.Phoenix.ViewHelpers`] Updated to handle Phoenix 1.7 components layout\n\n#","ref":"CHANGELOG.html#enhancements"},{"type":"extras","title":"Bug fixes - Changelog","doc":"* `:phoenix` removed from the compilers\n\n#","ref":"CHANGELOG.html#bug-fixes"},{"type":"extras","title":"Documentation - Changelog","doc":"* Updated [api guide](guides/api.md) to correctly return updated `conn` for delete calls","ref":"CHANGELOG.html#documentation"},{"type":"extras","title":"v1.0.27 (2022-04-27) - Changelog","doc":"Now supports `ecto_sql` 3.8.x and requires Elixir 1.11+.\n\n#","ref":"CHANGELOG.html#v1-0-27-2022-04-27"},{"type":"extras","title":"Enhancements - Changelog","doc":"* [`Pow.Ecto.Schema`] has been refactored to conform the `@pow_fields` and `@pow_assocs` attributes with separate migration options","ref":"CHANGELOG.html#enhancements"},{"type":"extras","title":"v1.0.26 (2021-11-06) - Changelog","doc":"#","ref":"CHANGELOG.html#v1-0-26-2021-11-06"},{"type":"extras","title":"Enhancemnets - Changelog","doc":"* [`Pow.Store.Backend.MnesiaCache.Unsplit`] The unsplit module will now initialize the Mnesia cluster when nodes are connected lazily by resetting the Mnesia schema\n\n#","ref":"CHANGELOG.html#enhancemnets"},{"type":"extras","title":"Bug fixes - Changelog","doc":"* [`Pow.Store.Backend.MnesiaCache`] Now properly handles Mnesia application start errors\n\n#","ref":"CHANGELOG.html#bug-fixes"},{"type":"extras","title":"Documentation - Changelog","doc":"* Updated [api guide](guides/api.md) to use `Plug.Conn.register_before_send/2` for token writes","ref":"CHANGELOG.html#documentation"},{"type":"extras","title":"v1.0.25 (2021-09-26) - Changelog","doc":"Now supports Phoenix 1.6.x, and `phoenix_html` 3.x.x.\n\n#","ref":"CHANGELOG.html#v1-0-25-2021-09-26"},{"type":"extras","title":"Enhancements - Changelog","doc":"* [`Pow.Ecto.Schema.Fields`] The `:password_hash`, `:current_password`, and `:password` fields now have `redact: true` option set\n* [`Pow.Phoenix.Controller`] `Pow.Phoenix.Controller.action/3` now properly handles `{:halt, conn}` returned in the `before_process` callback\n* [`Pow.Store.Backend.EtsCache`] Now does synchronous writes unless `writes: :async` is passed in config options\n* [`Pow.Store.Backend.MnesiaCache`] Now does synchronous writes unless `writes: :async` is passed in config options\n\n#","ref":"CHANGELOG.html#enhancements"},{"type":"extras","title":"Bug fixes - Changelog","doc":"* [`Pow.Operations`] `Pow.Operations.fetch_primary_key_values/2` now ensures that module exists and is loaded before deriving primary keys\n\n#","ref":"CHANGELOG.html#bug-fixes"},{"type":"extras","title":"Documentation - Changelog","doc":"* Updated [redis guide](guides/redis_cache_store_backend.md) to use synchronous writes unless `writes: :async` is passed in config options\n* Updated [redis guide](guides/redis_cache_store_backend.md) to use optimized lookups with sorted keys","ref":"CHANGELOG.html#documentation"},{"type":"extras","title":"v1.0.24 (2021-05-27) - Changelog","doc":"#","ref":"CHANGELOG.html#v1-0-24-2021-05-27"},{"type":"extras","title":"Enhancements - Changelog","doc":"* [`Pow.Store.Backend.MnesiaCache`] Now accepts `extra_db_nodes: {module, function, arguments}` to fetch nodes when MnesiaCache starts up\n* [`PowEmailConfirmation.Phoenix.Messages`] Added `PowEmailConfirmation.Phoenix.Messages.invalid_token/1`\n* [`Pow.Store.CredentialsCache`] Now outputs an IO warning when a `:ttl` longer than 30 minutes is used\n\n#","ref":"CHANGELOG.html#enhancements"},{"type":"extras","title":"Bug fixes - Changelog","doc":"* [`Pow.Store.Backend.MnesiaCache`] Now handles initialization errors","ref":"CHANGELOG.html#bug-fixes"},{"type":"extras","title":"v1.0.23 (2021-03-22) - Changelog","doc":"#","ref":"CHANGELOG.html#v1-0-23-2021-03-22"},{"type":"extras","title":"Enhancements - Changelog","doc":"* [`Pow.Ecto.Context`] No longer automatically reloads the struct after insert or update\n* [`PowInvitation.Ecto.Schema`] Added `PowInvitation.Ecto.Schema.invitation_token_changeset/1`\n* [`PowInvitation.Ecto.Schema`] Added `PowInvitation.Ecto.Schema.invited_by_changeset/2`\n* [`Pow.Ecto.Schema.Password.Pbkdf2`] Now uses `:crypto.mac/4` if available to support OTP 24\n* [`PowEmailConfirmation.Phoenix.ControllerCallbacks`] Now returns `:info` instead of `:error` message for when the user has to confirm their email\n\n#","ref":"CHANGELOG.html#enhancements"},{"type":"extras","title":"Bug fixes - Changelog","doc":"* [`Pow.Store.Backend.MnesiaCache`] No longer triggers Elixir 1.11 dependency warnings","ref":"CHANGELOG.html#bug-fixes"},{"type":"extras","title":"v1.0.22 (2021-01-27) - Changelog","doc":"This release introduces a deprecation for the default API guide implementation. Please check migration section below.\n\n#","ref":"CHANGELOG.html#v1-0-22-2021-01-27"},{"type":"extras","title":"Enhancements - Changelog","doc":"* [`PowPersistentSession.Plug.Cookie`] Now stores the user struct instead of clauses\n* [`PowPersistentSession.Plug.Base`] Now includes `:pow_config` in the store config\n* [`PowResetPassword.Plug`] Now includes `:pow_config` in the store config\n* [`Pow.Plug.Base`] Now includes `:pow_config` in the store config\n* [`Pow.Operations`] Added `Pow.Operations.reload/2` to reload structs\n* [`PowPersistentSession.Store.PersistentSessionCache`] Update `PowPersistentSession.Store.PersistentSessionCache.get/2` to reload the user using `Pow.Operations.reload/2`\n* [`Pow.Store.CredentialsCache`] Now support `reload: true` configuration so once fetched from the cache the user object will be reloaded through the context module\n\n#","ref":"CHANGELOG.html#enhancements"},{"type":"extras","title":"Documentation - Changelog","doc":"* Updated the [API guide](guides/api.md) as it's no longer necessary to load the user struct\n\n#","ref":"CHANGELOG.html#documentation"},{"type":"extras","title":"Migration - Changelog","doc":"If you've used an API setup for previous version, you'll see the warning ``PowPersistentSession.Store.PersistentSessionCache.get/2 call without `:pow_config` in second argument is deprecated, refer to the API guide.``. It's recommended to replace your `APIAuthPlug` with the updated version in the API guide.\n\nThe larger refactor of cache setup in Pow `v1.0.22` means that user struct is always expected to be passed in and returned by the stores, so it is no longer necessary to load the user in the API plug. The `PowPersistentSession.Store.PersistentSessionCache` has fallback logic to handle the deprecated clauses keyword list, and will load the user correctly.","ref":"CHANGELOG.html#migration"},{"type":"extras","title":"v1.0.21 (2020-09-13) - Changelog","doc":"#","ref":"CHANGELOG.html#v1-0-21-2020-09-13"},{"type":"extras","title":"Enhancements - Changelog","doc":"* [`Pow.Plug.Base`] Will now use the existing `:pow_config` in the `conn` when no plug options has been set\n* [`PowInvitation.Phoenix.InvitationController`] Fixed bug where user was incorrectly redirected to the show action with unsigned token when user struct has no e-mail\n* [`Pow.Ecto.Schema`] Now only emits warning for primitive Ecto types\n\n#","ref":"CHANGELOG.html#enhancements"},{"type":"extras","title":"Bug fixes - Changelog","doc":"* [`PowEmailConfirmation.Ecto.Schema`] `PowEmailConfirmation.Ecto.Schema.changeset/3` no longer sets the email to the unconfirmed email when the same email change is set twice\n* [`Pow.Extension.Phoenix.Messages`] Fixed fallback message dializer warning\n* [`Pow.Ecto.Context`] Fixed bug where the macro didn't add `:users_context` to the Pow config in the module resulting in `Pow.Ecto.Context.get_by/2` being called instead of `get_by/1` in the custom context\n* [`Pow.Ecto.Schema.Changeset`] The `Pow.Ecto.Schema.Changeset.validate_email/1` method has been improved per specifications to support wider unicode support, fully-qualified domain validation, and comments","ref":"CHANGELOG.html#bug-fixes"},{"type":"extras","title":"v1.0.20 (2020-04-22) - Changelog","doc":"Now supports Phoenix 1.5, and requires Elixir 1.7 or higher.\n\n#","ref":"CHANGELOG.html#v1-0-20-2020-04-22"},{"type":"extras","title":"Enhancements - Changelog","doc":"* [`Mix.Tasks.Pow.Extension.Phoenix.Gen.Templates`] `mix pow.extension.phoenix.gen.templates` now dynamically loads template list from the extension base module\n* [`PowResetPassword.Plug`] `PowResetPassword.Plug.load_user_by_token/2` now sets a `:pow_reset_password_decoded_token` key in `conn.private` that will be used in `PowResetPassword.Plug.update_user_password/2`","ref":"CHANGELOG.html#enhancements"},{"type":"extras","title":"v1.0.19 (2020-03-13) - Changelog","doc":"**Warning:** This release will now sign and verify all tokens, causing previous tokens to no longer work. Any sessions and persistent sessions will be invalidated.\n\n#","ref":"CHANGELOG.html#v1-0-19-2020-03-13"},{"type":"extras","title":"Enhancements - Changelog","doc":"* [`Pow.Plug.Session`] Now sets a global lock when renewing the session\n* [`PowPersistentSession.Plug.Cookie`] Now sets a global lock when authenticating the user\n* [`PowEmailConfirmation.Plug`] Added `PowEmailConfirmation.Plug.sign_confirmation_token/2` to sign the `email_confirmation_token` to prevent timing attacks\n* [`PowEmailConfirmation.Plug`] Added `PowEmailConfirmation.Plug.load_user_by_token/2` to verify the signed `email_confirmation_token` to prevent timing attacks\n* [`PowEmailConfirmation.Plug`] Added `PowEmailConfirmation.Plug.confirm_email/2` with map as second argument\n* [`PowInvitation.Plug`] Added `PowInvitation.Plug.sign_invitation_token/2` to sign the `invitation_token`\n* [`PowInvitation.Plug`] Added `PowInvitation.Plug.load_invited_user_by_token/2` to verify the signed `invitation_token` to prevent timing attacks\n* [`PowResetPassword.Plug`] Changed `PowResetPassword.Plug.create_reset_token/2` to sign the `:token`\n* [`PowResetPassword.Plug`] Added `PowResetPassword.Plug.load_user_by_token/2` to verify the signed token to prevent timing attacks\n* [`PowResetPassword.Plug`] Changed `PowResetPassword.Plug.update_user_password/2` so it decodes the signed token\n* [`PowPersistentSession.Plug.Cookie`] Now uses signed tokens to prevent timing attacks\n* [`Pow.Plug.Session`] Now uses signed session ID's to prevent timing attacks\n* [`Pow.Plug`] Added `Pow.Plug.sign_token/4` to sign tokens\n* [`Pow.Plug`] Added `Pow.Plug.verify_token/4` to decode and verify signed tokens\n* [`Pow.Plug.MessageVerifier`] Added `Pow.Plug.MessageVerifier` module to sign and verify messages\n* [`PowEmailConfirmation.Ecto.Context`] Added `PowEmailConfirmation.Ecto.Context.confirm_email/3`\n* [`PowEmailConfirmation.Ecto.Schema`] Added `confirm_email_changeset/2` and `pow_confirm_email_changeset/2` to the macro\n* [`PowEmailConfirmation.Ecto.Schema`] Added `PowEmailConfirmation.Ecto.Schema.confirm_email_changeset/2`\n* [`PowInvitation.Ecto.Schema`] Added `accept_invitation_changeset/2` and `pow_accept_invitation_changeset/2` to the macro\n* [`PowResetPassword.Ecto.Schema`] Added `reset_password_changeset/2` and `pow_reset_password_changeset/2` to the macro\n* [`Pow.Ecto.Schema`] Now emits a warning instead of raising error with missing fields/associations\n\n#","ref":"CHANGELOG.html#enhancements"},{"type":"extras","title":"Deprecations - Changelog","doc":"* [`PowEmailConfirmation.Plug`] `PowEmailConfirmation.Plug.confirm_email/2` with token param as second argument has been deprecated in favor of `PowEmailConfirmation.Plug.load_user_by_token/2`, and `PowEmailConfirmation.Plug.confirm_email/2` with map as second argument\n* [`PowInvitation.Plug`] `PowInvitation.Plug.invited_user_from_token/2` has been deprecated in favor of `PowInvitation.Plug.load_invited_user_by_token/2`\n* [`PowInvitation.Plug`] `PowInvitation.Plug.assign_invited_user/2` has been deprecated\n* [`PowResetPassword.Plug`] `PowResetPassword.Plug.user_from_token/2` has been deprecated in favor of `PowResetPassword.Plug.load_user_by_token/2`\n* [`PowResetPassword.Plug`] `PowResetPassword.Plug.assign_reset_password_user/2` has been deprecated\n* [`PowEmailConfirmation.Ecto.Context`] `PowEmailConfirmation.Ecto.Context.confirm_email/2` deprecated in favor of `PowEmailConfirmation.Ecto.Context.confirm_email/3`\n* [`PowEmailConfirmation.Ecto.Schema`] `PowEmailConfirmation.Ecto.Schema.confirm_email_changeset/1` deprecated in favor of `PowEmailConfirmation.Ecto.Schema.confirm_email_changeset/2`\n\n#","ref":"CHANGELOG.html#deprecations"},{"type":"extras","title":"Documentation - Changelog","doc":"* Updated the [API guide](guides/api.md) with signed tokens","ref":"CHANGELOG.html#documentation"},{"type":"extras","title":"v1.0.18 (2020-02-14) - Changelog","doc":"#","ref":"CHANGELOG.html#v1-0-18-2020-02-14"},{"type":"extras","title":"Bug fixes - Changelog","doc":"* [`Pow.Phoenix.Routes`] Fixed bug where callback route methods is not using the overridden method\n* [`PowPersistentSession.Plug.Cookie`] `PowPersistentSession.Plug.Cookie.delete/2` now correctly pulls token during `:before_send` callback\n* [`Pow.Plug.Session`] `Pow.Plug.Session.delete/2` now correctly pulls session id during `:before_send` callback so `PowEmailConfirmation` will remove set session","ref":"CHANGELOG.html#bug-fixes"},{"type":"extras","title":"v1.0.17 (2020-02-04) - Changelog","doc":"#","ref":"CHANGELOG.html#v1-0-17-2020-02-04"},{"type":"extras","title":"Enhancements - Changelog","doc":"* [`Pow.Ecto.Context`] Calls to `Pow.Ecto.Context.get_by/2` replaced with `Pow.Operations.get_by/2` so custom users context module can be used. The following methods has been updated:\n  * `Pow.Ecto.Context.authenticate/2`\n  * `PowEmailConfirmation.Ecto.Context.get_by_confirmation_token/2`\n  * `PowInvitation.Ecto.Context.get_by_invitation_token/2`\n  * `PowResetPassword.Ecto.Context.get_by_email/2`\n* [`Pow.Ecto.Schema.Changeset`] `Pow.Ecto.Schema.Changeset.confirm_password_changeset/3` now adds the default `Ecto.Changeset.validate_confirmation/3` error instead of the previous `not same as password` error\n* [`Pow.Ecto.Schema.Changeset`] `Pow.Ecto.Schema.Changeset.confirm_password_changeset/3` now uses the `Ecto.Changeset.validate_confirmation/3` for validation and expects `:password_confirmation` instead of `:confirm_password` in params\n* [`Pow.Ecto.Schema.Changeset`] `Pow.Ecto.Schema.Changeset.new_password_changeset/3` now only requires the `:password_hash` if there have been no previous errors set in the changeset\n* [`Pow.Ecto.Schema`] No longer adds `:confirm_password` virtual field\n* [`Pow.Ecto.Schema`] Now has an `@after_compile` callback that ensures all required fields has been defined\n* [`PowInvitation.Phoenix.InvitationView`] Now renders `:password_confirmation` field instead of `:confirm_password`\n* [`PowResetPassword.Phoenix.ResetPasswordView`] Now renders `:password_confirmation` field instead of `:confirm_password`\n* [`Pow.Phoenix.RegistrationView`] Now renders `:password_confirmation` field instead of `:confirm_password`\n* [`PowEmailConfirmation.Ecto.Schema`] No longer validates if `:email` has been taken before setting `:unconfirmed_email`\n* [`PowEmailConfirmation.Phoenix.ControllerCallbacks`] Now prevents user enumeration for `PowInvitation.Phoenix.InvitationController.create/2`\n* [`PowPersistentSession.Plug.Cookie`] Changed default cookie name to `persistent_session`\n* [`PowPersistentSession.Plug.Cookie`] Removed renewal of cookie as the token will always expire\n* [`PowPersistentSession.Plug.Cookie`] No longer expires invalid cookies\n* [`Pow.Operations`] Added `Pow.Operations.fetch_primary_key_values/2`\n* [`PowPersistentSession.Plug.Base`] Now registers `:before_send` callbacks\n* [`PowPersistentSession.Plug.Cookie`] Now updates cookie and backend store in `:before_send` callback\n* [`Pow.Plug.Base`] Now registers `:before_send` callbacks\n* [`Pow.Plug.Session`] Now updates plug session and backend store in  `:before_send` callback\n* [`Pow.Plug`] Added `Pow.Plug.create/3`\n* [`Pow.Plug`] Added `Pow.Plug.delete/2`\n\n#","ref":"CHANGELOG.html#enhancements"},{"type":"extras","title":"Removed - Changelog","doc":"* [`PowResetPassword.Phoenix.ResetPasswordController`] Will no longer prevent information leak by checking if `PowEmailConfirmation` or registration routes are enabled; instead it'll by default prevent user enumeration, but can be disabled if `pow_prevent_user_enumeration: false` is set in `conn.private`\n\n#","ref":"CHANGELOG.html#removed"},{"type":"extras","title":"Bug fixes - Changelog","doc":"* [`PowPersistentSession.Plug.Base`] With custom `:persistent_session_store` now falls back to `:cache_store_backend` configuration option\n* [`PowResetPassword.Plug`] With custom `:reset_password_token_store` now falls back to `:cache_store_backend` configuration option\n* [`Pow.Plug.Base`] With custom `:credentials_cache_store` now falls back to `:cache_store_backend` configuration option\n\n#","ref":"CHANGELOG.html#bug-fixes"},{"type":"extras","title":"Deprecations - Changelog","doc":"* [`Pow.Ecto.Changeset`] `Pow.Ecto.Schema.Changeset.confirm_password_changeset/3` has deprecated use of `:confirm_password` in params in favor of `:password_confirmation`\n* [`Pow.Plug.Session`] `:session_store` option has been renamed to `:credentials_cache_store`\n* [`Pow.Plug`] `Pow.Plug.clear_authenticated_user/1` deprecated in favor of `Pow.Plug.delete/1`","ref":"CHANGELOG.html#deprecations"},{"type":"extras","title":"v1.0.16 (2020-01-07) - Changelog","doc":"**Note:** This release contains an important security fix.\n\n#","ref":"CHANGELOG.html#v1-0-16-2020-01-07"},{"type":"extras","title":"Enhancements - Changelog","doc":"* [`PowPersistentSession.Plug.Cookie`] Now supports `:persistent_session_cookie_opts` to customize any options that will be passed on to `Plug.Conn.put_resp_cookie/4`\n* [`PowResetPassword.Phoenix.ResetPasswordController`] Now uses `PowResetPassword.Phoenix.Messages.maybe_email_has_been_sent/1` with a generic response that tells the user the email has been sent only if an account was found\n* [`PowResetPassword.Phoenix.ResetPasswordController`] When a user doesn't exist will now return success message if `PowEmailConfirmation` extension is enabled\n* [`PowResetPassword.Phoenix.Messages`] Added `PowResetPassword.Phoenix.Messages.maybe_email_has_been_sent/1` and let `PowResetPassword.Phoenix.Messages.email_has_been_sent/1` fall back to it\n* [`PowEmailConfirmation.Phoenix.ControllerCallbacks`] When a user tries to sign up and the email has already been taken the default e-mail confirmation required message will be shown\n* [`Pow.Plug.Session`] Now renews the Plug session each time the Pow session is created or rolled\n\n#","ref":"CHANGELOG.html#enhancements"},{"type":"extras","title":"Bug fixes - Changelog","doc":"* [`Pow.Ecto.Schema.Changeset`] Fixed bug where `Pow.Ecto.Schema.Changeset.user_id_field_changeset/3` update with `nil` value caused an exception to be raised\n* [`PowPersistentSession.Plug.Cookie`] Now expires the cookie 10 seconds after the last request when authenticating to prevent multiple simultaneous requests deletes the cookie immediately\n\n#","ref":"CHANGELOG.html#bug-fixes"},{"type":"extras","title":"Documentation - Changelog","doc":"* Added mailer rate limitation section to [production checklist guide](guides/production_checklist.md)\n* [`Pow.Plug.Session`] Added section on session expiration to the docs\n* Updated instructions in [umbrella project guide](guides/umbrella_project.md) to Elixir 1.9\n* [`Pow.Store.Backend.Base`] Updated usage example with Cachex\n* Added [security practices page](guides/security_practices.md)","ref":"CHANGELOG.html#documentation"},{"type":"extras","title":"v1.0.15 (2019-11-20) - Changelog","doc":"#","ref":"CHANGELOG.html#v1-0-15-2019-11-20"},{"type":"extras","title":"Enhancements - Changelog","doc":"* [`Pow.Extension.Base`] Extensions are now expected to have a base module with compile-time information whether certain modules are available to prevent unnecessary `Code.ensure_compiled?/1` calls:\n  * Added `Pow.Extension.Base` module\n  * Added `PowEmailConfirmation` module\n  * Added `PowInvitation` module\n  * Added `PowPersistentSession` module\n  * Added `PowResetPassword` module\n* [`PowPersistentSession.Plug.Cookie`] Added support for custom metadata:\n  * `PowPersistentSession.Plug.Cookie.create/3` now stores a metadata keyword list that can be populated\n  * `PowPersistentSession.Plug.Cookie.create/3` will now, instead of adding `:session_fingerprint` to the metadata, populate the `:session_metadata` keyword list with `:fingerprint`\n  * `PowPersistentSession.Plug.Cookie.authenticate/2` will now populate session metadata with what exists in `:session_metadata` key for the persistent session metadata\n  * `PowPersistentSession.Plug.Cookie.create/3` now ensures to delete the previous persistent session first, if one is found in cookies\n* [`Pow.Extension.Config`] Added `Pow.Extension.Config.extension_modules/2`\n\n#","ref":"CHANGELOG.html#enhancements"},{"type":"extras","title":"Bug fixes - Changelog","doc":"* [`Router.Phoenix.Router`] Fixed bug where resource routes were not filtered correctly according to the path bindings\n\n#","ref":"CHANGELOG.html#bug-fixes"},{"type":"extras","title":"Deprecations - Changelog","doc":"* [`Pow.Extension.Config`] Deprecated `Pow.Extension.Config.discover_modules/2`","ref":"CHANGELOG.html#deprecations"},{"type":"extras","title":"v1.0.14 (2019-10-29) - Changelog","doc":"#","ref":"CHANGELOG.html#v1-0-14-2019-10-29"},{"type":"extras","title":"Changes - Changelog","doc":"* Changed minmum password length to 8 (OWASP/NIST recommendations)\n* `Pow.Phoenix.Router` now only filters routes that has equal number of bindings\n* `Pow.Phoenix.Routes.user_not_authenticated_path/1` now only puts the `:request_path` param if the request is using \"GET\" method\n* The stores has been refactored so the command conforms with ETS store. This means that put commands now accept `{key, value}` record element(s), and keys may be list for easier lookup.\n  * `Pow.Store.Backend.Base` behaviour now requires to;\n    * Accept `Pow.Store.Backend.Base.record/0` values for `put/2`\n    * Accept `Pow.Store.Backend.Base.key/0` for `delete/2` and `get/2`\n    * Implement `all/2`\n    * Remove `keys/1`\n    * Remove `put/3`\n  * `Pow.Store.Backend.EtsCache` now uses `:ordered_set` instead of `:set` for efficiency\n  * `Pow.Store.Backend.MnesiaCache` now uses `:ordered_set` instead of `:set` for efficiency\n  * `Pow.Store.Backend.MnesiaCache` will delete all binary key records when initialized\n  * `Pow.Store.Base` behaviour now requires to;\n    * Accept erlang term value for keys in all methods\n    * Implement `put/3` instead of `put/4`\n    * Implement `delete/2` instead of `put/3`\n    * Implement `get/2` instead of `put/3`\n    * Remove `keys/2`\n  * `Pow.Store.Base.all/3` added\n  * `Pow.Store.Base.put/3` added\n  * `Pow.Store.Base` will use binary key rather than key list if `all/2` doesn't exist in the backend cache\n  * Added `Pow.Store.CredentialsCache.users/2`\n  * Added `Pow.Store.CredentialsCache.sessions/2`\n  * `Pow.Store.CredentialsCache` now adds a session key rather than appending to a list for the user key to prevent race condition\n* `Pow.Plug.Session.create/3` now stores a keyword list with metadata for the session rather than just a timestamp\n* `Pow.Plug.Session.fetch/2` and `Pow.Plug.Session.create/3` now assigns `:pow_session_metadata` in `conn.private` with the session metadata\n* `Pow.Plug.Session.create/3` will use the metadata found in `conn.private[:pow_session_metadata]` if it exists and otherwise add a randomly unique id for `:fingerprint`\n* `PowPersistentSession.Plug.Cookie.create/3` will use the value of `conn.private[:pow_session_metadata][:fingerprint]` if it exists as `:session_fingerprint` in the persistent session metadata\n* `PowPersistentSession.Plug.Cookie.authenticate/2` will assign `:fingerprint` to `conn.private[:pow_session_metadata]` if it exists in the persistent session metadata\n* `Pow.Store.CredentialsCache.put/3` will invalidate any other sessions with the same `:fingerprint` if any is set in session metadata\n* `PowResetPassword.Phoenix.ResetPasswordController.create/2` when a user doesn't exist will now only return success message if the registration routes has been disabled, otherwise the form with an error message will be returned\n* Added `PowResetPassword.Phoenix.Messages.user_not_found/1`\n\n#","ref":"CHANGELOG.html#changes"},{"type":"extras","title":"Bug fixes - Changelog","doc":"* Fixed bug where `Pow.Store.CredentialsCache` wasn't used due to how `Pow.Store.Base` macro worked\n* Fixed bug where `PowEmailConfirmation.Phoenix.ControllerCallbacks` couldn't deliver email\n\n#","ref":"CHANGELOG.html#bug-fixes"},{"type":"extras","title":"Deprecations - Changelog","doc":"* Deprecated `Pow.Store.Backend.EtsCache.keys/1`\n* Deprecated `Pow.Store.Backend.EtsCache.put/3`\n* Deprecated `Pow.Store.Backend.MnesiaCache.keys/1`\n* Deprecated `Pow.Store.Backend.MnesiaCache.put/3`\n* Deprecated `Pow.Store.Base.keys/2`\n* Deprecated `Pow.Store.Base.put/4`\n* Deprecated `Pow.Store.CredentialsCache.user_session_keys/3`\n* Deprecated `Pow.Store.CredentialsCache.sessions/3`","ref":"CHANGELOG.html#deprecations"},{"type":"extras","title":"v1.0.13 (2019-08-25) - Changelog","doc":"* Updated `PowEmailConfirmation.Ecto.Schema.changeset/3` so;\n  * when `:email` is identical to `:unconfirmed_email` it won't generate new `:email_confirmation_token`\n  * when `:email` is identical to the persisted `:email` value both `:email_confirmation_token` and `:unconfirmed_email` will be set to `nil`\n  * when there is no `:email` value in the params nothing happens\n* Updated `PowEmailConfirmation.Ecto.Schema.confirm_email_changeset/1` so now `:email_confirmation_token` is set to `nil`\n* Updated `Pow.Ecto.Schema.Changeset.user_id_field_changeset/3` so the e-mail validator now accepts unicode e-mails\n* Added `PowEmailConfirmation.Ecto.Context.current_email_unconfirmed?/2` and `PowEmailConfirmation.Plug.pending_email_change?/1`\n* Added `:email_validator` configuration option to `Pow.Ecto.Schema.Changeset`\n* Added `Pow.Ecto.Schema.Changeset.validate_email/1`\n* Fixed bug in `PowEmailConfirmation.Phoenix.ControllerCallbacks.send_confirmation_email/2` where the confirmation e-mail wasn't send to the updated e-mail address","ref":"CHANGELOG.html#v1-0-13-2019-08-25"},{"type":"extras","title":"v1.0.12 (2019-08-16) - Changelog","doc":"* Added API integration guide\n* Added `:reset_password_token_store` configuration setting\n* To prevent timing attacks, `Pow.Ecto.Context.authenticate/2` now verifies password on a blank user struct when no user can be found for the provided user id, but will always return nil. The blank user struct has a nil `:password_hash` value. The struct will be passed along with a blank password to the `verify_password/2` method in the user schema module.\n* To prevent timing attacks, when `Pow.Ecto.Schema.Changeset.verify_password/3` receives a struct with a nil `:password_hash` value, it'll hash a blank password, but always return false.\n* To prevent timing attacks, the UUID is always generated in `PowResetPassword.Plug.create_reset_token/2` whether the user exists or not.\n* `PowPersistentSession.Plug.Base` now accepts `:persistent_session_ttl` which will pass the TTL to the cache backend and used for the max age of the sesion cookie in `PowPersistentSession.Plug.Cookie`\n* Deprecated `:persistent_session_cookie_max_age` configuration setting\n* `Pow.Store.Backend.MnesiaCache` can now auto join clusters\n* `Pow.Store.Backend.MnesiaCache.Unsplit` module added for self-healing after network split\n* Removed `:nodes` config option for `Pow.Store.Backend.MnesiaCache`","ref":"CHANGELOG.html#v1-0-12-2019-08-16"},{"type":"extras","title":"v1.0.11 (2019-06-13) - Changelog","doc":"* Fixed bug in router filters with Phoenix 1.4.7","ref":"CHANGELOG.html#v1-0-11-2019-06-13"},{"type":"extras","title":"v1.0.10 (2019-06-09) - Changelog","doc":"* Prevent browser cache of `Pow.Phoenix.SessionController.new/2`, `Pow.Phoenix.RegistrationController.new/2` and `PowInvitation.Phoenix.InvitationController.edit/2` by setting \"Cache-Control\" header unless it already has been customized\n* All links in docs generated with `mix docs` and on [hexdocs.pm](http://hexdocs.pm/pow/) now works\n* Generated docs now uses lower case file name except for `README`, `CONTRIBUTING` and `CHANGELOG`\n* Removed duplicate call for `Pow.Plug.Session.delete/2` in `Pow.Plug.Sesssion.create/3`","ref":"CHANGELOG.html#v1-0-10-2019-06-09"},{"type":"extras","title":"v1.0.9 (2019-06-04) - Changelog","doc":"#","ref":"CHANGELOG.html#v1-0-9-2019-06-04"},{"type":"extras","title":"Changes - Changelog","doc":"* `Pow.Phoenix.Router` will now only add specific routes if there is no matching route already defined\n* Added `Pow.Plug.get_plug/1` and instead of `:mod`, `:plug` is used in config\n* `Pow.Ecto.Context.authenticate/2` now returns nil if user id or password is nil\n\n#","ref":"CHANGELOG.html#changes"},{"type":"extras","title":"Bug fixes - Changelog","doc":"* Fixed bug with exception raised in `Pow.Ecto.Schema.normalize_user_id_field_value/1` when calling `Pow.Ecto.Context.get_by/2` with a non binary user id\n* Fixed bug with exception raised in `Pow.Ecto.Schema.normalize_user_id_field_value/1` when calling `Pow.Ecto.Context.authenticate/2` with a non binary user id\n\n#","ref":"CHANGELOG.html#bug-fixes"},{"type":"extras","title":"Deprecations - Changelog","doc":"* Deprecated `Pow.Plug.get_mod/1`\n* Removed call to `Pow.Ecto.Context.repo/1`","ref":"CHANGELOG.html#deprecations"},{"type":"extras","title":"v1.0.8 (2019-05-24) - Changelog","doc":"#","ref":"CHANGELOG.html#v1-0-8-2019-05-24"},{"type":"extras","title":"Changes - Changelog","doc":"* Added support for layout in mails with `Pow.Phoenix.Mailer.Mail` by setting `conn.private[:pow_mailer_layout]` same way as the Phoenix layout with `conn.private[:phoenix_layout]`\n* Added `:prefix` repo opts support to use in multitenant apps\n* Removed `@changeset.data.__struct__.pow_user_id_field()` in template in favor of using `Pow.Ecto.Schema.user_id_field/1`\n\n#","ref":"CHANGELOG.html#changes"},{"type":"extras","title":"Bug fixes - Changelog","doc":"* Fixed bug in `Pow.Ecto.Schema.Changeset.current_password_changeset/3` where an exception would be thrown if the virtual `:current_password` field of the user struct was set and either the `:current_password` change was blank or identical\n\n#","ref":"CHANGELOG.html#bug-fixes"},{"type":"extras","title":"Deprecations - Changelog","doc":"* Deprecated `Mix.Pow.Ecto.Migration.create_migration_files/3` and moved it to `Mix.Pow.Ecto.Migration.create_migration_file/3`\n* Deprecated `Pow.Ecto.Context.repo/1` and moved it to `Pow.Config.repo!/1`\n* Deprecated `Pow.Ecto.Context.user_schema_mod/1` and moved it to `Pow.Config.user!/1`","ref":"CHANGELOG.html#deprecations"},{"type":"extras","title":"v1.0.7 (2019-05-01) - Changelog","doc":"* Fixed bug with Phoenix 1.4.4 scoped routes","ref":"CHANGELOG.html#v1-0-7-2019-05-01"},{"type":"extras","title":"v1.0.6 (2019-04-19) - Changelog","doc":"* Fixed bug where custom layout setting raised exception in `Pow.Phoenix.ViewHelpers.layout/1`\n* Prevent users from changing their email to one already taken when the PowEmailConfirmation extension has been enabled","ref":"CHANGELOG.html#v1-0-6-2019-04-19"},{"type":"extras","title":"v1.0.5 (2019-04-09) - Changelog","doc":"* Added `extension_messages/1` to extension controllers and callbacks\n* Improved feedback for when no templates are generated for an extension with `mix pow.extension.phoenix.gen.templates` and `mix pow.extension.phoenix.mailer.gen.templates` tasks\n* Error flash is no longer overridden in `Pow.Phoenix.PlugErrorHandler` if the error message is nil\n* Fixed bug in the migration generator where `references/2` wasn't called with options\n* Support any `:plug` version below `2.0.0`\n* Deprecated `Pow.Extension.Ecto.Context.Base`","ref":"CHANGELOG.html#v1-0-5-2019-04-09"},{"type":"extras","title":"v1.0.4 (2019-03-13) - Changelog","doc":"* Added `PowInvitation` to the `mix pow.extension.phoenix.gen.templates` and `mix pow.extension.phoenix.mailer.gen.templates` tasks\n* Fixed issue in umbrella projects where extensions wasn't found in environment configuration\n* Fixed so `:namespace` environment config can be used as web app module name\n* Shell instructions will only be printed if the configuration is missing\n* Now requires that `:ecto` or `:phoenix` are included in the dependency list for the app to run respective mix tasks\n* Deprecated `Mix.Pow.context_app/0`\n* Deprecated `Mix.Pow.ensure_dep!/3`\n* Deprecated `Mix.Pow.context_base/1`","ref":"CHANGELOG.html#v1-0-4-2019-03-13"},{"type":"extras","title":"v1.0.3 (2019-03-09) - Changelog","doc":"#","ref":"CHANGELOG.html#v1-0-3-2019-03-09"},{"type":"extras","title":"Changes - Changelog","doc":"* Added `PowInvitation` extension\n* Added support in `Pow.Ecto.Schema` for Ecto associations fields\n* Added support for adding custom methods with `Pow.Extension.Ecto.Schema` through `__using__/1` macro in extension ecto schema module\n* Help information raised with invalid schema arguments for `pow.install`, `pow.ecto.install`, `pow.ecto.gen.migration`, and `pow.ecto.gen.schema` mix tasks\n* `PowEmailConfirmation` now redirects unconfirmed users to `after_registration_path/1` or `after_sign_in_path/1` rather than `pow_session_path(conn, :new)`\n\n#","ref":"CHANGELOG.html#changes"},{"type":"extras","title":"Bug fixes - Changelog","doc":"* Correct shell instructions for `mix pow.install` task with custom schema\n* Fixed bug in `Pow.Extension.Phoenix.Router.Base` and `Pow.Extension.Phoenix.Messages` where the full extension name wasn't used to namespace methods\n\n#","ref":"CHANGELOG.html#bug-fixes"},{"type":"extras","title":"Deprecations - Changelog","doc":"* Deprecated `Pow.Extension.Config.underscore_extension/1`\n* Deprecated `PowResetPassword.Ecto.Context.password_changeset/2`\n* Deprecated `Pow.Ecto.Schema.filter_new_fields/2`\n* Deprecated `:messages_backend_fallback` setting for extension controllers\n* Removed deprecated macro `router_helpers/1` in `Pow.Phoenix.Controller`","ref":"CHANGELOG.html#deprecations"},{"type":"extras","title":"v1.0.2 (2019-02-28) - Changelog","doc":"* Added flash error message about e-mail confirmation for when user changes e-mail with PowEmailConfirmation enabled\n* Added `new_password_changeset/3` and `confirm_password_changeset/3` to `Pow.Ecto.Schema.Changeset`\n* Redis cache store backend guide\n* Correct shell instructions for `mix pow.phoenix.gen.templates` task\n* Only load environment config in `Pow.Config.get/3` when no key is set in the provided config\n* Fixed issue in `Pow.Store.Backend.MnesiaCache.keys/1` and `Pow.Store.Backend.EtsCache.keys/1` so they now return keys without namespace\n* `Pow.Store.Backend.MnesiaCache.put/3` now raises an error if TTL is not provided\n\n#","ref":"CHANGELOG.html#v1-0-2-2019-02-28"},{"type":"extras","title":"Breaking changes - Changelog","doc":"* `PowResetPassword.Plug.reset_password_token/1` has been removed","ref":"CHANGELOG.html#breaking-changes"},{"type":"extras","title":"v1.0.1 (2019-01-27) - Changelog","doc":"* `pow.extension.ecto.gen.migrations` mix task will output warning when a migration file won't be generated for any particular extension\n* Leading and trailing whitespace is removed from the user id field value (in addition to forced lower case)\n* An exception is raised when `pow_routes/0` or `pow_extension_routes/0` are used inside router scopes with aliases\n* Mail view templates assigns now has `[user: user, conn: conn]` along with the template specific assigns\n* Mail view subject methods now gets the same assigns passed as mail view template assigns instead of only `[conn: conn]`\n* Added `pow_registration_routes/0`, `pow_session_routes/0` and `pow_scope/1` macros to the router module\n* Added guide on how to disable registration","ref":"CHANGELOG.html#v1-0-1-2019-01-27"},{"type":"extras","title":"v1.0.0 (2018-11-18) - Changelog","doc":"* Phoenix 1.4 support\n* Ecto 3.0 support","ref":"CHANGELOG.html#v1-0-0-2018-11-18"},{"type":"extras","title":"PowEmailConfirmation","doc":"# PowEmailConfirmation\n\nThis extension will send an e-mail confirmation link when the user registers, and when the user changes their e-mail. It requires that the user schema has an `:email` field.\n\nUsers won't be signed in when they register, and can't sign in until the e-mail has been confirmed. The confirmation e-mail will be sent every time the sign in fails. The user will be redirected to `after_registration_path/1` and `after_sign_in_path/1` accordingly.\n\nTo prevent user enumeration, the user will see the same confirmation required message if the account couldn't be created due to unique constraint error on `:email`. No e-mail will be sent. If `pow_prevent_user_enumeration: false` is set in `conn.private` the form with error will be shown instead.\n\nWhen users updates their e-mail, it won't be changed until the user has confirmed the new e-mail by clicking the e-mail confirmation link. The confirmation will fail if the `:email` is already in use for another account. If `PowInvitation` is used then the same logic applies when a user accepts an invitation changing their e-mail address in the process.","ref":"pow_email_confirmation.html"},{"type":"extras","title":"Installation - PowEmailConfirmation","doc":"Follow the instructions for extensions in [README.md](../../../README.md#add-extensions-support), and set `PowEmailConfirmation` in the `:extensions` list.","ref":"pow_email_confirmation.html#installation"},{"type":"extras","title":"Configuration - PowEmailConfirmation","doc":"Add the following section to your `WEB_PATH/controllers/pow/registration_html/edit.html.heex` template (you may need to generate the templates first) after the `pow_user_id_field` field:\n\n```elixir\n \n  <.icon name=\"hero-exclamation-circle-mini\" class=\"mt-0.5 w-5 h-5 flex-none\" />\n  Click the link in the confirmation email to change your email to  @changeset.data.unconfirmed_email) .\n \n```","ref":"pow_email_confirmation.html#configuration"},{"type":"extras","title":"Prevent persistent session sign in - PowEmailConfirmation","doc":"To prevent that `PowPersistentSession` creates a new persistent session when the email hasn't been confirmed, `PowEmailConfirmation` should be placed first in the extensions list. It'll halt the connection.","ref":"pow_email_confirmation.html#prevent-persistent-session-sign-in"},{"type":"extras","title":"Test and seed - PowEmailConfirmation","doc":"If you want your user to be automatically confirmed in test and seed, you just have to call: `PowEmailConfirmation.Ecto.Context.confirm_email(user, %{}, otp_app: :my_app)`\n\nYou can also update or insert the row directly and set `email_confirmed_at: DateTime.utc_now()`.","ref":"pow_email_confirmation.html#test-and-seed"},{"type":"extras","title":"Note on PowInvitation - PowEmailConfirmation","doc":"When a user is invited with [PowInvitation](../invitation/README.md), the email will only be required confirmed if the invited user decides to change their email when accepting the invitation.","ref":"pow_email_confirmation.html#note-on-powinvitation"},{"type":"extras","title":"PowInvitation","doc":"# PowInvitation\n\nThis extension will set up a basic invitation system where users can invite other users to join. If `:email` field exists on the user struct an e-mail is sent out with an invitation link. Otherwise a page with the invitation link is shown.\n\nInvited users are persisted in the database without a password. Only the user id will be validated when the user is invited, but `changeset/2` on your user schema will be used for when the user accepts the invitation.\n\nTo prevent user enumeration, the invited user will, to the inviter, appear as succesfully invited even if the user couldn't be created due to unique constraint error on `:email`. No e-mail will be sent out. If `pow_prevent_user_enumeration: false` is set in `conn.private` the form with error will be shown instead.\n\nAn invited user can change their e-mail when accepting the invitation. To prevent user enumeration `PowEmailConfirmation` extension can be enabled.","ref":"pow_invitation.html"},{"type":"extras","title":"Installation - PowInvitation","doc":"Follow the instructions for extensions in [README.md](../../../README.md#add-extensions-support), and set `PowInvitation` in the `:extensions` list.","ref":"pow_invitation.html#installation"},{"type":"extras","title":"Configuration - PowInvitation","doc":"There are numerous ways you can modify the invitation flow. Here's a few common setups to get your started.\n\n#","ref":"pow_invitation.html#configuration"},{"type":"extras","title":"Parent organization or team - PowInvitation","doc":"If your users belongs to a parent organization or team, you can set up the `invite_changeset/3` to carry over the id for invitations:\n\n```elixir\ndefmodule MyApp.Users.User do\n  # ...\n\n  def invite_changeset(user_or_changeset, invited_by, attrs) do\n    user_or_changeset\n    |> pow_invite_changeset(invited_by, attrs)\n    |> changeset_organization(invited_by)\n  end\n\n  defp changeset_organization(changeset, invited_by) do\n    Ecto.Changeset.change(changeset, organization_id: invited_by.organization_id)\n  end\nend\n```\n\n#","ref":"pow_invitation.html#parent-organization-or-team"},{"type":"extras","title":"Limit invitation based on role - PowInvitation","doc":"If you have different roles (e.g. [admin and user](../../../guides/user_roles.md)), you can limit the type of user who can invite others by using a plug and override the routes in your `router.ex`:\n\n```elixir\ndefmodule MyAppWeb.Router do\n  use MyAppWeb, :router\n  # ...\n\n  pipeline :admin_role do\n    plug MyAppWeb.EnsureRolePlug, :admin\n  end\n\n  scope \"/\", PowInvitation.Phoenix, as: \"pow_invitation\" do\n    pipe_through [:browser, :protected, :admin_role]\n\n    resources \"/invitations\", InvitationController, only: [:new, :create, :show]\n  end\n\n  # ... you would want `pow_extension_routes/0` with the default routes to be after this\nend\n```\n\nThe routes will override the default ones in `pow_extension_routes/0`.\n\n#","ref":"pow_invitation.html#limit-invitation-based-on-role"},{"type":"extras","title":"Limit registration - PowInvitation","doc":"If you wish to restrict signup to only invites, you can modify `router.ex` to exclude registration by using `pow_session_routes/0` in place of `pow_routes/0`:\n\n```elixir\ndefmodule MyAppWeb.Router do\n  use MyAppWeb, :router\n  # ...\n\n  scope \"/\" do\n    pipe_through :browser\n\n    pow_session_routes()\n    pow_extension_routes()\n  end\n\n  # ...\nend\n```\n\nYou need to  use custom template for the session controller, since by default it'll still have the link to registration. Read more in the [Disable registration guide](../../../guides/disable_registration.md).\n\n#","ref":"pow_invitation.html#limit-registration"},{"type":"extras","title":"Expire invited users - PowInvitation","doc":"Invited users will have a token set in the `:invitation_token` field and `:invitation_accepted_at` field set to nil. If you want to expire the invitation link you can run a background task to delete these users a certain time after `:inserted_at`.","ref":"pow_invitation.html#expire-invited-users"},{"type":"extras","title":"Note on PowEmailConfirmation - PowInvitation","doc":"[PowEmailConfirmation](../email_confirmation/README.md) will only require email confirmation if the invited user changes their email when accepting their invitation.","ref":"pow_invitation.html#note-on-powemailconfirmation"},{"type":"extras","title":"PowPersistentSession","doc":"# PowPersistentSession\n\nThis extension can reissue sessions by setting a cookie with a token that may be used exactly once to issue the session. The cookie and token will expire after 30 days. Once the session has been issued, a new cookie and token will be set that expires after another 30 days.","ref":"pow_persistent_session.html"},{"type":"extras","title":"Installation - PowPersistentSession","doc":"Follow the instructions for extensions in [README.md](../../../README.md#add-extensions-support), and set `PowPersistentSession` in the `:extensions` list.\n\nAdd the following plug after the pow session plug in your `WEB_PATH/endpoint.ex`:\n\n```elixir\ndefmodule MyAppWeb.Endpoint do\n  # ...\n\n  plug Pow.Plug.Session, otp_app: :my_app\n  plug PowPersistentSession.Plug.Cookie\n  #...\nend\n```","ref":"pow_persistent_session.html#installation"},{"type":"extras","title":"Configuration - PowPersistentSession","doc":"By default, the persistent session is automatically used if the extension has been enabled. If you wish to let the user manage this, you should add the following checkbox to the form in `WEB_PATH/controllers/pow/session_html/new.html.heex` (you may need to generate the templates first):\n\n```elixir\n<.input field={f[:persistent_session]} type=\"checkbox\" label=\"Keep me logged in\" />\n```","ref":"pow_persistent_session.html#configuration"},{"type":"extras","title":"PowResetPassword","doc":"# PowResetPassword\n\nThis extension will allow users to reset the password by sending an e-mail with a reset password link. It requires that the user schema has an `:email` field.\n\nTo prevent user enumeration attacks, the generic `PowResetPassword.Phoenix.Messages.maybe_email_has_been_sent/1` message is always shown when requesting password reset. If `pow_prevent_user_enumeration: false` is set in `conn.private` the form will be shown instead with the `PowResetPassword.Phoenix.Messages.user_not_found/1` message.","ref":"pow_reset_password.html"},{"type":"extras","title":"Installation - PowResetPassword","doc":"Follow the instructions for extensions in [README.md](../../../README.md#add-extensions-support), and set `PowResetPassword` in the `:extensions` list.","ref":"pow_reset_password.html#installation"},{"type":"extras","title":"Configuration - PowResetPassword","doc":"Add the following link to your `WEB_PATH/controllers/pow/session_html/new.html.heex` template (you may need to generate the templates first):\n\n```elixir\n<.link navigate={~p\"/reset-password/new\"} class=\"text-sm font-semibold\">Forgot your password?<./link>\n```","ref":"pow_reset_password.html#configuration"},{"type":"extras","title":"Why Pow","doc":"# Why Pow\n\nWhy should you use Pow instead of any other user management system? Let's take a look at what Pow does differently.","ref":"why_pow.html"},{"type":"extras","title":"Functional configuration - Why Pow","doc":"No global configuration!\n\nUnlike most alternative user management libraries, Pow is built to be a functional component in your app. You can have numerous separate Pow setups in the same app, e.g., a super admin backend and a regular user login.\n\nConfiguration can be passed to nearly all functions in runtime or compile time.","ref":"why_pow.html#functional-configuration"},{"type":"extras","title":"Modular - Why Pow","doc":"Pow has an explicit API for its Plug, Ecto and Phoenix modules. Any part can be removed entirely, or modified. Each of the main category modules has a clear separation of responsibilities that makes it easy to micro adjust the flow.","ref":"why_pow.html#modular"},{"type":"extras","title":"Low dependency requirement - Why Pow","doc":"Nearly everything is baked in. You won't get into annoying dependency conflicts!","ref":"why_pow.html#low-dependency-requirement"},{"type":"extras","title":"Extendable - Why Pow","doc":"Pow starts out simple: Session management and user registration.\n\nBut with Pow you've access to multiple extensions that covers most needs for user management: E-mail confirmation, reset password and long-term session (remember me). There's also a multi-provider library that can be used, e.g. with Twitter and Github.","ref":"why_pow.html#extendable"},{"type":"extras","title":"Developer friendly - Why Pow","doc":"With a clear API in mind, all instructions are written so it's easy to understand the basics of Pow. As you get your first app with Pow up and running, you'll understand the underlying mechanisms. Pow has extensive documentation in all its modules that will clearly show you how Pow works.\n\nExplicit rather than implicit.","ref":"why_pow.html#developer-friendly"},{"type":"extras","title":"Secure - Why Pow","doc":"The basis for security in Pow is industry practices and recommendations from, among others, NIST and OWASP. You can read more in the [README.md](../README.md#pow-security-practices) for specifics.","ref":"why_pow.html#secure"},{"type":"extras","title":"Production ready - Why Pow","doc":"There are several production apps successfully running Pow. From migration from Coherence to highly customized Pow setups.","ref":"why_pow.html#production-ready"},{"type":"extras","title":"Production checklist","doc":"# Production checklist\n\nBefore you deploy your Pow enabled app to production, you should take a look at the following checklist to ensure that your app is ready.\n\nThe list is not exhaustive, and you should take any appropriate additional steps for your particular setup.","ref":"production_checklist.html"},{"type":"extras","title":"REQUIRED: Use a persistent cache store - Production checklist","doc":"By default the `Pow.Store.Backend.EtsCache` will be used as the cache backend. In production, this would mean that all session data will be lost between deploys or server restarts. Furthermore, in clusters, the sessions will not be shared between nodes.\n\nYou should use a persistent (and possibly distributed) cache store like the `Pow.Store.Backend.MnesiaCache`.\n\nTo enable the Mnesia cache you should add it to your `application.ex` supervisor:\n\n```elixir\ndefmodule MyApp.Application do\n  use Application\n\n  def start(_type, _args) do\n    children = [\n      MyApp.Repo,\n      MyAppWeb.Endpoint,\n      Pow.Store.Backend.MnesiaCache\n      # # Or in a distributed system:\n      # {Pow.Store.Backend.MnesiaCache, extra_db_nodes: {Node, :list, []}},\n      # Pow.Store.Backend.MnesiaCache.Unsplit # Recover from netsplit\n    ]\n\n    opts = [strategy: :one_for_one, name: MyAppWeb.Supervisor]\n    Supervisor.start_link(children, opts)\n  end\n\n  # ...\nend\n```\n\nUpdate the config with `cache_store_backend: Pow.Store.Backend.MnesiaCache`.\n\nMnesia will store the database files in the directory `./Mnesia.NODE` in the current working directory where `NODE` is the node name. By default, this is `./Mnesia.nonode@nohost`. You may wish to change the location to a shared directory so you can roll deploys:\n\n```elixir\nconfig :mnesia, :dir, '/path/to/dir'\n```\n\n`:mnesia` should be added to `:extra_applications` in `mix.exs` for it to be included in releases.","ref":"production_checklist.html#required-use-a-persistent-cache-store"},{"type":"extras","title":"OPTIONAL: Validate that strong passwords are used - Production checklist","doc":"[NIST 800-63b](https://pages.nist.gov/800-63-3/sp800-63b.html#-5112-memorized-secret-verifiers) recommends that you reject passwords that are commonly-used, expected, or compromised. The guidelines explicitly mention the following methods to ensure strong passwords are used:\n\n> - Passwords obtained from previous breach corpuses.\n> - Dictionary words.\n> - Repetitive or sequential characters (e.g. ‘aaaaaa’, ‘1234abcd’).\n> - Context-specific words, such as the name of the service, the username, and derivatives thereof.\n\nYou can read how to handle password breach lookup and other NIST based validation rules [on the powauth.com website](https://powauth.com/guides/2019-09-14-password-breach-lookup-and-other-password-validation-rules.html).","ref":"production_checklist.html#optional-validate-that-strong-passwords-are-used"},{"type":"extras","title":"OPTIONAL: Use an appropriate password hash method - Production checklist","doc":"By default PBKDF2-SHA512 with 100,000 iterations is used for password hashing. This is what's [recommended by NIST 800-63b](https://pages.nist.gov/800-63-3/sp800-63b.html#-5112-memorized-secret-verifiers). If you are allowed to use other password hashing algorithms, then Argon2id is [considered a safer option](https://medium.com/@mpreziuso/password-hashing-pbkdf2-scrypt-bcrypt-and-argon2-e25aaf41598e).\n\nYou can easily change the password hashing method in Pow. Here's how you can use [comeonin with Argon2](https://github.com/riverrun/argon2_elixir):\n\n```elixir\ndefmodule MyApp.Users.User do\n  use Ecto.Schema\n  use Pow.Ecto.Schema,\n    password_hash_verify: {&Argon2.hash_pwd_salt/1,\n                           &Argon2.verify_pass/2}\n\n  # ...\nend\n```","ref":"production_checklist.html#optional-use-an-appropriate-password-hash-method"},{"type":"extras","title":"OPTIONAL: Rate limit authentication attempts - Production checklist","doc":"You should rate limit authentication attempts according to [NIST 800-63b](https://pages.nist.gov/800-63-3/sp800-63b.html#-5112-memorized-secret-verifiers). Pow doesn't include a rate limiter since this is better dealt with at the proxy or gateway side rather than the application side. The minimum requirement would be to rate limit to a maximum of 100 failed authentication attempts per IP.\n\nYou may also wish to [lock accounts](../guides/lock_users.md) that has had too many failed authentication attempts, or require a CAPTCHA to be solved before allowing new attempts.","ref":"production_checklist.html#optional-rate-limit-authentication-attempts"},{"type":"extras","title":"OPTIONAL: Rate limit e-mail delivery - Production checklist","doc":"There are no rate limits for any e-mails sent out with Pow, including `PowEmailConfirmation`, `PowInvitation` and `PowResetPassword` extensions. If you use a transactional e-mail service you have to make careful considerations to prevent resource usage attacks.\n\nRate limitation should either be handled at the service, or you may be able to set up rate limitation in the Pow mailer. For the latter, here's a simple example using [Hammer](https://github.com/ExHammer/hammer):\n\n```elixir\ndefmodule MyAppWeb.Pow.Mailer do\n  use Pow.Phoenix.Mailer\n\n  # ....\n\n  require Logger\n\n  @impl true\n  def process(email) do\n    case check_rate(email) do\n      {:allow, _count} -> deliver(email)\n      {:deny, _count}  -> Logger.warning(\"Mailer backend failed due to rate limitation: #{inspect(email)}\")\n    end\n  end\n\n  defp check_rate(%{to: email}) do\n    Hammer.check_rate_inc(\"email:#{email}\", :timer.minutes(1), 2, 1)\n  end\nend\n```\n\nIn the above, the e-mail delivery will be limited to two e-mails per minute for a single recipient, but you can use different criteria, e.g. limit for e-mails that have the same recipient and subject. It's strongly recommended to add tests where appropriate to ensure abuse is not possible.","ref":"production_checklist.html#optional-rate-limit-e-mail-delivery"},{"type":"extras","title":"Security practices","doc":"# Security practices\n\nSome of the below is based on [OWASP](https://www.owasp.org/) or [NIST SP800-63b](https://pages.nist.gov/800-63-3/sp800-63b.html) recommendations.","ref":"security_practices.html"},{"type":"extras","title":"User ID - Security practices","doc":"* The `user_id_field` value is always treated as case insensitive\n* If the `user_id_field` is `:email`, it'll be validated based on RFC 5322 (sections 3.2.3 and 3.4.1) and RFC 5321 with unicode characters permitted in local and domain part","ref":"security_practices.html#user-id"},{"type":"extras","title":"Password - Security practices","doc":"* The `:password` has a minimum length of 8 characters\n* The `:password` has a maximum length of 4096 bytes [to prevent DOS attacks against Pbkdf2](https://github.com/riverrun/pbkdf2_elixir/blob/master/lib/pbkdf2.ex#L21)\n* The `:password_hash` is generated with `PBKDF2-SHA512` with 100,000 iterations","ref":"security_practices.html#password"},{"type":"extras","title":"Session management - Security practices","doc":"* The session value contains a UUID token that is used to pull credentials through a GenServer\n* The credentials are stored in a key-value cache with TTL of 30 minutes\n* The credentials and session are renewed after 15 minutes if any activity is detected\n* The credentials and session are renewed when user updates","ref":"security_practices.html#session-management"},{"type":"extras","title":"Timing attacks - Security practices","doc":"* If a user couldn't be found or the `:password_hash` is `nil` a blank password is used\n* A UUID is always generated during reset password flow\n* Tokens are signed for public consumption and verified before lookup:\n  * Session ID in `Pow.Plug.Session`\n  * Persistent session token in `PowPersistentSession.Plug.Cookie`\n  * Reset password token in `PowResetPassword.Plug`\n  * E-mail confirmation token in `PowEmailConfirmation.Plug`\n  * Invitation token in `PowInvitation.Plug`","ref":"security_practices.html#timing-attacks"},{"type":"extras","title":"User enumeration attacks - Security practices","doc":"* If authentication fails, a generic `The provided login details did not work. Please verify your credentials, and try again.` message is returned\n* When password reset is requested with `PowResetPassword` for an e-mail that doesn't exist, the generic `If an account for the provided email exists, an email with reset instructions will be send to you. Please check your inbox.` message is returned\n* When attempting to invite a user with `PowInvitation` using an already taken e-mail, the success message `An e-mail with invitation link has been sent.` is returned\n\nEnabling `PowEmailConfirmation` extension will add additional protection:\n\n* User is redirected with message to confirm their e-mail when they attempt to create a user with already taken e-mail\n* Updating e-mail requires the user to confirm the e-mail address by clicking a link send to them\n\nYou can disable the protection by setting `pow_prevent_user_enumeration: false` in `conn.private`.","ref":"security_practices.html#user-enumeration-attacks"},{"type":"extras","title":"Browser cache - Security practices","doc":"* The sign in, registration and invitation acceptance page won't be cached by the browser","ref":"security_practices.html#browser-cache"},{"type":"extras","title":"Configuring mailer","doc":"# Configuring mailer\n\nYou are able to configure a mailer for Pow and set it up with the library of \nyour choice.\n\nThis guide shows how to setup Pow with\n\n * [Swoosh](https://github.com/swoosh/swoosh)\n * [Bamboo](https://github.com/thoughtbot/bamboo)\n\nYou must first setup and configure either of these libraries before you can\nintegrate them with Pow.","ref":"configuring_mailer.html"},{"type":"extras","title":"Swoosh mailer - Configuring mailer","doc":"Set up your `WEB_PATH/mails/pow_mailer.ex` file like so:\n\n```elixir\ndefmodule MyAppWeb.Pow.Mailer do\n  use Pow.Phoenix.Mailer\n  use Swoosh.Mailer, otp_app: :my_app\n\n  import Swoosh.Email\n  \n  require Logger\n\n  @impl true\n  def cast(%{user: user, subject: subject, text: text, html: html}) do\n    %Swoosh.Email{}\n    |> to({\"\", user.email})\n    |> from({\"My App\", \"myapp@example.com\"})\n    |> subject(subject)\n    |> html_body(html)\n    |> text_body(text)\n  end\n\n  @impl true\n  def process(email) do\n    # An asynchronous process should be used here to prevent enumeration\n    # attacks. Synchronous e-mail delivery can reveal whether a user already\n    # exists in the system or not.\n\n    Task.start(fn ->\n      email\n      |> deliver()\n      |> log_warnings()\n    end)\n\n    :ok\n  end\n\n  defp log_warnings({:error, reason}) do\n    Logger.warning(\"Mailer backend failed with: #{inspect(reason)}\")\n  end\n\n  defp log_warnings({:ok, response}), do: {:ok, response}\nend\n```\n\nRemember to add `mailer_backend: MyAppWeb.Pow.Mailer` to the Pow configuration, and set the Swoosh configuration:\n\n```elixir\n# config/config.exs\nconfig :my_app, :pow,\n  user: MyApp.Users.User,\n  repo: MyApp.Repo,\n  mailer_backend: MyAppWeb.Pow.Mailer\n\n# config/prod.exs\nconfig :my_app, MyAppWeb.Pow.Mailer,\n  adapter: Swoosh.Adapters.Sendgrid,\n  api_key: \"SG.x.x\"\n```","ref":"configuring_mailer.html#swoosh-mailer"},{"type":"extras","title":"Bamboo mailer - Configuring mailer","doc":"Set up your `WEB_PATH/mails/pow_mailer.ex` file like so:\n\n```elixir\ndefmodule MyAppWeb.Pow.Mailer do\n  use Pow.Phoenix.Mailer\n  use Bamboo.Mailer, otp_app: :my_app\n\n  import Bamboo.Email\n\n  @impl true\n  def cast(%{user: user, subject: subject, text: text, html: html}) do\n    new_email(\n      to: user.email,\n      from: \"myapp@example.com\",\n      subject: subject,\n      html_body: html,\n      text_body: text\n    )\n  end\n\n  @impl true\n  def process(email) do\n    # An asynchronous process should be used here to prevent enumeration\n    # attacks. Synchronous e-mail delivery can reveal whether a user already\n    # exists in the system or not.\n\n    deliver_later(email)\n  end\nend\n```\n\nRemember to add `mailer_backend: MyAppWeb.Pow.Mailer` to the Pow configuration, and set the Bamboo configuration:\n\n```elixir\n# config/config.exs\nconfig :my_app, :pow,\n  user: MyApp.Users.User,\n  repo: MyApp.Repo,\n  mailer_backend: MyAppWeb.Pow.Mailer\n\n# config/prod.exs\nconfig :my_app, MyAppWeb.Pow.Mailer,\n  adapter: Bamboo.MandrillAdapter, # Specify your preferred adapter\n  api_key: \"my_api_key\" # Specify adapter-specific configuration\n```","ref":"configuring_mailer.html#bamboo-mailer"},{"type":"extras","title":"How to add user roles","doc":"# How to add user roles\n\nAdding user roles is very simple, and you won't need an extension for this. This can be done in several ways, but we'll work with the most straight forward setup.","ref":"user_roles.html"},{"type":"extras","title":"Update your schema - How to add user roles","doc":"Add a `role` column to your user schema. In our example, we'll set the default role to `user` and add a `changeset_role/2` function that ensures the role can only be `user` or `admin`.\n\n```elixir\n# lib/my_app/users/user.ex\ndefmodule MyApp.Users.User do\n  use Ecto.Schema\n  use Pow.Ecto.Schema\n\n  schema \"users\" do\n    field :role, :string, default: \"user\"\n\n    pow_user_fields()\n\n    timestamps()\n  end\n\n  @spec changeset_role(Ecto.Schema.t() | Ecto.Changeset.t(), map()) :: Ecto.Changeset.t()\n  def changeset_role(user_or_changeset, attrs) do\n    user_or_changeset\n    |> Ecto.Changeset.cast(attrs, [:role])\n    |> Ecto.Changeset.validate_inclusion(:role, ~w(user admin))\n  end\nend\n```\n\nTo keep your app secure you shouldn't allow any direct calls to `changeset_role/2` with params provided by the user. Instead you should set up functions in your users context module to either create an admin user or update the role of an existing user:\n\n```elixir\n# lib/my_app/users.ex\ndefmodule MyApp.Users do\n  alias MyApp.{Repo, Users.User}\n\n  @type t :: %User{}\n\n  @spec create_admin(map()) :: {:ok, t()} | {:error, Ecto.Changeset.t()}\n  def create_admin(params) do\n    %User{}\n    |> User.changeset(params)\n    |> User.changeset_role(%{role: \"admin\"})\n    |> Repo.insert()\n  end\n\n  @spec set_admin_role(t()) :: {:ok, t()} | {:error, Ecto.Changeset.t()}\n  def set_admin_role(user) do\n    user\n    |> User.changeset_role(%{role: \"admin\"})\n    |> Repo.update()\n  end\nend\n```\n\nNow you can safely call either `MyApp.Users.create_admin/1` or `MyApp.Users.set_admin_role/1` from your controllers.","ref":"user_roles.html#update-your-schema"},{"type":"extras","title":"Add role plug - How to add user roles","doc":"This is all the work you'll need to control access:\n\n```elixir\n# lib/my_app_web/ensure_role_plug.ex\ndefmodule MyAppWeb.EnsureRolePlug do\n  @moduledoc \"\"\"\n  This plug ensures that a user has a particular role.","ref":"user_roles.html#add-role-plug"},{"type":"extras","title":"Example - How to add user roles","doc":"plug MyAppWeb.EnsureRolePlug, [:user, :admin]\n\n      plug MyAppWeb.EnsureRolePlug, :admin\n\n      plug MyAppWeb.EnsureRolePlug, ~w(user admin)a\n  \"\"\"\n  import Plug.Conn, only: [halt: 1]\n\n  use MyAppWeb, :verified_routes\n\n  alias Phoenix.Controller\n  alias Plug.Conn\n  alias Pow.Plug\n\n  @doc false\n  @spec init(any()) :: any()\n  def init(config), do: config\n\n  @doc false\n  @spec call(Conn.t(), atom() | binary() | [atom()] | [binary()]) :: Conn.t()\n  def call(conn, roles) do\n    conn\n    |> Plug.current_user()\n    |> has_role?(roles)\n    |> maybe_halt(conn)\n  end\n\n  defp has_role?(nil, _roles), do: false\n  defp has_role?(user, roles) when is_list(roles), do: Enum.any?(roles, &has_role?(user, &1))\n  defp has_role?(user, role) when is_atom(role), do: has_role?(user, Atom.to_string(role))\n  defp has_role?(%{role: role}, role), do: true\n  defp has_role?(_user, _role), do: false\n\n  defp maybe_halt(true, conn), do: conn\n  defp maybe_halt(_any, conn) do\n    conn\n    |> Controller.put_flash(:error, \"Unauthorized access\")\n    |> Controller.redirect(to: ~p\"/\")\n    |> halt()\n  end\nend\n```\n\nNow you can add `plug MyAppWeb.EnsureRolePlug, :admin` to your pipeline in `router.ex`:\n\n```elixir\n# lib/my_app_web/router.ex\ndefmodule MyAppWeb.Router do\n  use MyAppWeb, :router\n  use Pow.Phoenix.Router\n\n  # ...\n\n  pipeline :admin do\n    plug MyAppWeb.EnsureRolePlug, :admin\n  end\n\n  scope \"/admin\", MyAppWeb do\n    pipe_through [:browser, :admin]\n\n    # ...\n  end\n\n  # ...\nend\n```\n\nOr you can add it to your controller(s):\n\n```elixir\n# lib/my_app_web/controllers/some_controller.ex\ndefmodule MyAppWeb.SomeController do\n  use MyAppWeb, :controller\n\n  # ...\n\n  plug MyAppWeb.EnsureRolePlug, :admin\n\n  # ...\nend\n```","ref":"user_roles.html#example"},{"type":"extras","title":"Using role permissions with layout - How to add user roles","doc":"You may wish to render certain sections in your layout for certain roles. First let's add a helper function to the users context:\n\n```elixir\n# lib/my_app/users.ex\ndefmodule MyApp.Users do\n  alias MyApp.{Repo, Users.User}\n\n  # ...\n\n  @spec is_admin?(t()) :: boolean()\n  def is_admin?(%{role: \"admin\"}), do: true\n  def is_admin?(_any), do: false\nend\n```\n\nNow we can use that helper to conditionally render a section in our templates:\n\n```elixir\n<%= if MyApp.Users.is_admin?(@current_user) do %>\n   \n     You have admin access \n   \n<% end %>\n```","ref":"user_roles.html#using-role-permissions-with-layout"},{"type":"extras","title":"Test modules - How to add user roles","doc":"```elixir\n# test/my_app/users/user_test.exs\ndefmodule MyApp.Users.UserTest do\n  use MyApp.DataCase\n\n  alias MyApp.Users.User\n\n  test \"changeset/2 sets default role\" do\n    user =\n      %User{}\n      |> User.changeset(%{})\n      |> Ecto.Changeset.apply_changes()\n\n    assert user.role == \"user\"\n  end\n\n  test \"changeset_role/2\" do\n    changeset = User.changeset_role(%User{}, %{role: \"invalid\"})\n    assert changeset.errors[:role] == {\"is invalid\", [validation: :inclusion, enum: [\"user\", \"admin\"]]}\n\n    changeset = User.changeset_role(%User{}, %{role: \"admin\"})\n    refute changeset.errors[:role]\n  end\nend\n```\n\n```elixir\n# test/my_app/users_test.exs\ndefmodule MyApp.UsersTest do\n  use MyApp.DataCase\n\n  alias MyApp.{Repo, Users, Users.User}\n\n  @valid_params %{email: \"test@example.com\", password: \"secret1234\", password_confirmation: \"secret1234\"}\n\n  test \"create_admin/2\" do\n    assert {:ok, user} = Users.create_admin(@valid_params)\n    assert user.role == \"admin\"\n  end\n\n  test \"set_admin_role/1\" do\n    assert {:ok, user} = Repo.insert(User.changeset(%User{}, @valid_params))\n    assert user.role == \"user\"\n\n    assert {:ok, user} = Users.set_admin_role(user)\n    assert user.role == \"admin\"\n  end\n\n  # Uncomment if you added this function to your users context\n  # test \"is_admin?/1\" do\n  #   refute Users.is_admin?(nil)\n  #\n  #   assert {:ok, user} = Repo.insert(User.changeset(%User{}, @valid_params))\n  #   refute Users.is_admin?(user)\n  #\n  #   assert {:ok, admin} = Users.create_admin(%{@valid_params | email: \"test2@example.com\"})\n  #   assert Users.is_admin?(admin)\n  # end\nend\n```\n\n```elixir\n# test/my_app_web/ensure_role_plug_test.exs\ndefmodule MyAppWeb.EnsureRolePlugTest do\n  use MyAppWeb.ConnCase\n\n  alias MyAppWeb.EnsureRolePlug\n\n  @opts ~w(admin)a\n  @user %{id: 1, role: \"user\"}\n  @admin %{id: 2, role: \"admin\"}\n\n  setup do\n    conn =\n      build_conn()\n      |> Plug.Conn.put_private(:plug_session, %{})\n      |> Plug.Conn.put_private(:plug_session_fetch, :done)\n      |> Pow.Plug.put_config(otp_app: :my_app)\n      |> fetch_flash()\n\n    {:ok, conn: conn}\n  end\n\n  test \"call/2 with no user\", %{conn: conn} do\n    opts = EnsureRolePlug.init(@opts)\n    conn = EnsureRolePlug.call(conn, opts)\n\n    assert conn.halted\n    assert redirected_to(conn) == ~p\"/\"\n  end\n\n  test \"call/2 with non-admin user\", %{conn: conn} do\n    opts = EnsureRolePlug.init(@opts)\n    conn =\n      conn\n      |> Pow.Plug.assign_current_user(@user, otp_app: :my_app)\n      |> EnsureRolePlug.call(opts)\n\n    assert conn.halted\n    assert redirected_to(conn) == ~p\"/\"\n  end\n\n  test \"call/2 with non-admin user and multiple roles\", %{conn: conn} do\n    opts = EnsureRolePlug.init(~w(user admin)a)\n    conn =\n      conn\n      |> Pow.Plug.assign_current_user(@user, otp_app: :my_app)\n      |> EnsureRolePlug.call(opts)\n\n    refute conn.halted\n  end\n\n  test \"call/2 with admin user\", %{conn: conn} do\n    opts = EnsureRolePlug.init(@opts)\n    conn =\n      conn\n      |> Pow.Plug.assign_current_user(@admin, otp_app: :my_app)\n      |> EnsureRolePlug.call(opts)\n\n    refute conn.halted\n  end\nend\n```","ref":"user_roles.html#test-modules"},{"type":"extras","title":"How to lock users","doc":"# How to lock users\n\nLocking users is trivial, and you won't need an extension for this. It can be done in several ways, but we'll work with the most straight forward setup.","ref":"lock_users.html"},{"type":"extras","title":"Update your schema - How to lock users","doc":"Add a `locked_at` column to your user schema, and a `lock_changeset/1` function to lock the account:\n\n```elixir\n# lib/my_app/users/user.ex\ndefmodule MyApp.Users.User do\n  use Ecto.Schema\n  use Pow.Ecto.Schema\n  \n  alias Ecto.{Changeset, Schema}\n\n  schema \"users\" do\n    field :locked_at, :utc_datetime\n\n    pow_user_fields()\n\n    timestamps()\n  end\n\n  @spec lock_changeset(Schema.t() | Changeset.t()) :: Changeset.t()\n  def lock_changeset(user_or_changeset) do\n    changeset = Changeset.change(user_or_changeset)\n    locked_at = DateTime.truncate(DateTime.utc_now(), :second)\n\n    case Changeset.get_field(changeset, :locked_at) do\n      nil  -> Changeset.change(changeset, locked_at: locked_at)\n      _any -> Changeset.add_error(changeset, :locked_at, \"already set\")\n    end\n  end\nend\n```\n\nAdd a lock action to your user context module:\n\n```elixir\n# lib/my_app/users.ex\ndefmodule MyApp.Users do\n  alias MyApp.{Repo, Users.User}\n\n  @spec lock(map()) :: {:ok, map()} | {:error, map()}\n  def lock(user) do\n    user\n    |> User.lock_changeset()\n    |> Repo.update()\n  end\nend\n```","ref":"lock_users.html#update-your-schema"},{"type":"extras","title":"Set up controller - How to lock users","doc":"Create or modify you user management controller so you (likely the admin) can lock the account:\n\n```elixir\n# lib/my_app_web/controllers/admin/user_controller.ex\ndefmodule MyAppWeb.Admin.UserController do\n  use MyAppWeb, :controller\n\n  alias Plug.Conn\n  alias Pow.{Plug, Operations}\n  alias MyApp.Users\n\n  plug :load_user when action in [:lock]\n\n  # ...\n\n  @spec lock(Conn.t(), map()) :: Conn.t()\n  def lock(%{assigns: %{user: user}} = conn, _params) do\n    case Users.lock(user) do\n      {:ok, _user} ->\n        conn\n        |> put_flash(:info, \"User has been locked.\")\n        |> redirect(to: \"/\")\n\n      {:error, _changeset} ->\n        conn\n        |> put_flash(:error, \"User couldn't be locked.\")\n        |> redirect(to: \"/\")\n    end\n  end\n\n  defp load_user(%{params: %{\"id\" => user_id}} = conn, _opts) do\n    config = Plug.fetch_config(conn)\n\n    case Operations.get_by([id: user_id], config) do\n      nil ->\n        conn\n        |> put_flash(:error, \"User doesn't exist\")\n        |> redirect(to: \"/\")\n\n      user ->\n        assign(conn, :user, user)\n    end\n  end\nend\n```\n\nRemember to add this route to your `router.ex` file:\n\n```elixir\n# lib/my_app_web/router.ex\ndefmodule MyAppWeb.Router do\n  use MyAppWeb, :router\n  use Pow.Phoenix.Router\n\n  # ...\n\n  scope \"/admin\", MyAppWeb.Admin, as: :admin do\n    pipe_through :browser\n    # Usually you would lock this area with a plug:\n    # pipe_through [:browser, :require_admin_user]\n\n    post \"/users/:id/lock\", UserController, :lock\n  end\n\n  # ...\nend\n```","ref":"lock_users.html#set-up-controller"},{"type":"extras","title":"Prevent sign in for locked users - How to lock users","doc":"This is all you need to ensure locked users can't sign in:\n\n```elixir\n# lib/my_app_web/ensure_user_not_locked_plug.ex\ndefmodule MyAppWeb.EnsureUserNotLockedPlug do\n  @moduledoc \"\"\"\n  This plug ensures that a user isn't locked.","ref":"lock_users.html#prevent-sign-in-for-locked-users"},{"type":"extras","title":"Example - How to lock users","doc":"plug MyAppWeb.EnsureUserNotLockedPlug\n  \"\"\"\n  import Plug.Conn, only: [halt: 1]\n\n  use MyAppWeb, :verified_routes\n  alias Phoenix.Controller\n  alias Plug.Conn\n  alias Pow.Plug\n\n  @doc false\n  @spec init(any()) :: any()\n  def init(opts), do: opts\n\n  @doc false\n  @spec call(Conn.t(), any()) :: Conn.t()\n  def call(conn, _opts) do\n    conn\n    |> Plug.current_user()\n    |> locked?()\n    |> maybe_halt(conn)\n  end\n\n  defp locked?(%{locked_at: locked_at}) when not is_nil(locked_at), do: true\n  defp locked?(_user), do: false\n\n  defp maybe_halt(true, conn) do\n    conn\n    |> Plug.delete()\n    |> Controller.put_flash(:error, \"Sorry, your account is locked.\")\n    |> Controller.redirect(to: ~p\"/session/new\")\n    |> halt()\n  end\n  defp maybe_halt(_any, conn), do: conn\nend\n```\n\nAdd `plug MyAppWeb.EnsureUserNotLockedPlug` to your endpoint or pipeline, and presto!","ref":"lock_users.html#example"},{"type":"extras","title":"Optional: PowResetPassword - How to lock users","doc":"The above will prevent any locked users access, but it doesn't prevent them from using features that doesn't require authentication such as resetting their password. Be advised that this is a entirely optional step as this only affects UX.\n\nWhile there are many different ways of handling this, the most explicit one is to simply override the logic entirely with a custom controller:\n\n```elixir\n# lib/my_app_web/controllers/reset_password_controller.ex\ndefmodule MyAppWeb.ResetPasswordController do\n  use MyAppWeb, :controller\n\n  alias PowResetPassword.{Phoenix.ResetPasswordController, Plug, Store.ResetTokenCache}\n\n  def create(conn, params) do\n    conn\n    |> ResetPasswordController.process_create(params)\n    |> maybe_halt()\n    |> ResetPasswordController.respond_create()\n  end\n\n  defp maybe_halt({:ok, %{token: token, user: %{locked_at: locked_at}}, conn}) when not is_nil(locked_at) do\n    user = Plug.change_user(conn)\n\n    expire_token(conn, token)\n\n    {:error, %{user | action: :update}, conn}\n  end\n  defp maybe_halt(response), do: response\n\n  defp expire_token(conn, token) do\n    config = Pow.Plug.fetch_config(conn)\n\n    case Pow.Plug.verify_token(conn, Atom.to_string(PowResetPassword.Plug), token, config) do\n      {:ok, token} ->\n        backend = Pow.Config.get(config, :cache_store_backend, Pow.Store.Backend.EtsCache)\n\n        ResetTokenCache.delete([backend: backend], token)\n\n      :error ->\n        :ok\n    end\n  end\nend\n```\n\nTo make the code simpler for us we're leveraging the functions from `PowResetPassword.Phoenix.ResetPasswordController` here.\n\nNow all we got to do is to catch the route before the `pow_extension_routes/0` call:\n\n```elixir\n# lib/my_app_web/router.ex\ndefmodule MyAppWeb.Router do\n  use MyAppWeb, :router\n  use Pow.Phoenix.Router\n  use Pow.Extension.Phoenix.Router,\n    extensions: [PowResetPassword]\n\n  # ...\n\n  scope \"/\", MyAppWeb do\n    pipe_through :browser\n\n    post \"/reset-password\", ResetPasswordController, :create\n  end\n\n  scope \"/\" do\n    pow_routes()\n    pow_extension_routes()\n  end\n\n  # ...\nend\n```","ref":"lock_users.html#optional-powresetpassword"},{"type":"extras","title":"Test modules - How to lock users","doc":"```elixir\n# test/my_app/users_test.exs\ndefmodule MyApp.UsersTest do\n  use MyApp.DataCase\n\n  alias MyApp.{Repo, Users, Users.User}\n\n  @valid_params %{email: \"test@example.com\", password: \"secret1234\", password_confirmation: \"secret1234\"}\n\n  test \"lock/2\" do\n    assert {:ok, user} = Repo.insert(User.changeset(%User{}, @valid_params))\n    refute user.locked_at\n\n    assert {:ok, user} = Users.lock(user)\n    assert user.locked_at\n\n    assert {:error, changeset} = Users.lock(user)\n    assert changeset.errors[:locked_at] == {\"already set\", []}\n  end\nend\n```\n\n```elixir\n# test/my_app_web/controllers/admin/user_controller_test.exs\ndefmodule MyAppWeb.Admin.UserControllerTest do\n  use MyAppWeb.ConnCase\n\n  alias MyApp.{Users, Users.User, Repo}\n\n  describe \"lock/2\" do\n    test \"locks user\", %{conn: conn} do\n      user = user_fixture()\n\n      conn = post(conn, ~p\"/admin/users/#{user.id}/lock\")\n\n      assert Phoenix.Flash.get(conn.assigns.flash, :info) == \"User has been locked.\"\n      assert redirected_to(conn) == \"/\"\n    end\n\n    test \"with already locked user\", %{conn: conn} do\n      {:ok, user} = Users.lock(user_fixture())\n\n      conn = post(conn, ~p\"/admin/users/#{user.id}/lock\")\n\n      assert Phoenix.Flash.get(conn.assigns.flash, :error) == \"User couldn't be locked.\"\n      assert redirected_to(conn) == \"/\"\n    end\n  end\n\n  defp user_fixture() do\n    %User{}\n    |> User.changeset(%{email: \"test@example.com\", password: \"secret1234\", password_confirmation: \"secret1234\"})\n    |> Repo.insert!()\n  end\nend\n```\n\n```elixir\n# test/my_app_web/ensure_user_not_locked_plug_test.exs\ndefmodule MyAppWeb.EnsureUserNotLockedPlugTest do\n  use MyAppWeb.ConnCase\n\n  alias MyApp.Users.User\n  alias MyAppWeb.EnsureUserNotLockedPlug\n\n  @pow_config [otp_app: :my_app]\n  @user %User{id: 1, locked_at: nil}\n  @locked_user %User{id: 2, locked_at: DateTime.utc_now()}\n  @plug_opts []\n\n  setup do\n    {:ok, conn: init_conn()}\n  end\n\n  test \"call/2 with no user\", %{conn: conn} do\n    opts = EnsureUserNotLockedPlug.init(@plug_opts)\n    conn = EnsureUserNotLockedPlug.call(conn, opts)\n\n    refute conn.halted\n  end\n\n  test \"call/2 with user\", %{conn: conn} do\n    opts = EnsureUserNotLockedPlug.init(@plug_opts)\n    conn =\n      conn\n      |> Pow.Plug.assign_current_user(@user, @pow_config)\n      |> EnsureUserNotLockedPlug.call(opts)\n\n    refute conn.halted\n  end\n\n  test \"call/2 with locked user\", %{conn: conn} do\n    opts = EnsureUserNotLockedPlug.init(@plug_opts)\n    conn =\n      conn\n      |> Pow.Plug.assign_current_user(@locked_user, @pow_config)\n      |> EnsureUserNotLockedPlug.call(opts)\n\n    assert Phoenix.Flash.get(conn.assigns.flash, :error) == \"Sorry, your account is locked.\"\n    assert redirected_to(conn) == ~p\"/session/new\"\n  end\n\n  defp init_conn() do\n    pow_config = Keyword.put(@pow_config, :plug, Pow.Plug.Session)\n\n    :get\n    |> Plug.Test.conn(\"/\")\n    |> Plug.Test.init_test_session(%{})\n    |> Pow.Plug.put_config(pow_config)\n    |> fetch_flash()\n  end\nend\n```\n\n```elixir\n# test/my_app_web/controllers/reset_password_controller_test.exs\ndefmodule MyAppWeb.ResetPasswordControllerTest do\n  use MyAppWeb.ConnCase\n\n  alias MyApp.{Users, Users.User, Repo}\n  alias PowResetPassword.Store.ResetTokenCache\n\n  describe \"create/2\" do\n    @valid_params %{\"user\" => %{\"email\" => \"test@example.com\"}}\n\n    test \"with user\", %{conn: conn} do\n      user = user_fixture()\n\n      conn = post(conn, ~p\"/reset-password\", @valid_params)\n\n      assert Phoenix.Flash.get(conn.assigns.flash, :info)\n      assert redirected_to(conn) == ~p\"/session/new\"\n\n      assert count_reset_password_tokens_for_user(conn, user) == 1\n    end\n\n    test \"with locked user\", %{conn: conn} do\n      {:ok, user} = Users.lock(user_fixture())\n\n      conn = post(conn, ~p\"/reset-password\", @valid_params)\n\n      assert Phoenix.Flash.get(conn.assigns.flash, :info)\n      assert redirected_to(conn) == ~p\"/session/new\"\n\n      assert count_reset_password_tokens_for_user(conn, user) == 0\n    end\n  end\n\n  defp user_fixture() do\n    %User{}\n    |> User.changeset(%{email: \"test@example.com\", password: \"secret1234\", password_confirmation: \"secret1234\"})\n    |> Repo.insert!()\n  end\n\n  defp count_reset_password_tokens_for_user(conn, user) do\n    backend =\n      conn\n      |> Pow.Plug.fetch_config()\n      |> Pow.Config.get(:cache_store_backend, Pow.Store.Backend.EtsCache)\n\n    [backend: backend]\n    |> ResetTokenCache.all([:_])\n    |> Enum.filter(fn {_key, %{id: id}} -> id == user.id end)\n    |> length()\n  end\nend\n```","ref":"lock_users.html#test-modules"},{"type":"extras","title":"Custom controllers","doc":"# Custom controllers\n\n_Please note that if you just wish to modify the templates, then you should follow the [Modify templates](../README.md#modify-templates) section(s) in the README. This guide is meant for allowing complete control over flow._\n\nPow makes it easy to use custom controllers leveraging the underlying Pow logic. It is ideal for cases where you need to control the flow, e.g., protect the registration process in a certain way.\n\nFirst you should follow the [Getting Started](../README.md#getting-started) section in README until before the `router.ex` modification.","ref":"custom_controllers.html"},{"type":"extras","title":"Routes - Custom controllers","doc":"Modify your `WEB_PATH/router.ex` to set up the Pow plugs in `:protected` and `:not_authenticated` pipelines with a custom error handler, and add the routes for your custom session and registration controllers:\n\n```elixir\ndefmodule MyAppWeb.Router do\n  use MyAppWeb, :router\n\n  # ... pipelines\n\n  pipeline :protected do\n    plug Pow.Plug.RequireAuthenticated,\n      error_handler: MyAppWeb.AuthErrorHandler\n  end\n\n  pipeline :not_authenticated do\n    plug Pow.Plug.RequireNotAuthenticated,\n      error_handler: MyAppWeb.AuthErrorHandler\n  end\n\n  scope \"/\", MyAppWeb do\n    pipe_through [:browser, :not_authenticated]\n\n    get \"/signup\", RegistrationController, :new, as: :signup\n    post \"/signup\", RegistrationController, :create, as: :signup\n    get \"/login\", SessionController, :new, as: :login\n    post \"/login\", SessionController, :create, as: :login\n  end\n\n  scope \"/\", MyAppWeb do\n    pipe_through [:browser, :protected]\n\n    delete \"/logout\", SessionController, :delete, as: :logout\n  end\n\n  # ... routes\nend\n```\n\nAnd create `WEB_PATH/auth_error_handler.ex`:\n\n```elixir\ndefmodule MyAppWeb.AuthErrorHandler do\n  use MyAppWeb, :controller\n  alias Plug.Conn\n\n  @spec call(Conn.t(), atom()) :: Conn.t()\n  def call(conn, :not_authenticated) do\n    conn\n    |> put_flash(:error, \"You've to be authenticated first\")\n    |> redirect(to: ~p\"/login\")\n  end\n\n  @spec call(Conn.t(), atom()) :: Conn.t()\n  def call(conn, :already_authenticated) do\n    conn\n    |> put_flash(:error, \"You're already authenticated\")\n    |> redirect(to: ~p\"/\")\n  end\nend\n```\n\nThis module will make sure that unauthenticated user can't log out, and authenticated users can't sign in again.\n\n#","ref":"custom_controllers.html#routes"},{"type":"extras","title":"Controllers - Custom controllers","doc":"We'll be using `Pow.Plug` for the heavy lifting, and customizing the response handling in our controllers.\n\nCreate `WEB_PATH/controllers/registration_controller.ex`:\n\n```elixir\ndefmodule MyAppWeb.RegistrationController do\n  use MyAppWeb, :controller\n\n  def new(conn, _params) do\n    # We'll leverage `Pow.Plug`, but you can also follow the classic Phoenix way:\n    # changeset = MyApp.Users.User.changeset(%MyApp.Users.User{}, %{})\n\n    changeset = Pow.Plug.change_user(conn)\n\n    render(conn, \"new.html\", changeset: changeset)\n  end\n\n  def create(conn, %{\"user\" => user_params}) do\n    # We'll leverage `Pow.Plug`, but you can also follow the classic Phoenix way:\n    # user =\n    #   %MyApp.Users.User{}\n    #   |> MyApp.Users.User.changeset(user_params)\n    #   |> MyApp.Repo.insert()\n\n    conn\n    |> Pow.Plug.create_user(user_params)\n    |> case do\n      {:ok, user, conn} ->\n        conn\n        |> put_flash(:info, \"Welcome!\")\n        |> redirect(to: ~p\"/\")\n\n      {:error, changeset, conn} ->\n        render(conn, \"new.html\", changeset: changeset)\n    end\n  end\nend\n```\n\nCreate `WEB_PATH/controllers/session_controller.ex`:\n\n```elixir\ndefmodule MyAppWeb.SessionController do\n  use MyAppWeb, :controller\n\n  def new(conn, _params) do\n    changeset = Pow.Plug.change_user(conn)\n\n    render(conn, \"new.html\", changeset: changeset)\n  end\n\n  def create(conn, %{\"user\" => user_params}) do\n    conn\n    |> Pow.Plug.authenticate_user(user_params)\n    |> case do\n      {:ok, conn} ->\n        conn\n        |> put_flash(:info, \"Welcome back!\")\n        |> redirect(to: ~p\"/\")\n\n      {:error, conn} ->\n        changeset = Pow.Plug.change_user(conn, conn.params[\"user\"])\n\n        conn\n        |> put_flash(:info, \"Invalid email or password\")\n        |> render(\"new.html\", changeset: changeset)\n    end\n  end\n\n  def delete(conn, _params) do\n    conn\n    |> Pow.Plug.delete()\n    |> redirect(to: ~p\"/\")\n  end\nend\n```\n\n#","ref":"custom_controllers.html#controllers"},{"type":"extras","title":"Templates - Custom controllers","doc":"Create `WEB_PATH/controllers/registration_html/new.html.heex`:\n\n```elixir\n \n  <.header class=\"text-center\">\n    Register account\n    <:subtitle>\n      Already registered?\n      <.link navigate={~p\"/login\"} class=\"font-semibold text-brand hover:underline\">\n        Log in\n      </.link>\n      instead.\n    </:subtitle>\n  </.header>\n\n  <.simple_form :let={f} for={@changeset} action={~p\"/signup\"}>\n    <.error :if={@changeset.action == :insert}>\n      Oops, something went wrong! Please check the errors below.\n    </.error>\n\n    <.input field={f[:email]} type=\"email\" label=\"Email\" required />\n    <.input field={f[:password]} type=\"password\" label=\"Password\" required />\n    <.input field={f[:password_confirmation]} type=\"password\" label=\"Confirm password\" required />\n\n    <:actions>\n      <.button phx-disable-with=\"Registering account...\" class=\"w-full\">Register</.button>\n    </:actions>\n  </.simple_form>\n \n```\n\nCreate `WEB_PATH/controllers/session_html/new.html.heex`:\n\n```elixir\n \n  <.header class=\"text-center\">\n    Sign in\n    <:subtitle>\n      No account?\n      <.link navigate={~p\"/signup\"} class=\"font-semibold text-brand hover:underline\">\n        Register\n      </.link>\n      instead.\n    </:subtitle>\n  </.header>\n\n  <.simple_form :let={f} for={@changeset} action={~p\"/login\"}>\n    <.error :if={@changeset.action == :insert}>\n      Oops, something went wrong! Please check the errors below.\n    </.error>\n\n    <.input field={f[:email]} type=\"email\" label=\"Email\" required />\n    <.input field={f[:password]} type=\"password\" label=\"Password\" required />\n\n    <:actions>\n      <.button phx-disable-with=\"Registering account...\" class=\"w-full\">Register</.button>\n    </:actions>\n  </.simple_form>\n \n```\n\nRemember to create the template files `WEB_PATH/controllers/registration_html.ex` and `WEB_PATH/controllers/session_html.ex` too.","ref":"custom_controllers.html#templates"},{"type":"extras","title":"Further customization - Custom controllers","doc":"That's all you need to do to have custom controllers with Pow! From here on you can customize your flow.\n\nYou may want to utilize some of the extensions, but since you have created a custom controller, it's highly recommended that you do not rely on any controller actions in the extensions. Instead, you should implement the logic yourself to keep your controllers as explicit as possible. This is only an example:\n\n```elixir\ndefmodule MyAppWeb.SessionController do\n  # ...\n\n  def create(conn, %{\"user\" => user_params}) do\n    conn\n    |> Pow.Plug.authenticate_user(user_params)\n    |> verify_confirmed()\n  end\n\n  defp verify_confirmed({:ok, conn}) do\n    conn\n    |> Pow.Plug.current_user()\n    |> email_confirmed?()\n    |> case do\n      true ->\n        conn\n        |> put_flash(:info, \"Welcome back!\")\n        |> redirect(to: ~p\"/\")\n\n      false ->\n        conn\n        |> Pow.Plug.delete()\n        |> put_flash(:info, \"Your e-mail address has not been confirmed.\")\n        |> redirect(to: ~p\"/login\")\n    end\n  end\n  defp verify_confirmed({:error, conn}) do\n    changeset = Pow.Plug.change_user(conn, conn.params[\"user\"])\n\n    conn\n    |> put_flash(:info, \"Invalid email or password\")\n    |> render(\"login.html\", changeset: changeset)\n  end\n\n  defp email_confirmed?(%{email_confirmed_at: nil, email_confirmation_token: token, unconfirmed_email: nil}) when not is_nil(token), do: false\n  defp email_confirmed?(_user), do: true\n  # ...\nend\n```","ref":"custom_controllers.html#further-customization"},{"type":"extras","title":"Disable registration","doc":"# Disable registration\n\nYou may have an app in which users are not permitted to sign up. Pow makes it easy to disable registration by removing the registration routes.\n\nFirst you should follow the [Modify templates](../README.md#modify-templates) section in README.","ref":"disable_registration.html"},{"type":"extras","title":"Templates - Disable registration","doc":"Open up `WEB_PATH/controllers/pow/session_html/new.html.heex` and remove the registration link. Delete the `WEB_PATH/controllers/pow/registration_html/new.html.heex` file.","ref":"disable_registration.html#templates"},{"type":"extras","title":"Routes - Disable registration","doc":"Replace `pow_routes()` with `pow_session_routes()` in your router module.\n\nAdd the following routes below to enable account updates and deletion:\n\n```elixir\nscope \"/\", Pow.Phoenix, as: \"pow\" do\n  pipe_through [:browser, :protected]\n  resources \"/registration\", RegistrationController, singleton: true, only: [:edit, :update, :delete]\nend\n```\n\nThat's it!","ref":"disable_registration.html#routes"},{"type":"extras","title":"Redis cache store backend","doc":"# Redis cache store backend\n\nFor read-only systems, like Heroku, you won't be able to use the built-in Mnesia backend cache for distribution and to persist cache data between restarts. Instead, let's use [Redix](https://github.com/whatyouhide/redix) to store our cache data in Redis.\n\nFirst, add Redix to your list of dependencies in `mix.exs`:\n\n```elixir\n# mix.exs\ndefp deps do\n  [\n    # ...\n    {:redix, \"~> 0.9.2\"}\n  ]\nend\n```\n\nNow set up your `WEB_PATH/pow/redis_cache.ex` like so:\n\n```elixir\n# lib/my_app_web/pow/redis_cache.ex\ndefmodule MyAppWeb.Pow.RedisCache do\n  @moduledoc \"\"\"\n  Redis cache with optimized lookup.\n\n  To keep lookups performant the key is split up into n - 1 prefixes, where n\n  is the number of items in the key array. Each prefix will be combined with\n  all previous prefixes (if any) into a sorted set key. The rest of the key\n  will be combined into a member of this sorted set. The member of the sorted\n  set will have the expiration timestamp set as the score.\n\n  The sorted set will be set to expire with the provided `ttl`. When new\n  records are inserted any members of any of these prefix sorted sets with a\n  score score lower than the current timestamp will be removed.\n\n  When records are queried with `all/2`, the first matching `:_` wildcard in\n  the key match will define what prefix sorted set to use to find the keys. All\n  members with a lower score than the current timestamp will be removed, and\n  the sorted set for that prefix will be scanned. The resulting list is then\n  checked against the key match spec.\n\n  Any part of the key and value will be encoded with `:erlang.term_to_binary/1`\n  and `Base.url_encode64/2` when stored.","ref":"redis_cache_store_backend.html"},{"type":"extras","title":"Configuration options - Redis cache store backend","doc":"* `:ttl` - integer value in milliseconds for ttl of records. If this value\n      is not provided, or is set to nil, the records will never expire.\n\n    * `:namespace` - value to use for namespacing keys. Defaults to \"cache\".\n\n    * `:writes` - set to `:async` to do asynchronous writes. Defaults to\n      `:sync`.\n  \"\"\"\n\n  @behaviour Pow.Store.Backend.Base\n\n  alias Pow.Config\n\n  @redix_instance_name :redix\n\n  @impl true\n  def put(config, record_or_records) do\n    ttl = Config.get(config, :ttl) || raise_ttl_error!()\n\n    commands =\n      record_or_records\n      |> List.wrap()\n      |> Enum.reduce([], fn {key, value}, acc ->\n        config\n        |> redis_key(key)\n        |> command_builder(&put_command(&1, value, ttl))\n        |> flatten(acc)\n      end)\n\n    maybe_async(config, fn ->\n      @redix_instance_name\n      |> Redix.pipeline!(commands)\n      |> Enum.zip(commands)\n      |> Enum.reject(fn\n        {n, _cmd} when is_number(n) or n == \"OK\" -> true\n        _any -> false\n      end)\n      |> case do\n        []     -> :ok\n        errors -> raise \"Redix received unexpected response #{inspect errors}\"\n      end\n    end)\n\n    :ok\n  end\n\n  defp put_command({key, []}, value, ttl) do\n    key   = to_binary_redis_key(key)\n    value = :erlang.term_to_binary(value)\n\n    [\"SET\", key, value, \"PX\", ttl]\n  end\n  defp put_command({prefix, key}, _value, ttl) do\n    key       = to_binary_redis_key(key)\n    timestamp = current_timestamp()\n\n    index_key =\n      prefix\n      |> to_binary_redis_key()\n      |> to_index_key()\n\n    [\n      [\"ZREMRANGEBYSCORE\", index_key, \"-inf\", timestamp],\n      [\"ZADD\", index_key, timestamp + ttl, key],\n      [\"PEXPIRE\", index_key, ttl]\n    ]\n  end\n\n  defp current_timestamp, do: DateTime.to_unix(DateTime.utc_now(), :millisecond)\n\n  defp command_builder(key, fun) do\n    count = Enum.count(key)\n\n    1..count\n    |> Enum.map(fn i ->\n      key\n      |> Enum.split(i)\n      |> fun.()\n    end)\n    |> Enum.reduce([], &flatten/2)\n  end\n\n  defp flatten([item | _rest] = items, acc) when is_list(item)  do\n    Enum.reduce(items, acc, &flatten/2)\n  end\n  defp flatten(item, acc), do: acc ++ [item]\n\n  defp maybe_async(config, fun) do\n    case Config.get(config, :writes, :sync) do\n      :sync -> fun.()\n      :async -> Task.start(fun)\n    end\n  end\n\n  @impl true\n  def delete(config, key) do\n    commands =\n      config\n      |> redis_key(key)\n      |> command_builder(&delete_command/1)\n\n    maybe_async(config, fn ->\n      Redix.pipeline!(@redix_instance_name, commands)\n    end)\n\n    :ok\n  end\n\n  def delete_command({prefix, []}) do\n    prefix = to_binary_redis_key(prefix)\n\n    [\"DEL\", prefix]\n  end\n  def delete_command({prefix, key}) do\n    index_key =\n      prefix\n      |> to_binary_redis_key()\n      |> to_index_key()\n\n    key = to_binary_redis_key(key)\n\n    [\"ZREM\", index_key, key]\n  end\n\n  @impl true\n  def get(config, key) do\n    key =\n      config\n      |> redis_key(key)\n      |> to_binary_redis_key()\n\n    case Redix.command!(@redix_instance_name, [\"GET\", key]) do\n      nil   -> :not_found\n      value -> :erlang.binary_to_term(value)\n    end\n  end\n\n  @impl true\n  def all(config, key_match) do\n    compiled_match_spec = :ets.match_spec_compile([{{key_match, :_}, [], [:\"$_\"]}])\n    key_match           = redis_key(config, key_match)\n\n    prefix =\n      key_match\n      |> Enum.find_index(& &1 == :_)\n      |> case do\n        nil -> {redis_key(config, []), key_match}\n        i   -> Enum.split(key_match, i)\n      end\n      |> elem(0)\n\n    index_key =\n      prefix\n      |> to_binary_redis_key()\n      |> to_index_key()\n\n    Redix.command!(@redix_instance_name, [\"ZREMRANGEBYSCORE\", index_key, \"-inf\", current_timestamp()])\n\n    Stream.resource(\n      fn -> do_scan(config, prefix, compiled_match_spec, \"0\") end,\n      &stream_scan(config, prefix, compiled_match_spec, &1),\n      fn _ -> :ok end)\n    |> Enum.to_list()\n  end\n\n  defp to_index_key(key), do: \"_index:#{key}\"\n\n  defp stream_scan(_config, _prefix, _compiled_match_spec, {[], \"0\"}), do: {:halt, nil}\n  defp stream_scan(config, prefix, compiled_match_spec, {[], iterator}) do\n    result = do_scan(config, prefix, compiled_match_spec, iterator)\n\n    stream_scan(config, prefix, compiled_match_spec, result)\n  end\n  defp stream_scan(_config, _prefix, _compiled_match_spec, {keys, iterator}), do: {keys, {[], iterator}}\n\n  defp do_scan(config, prefix, compiled_match_spec, iterator) do\n    prefix    = to_binary_redis_key(prefix)\n    index_key = to_index_key(prefix)\n\n    [iterator, res] = Redix.command!(@redix_instance_name, [\"ZSCAN\", index_key, iterator])\n\n    keys = Enum.take_every(res, 2)\n\n    {filter_or_load_value(compiled_match_spec, prefix, keys, config), iterator}\n  end\n\n  defp filter_or_load_value(compiled_match_spec, prefix, keys, config) do\n    keys\n    |> Enum.map(&\"#{prefix}:#{&1}\")\n    |> Enum.map(&convert_key/1)\n    |> :ets.match_spec_run(compiled_match_spec)\n    |> populate_values(config)\n  end\n\n  defp convert_key(key) do\n    key =\n      key\n      |> from_binary_redis_key()\n      |> unwrap()\n\n    {key, nil}\n  end\n\n  defp unwrap([_namespace, key]), do: key\n  defp unwrap([_namespace | key]), do: key\n\n  defp populate_values([], _config), do: []\n  defp populate_values(records, config) do\n    binary_keys = Enum.map(records, fn {key, nil} -> binary_redis_key(config, key) end)\n\n    values =\n      @redix_instance_name\n      |> Redix.command!([\"MGET\"] ++ binary_keys)\n      |> Enum.map(fn\n        nil   -> nil\n        value -> :erlang.binary_to_term(value)\n      end)\n\n    records\n    |> zip_values(values)\n    |> Enum.reject(fn {_key, value} -> is_nil(value) end)\n  end\n\n  defp zip_values([{key, nil} | next1], [value | next2]) do\n    [{key, value} | zip_values(next1, next2)]\n  end\n  defp zip_values(_, []), do: []\n  defp zip_values([], _), do: []\n\n  defp binary_redis_key(config, key) do\n    config\n    |> redis_key(key)\n    |> to_binary_redis_key()\n  end\n\n  defp redis_key(config, key) do\n    [namespace(config) | List.wrap(key)]\n  end\n\n  defp namespace(config), do: Config.get(config, :namespace, \"cache\")\n\n  defp to_binary_redis_key(key) do\n    key\n    |> Enum.map(fn part ->\n      part\n      |> :erlang.term_to_binary()\n      |> Base.url_encode64(padding: false)\n    end)\n    |> Enum.join(\":\")\n  end\n\n  defp from_binary_redis_key(key) do\n    key\n    |> String.split(\":\")\n    |> Enum.map(fn part ->\n      part\n      |> Base.url_decode64!(padding: false)\n      |> :erlang.binary_to_term()\n    end)\n  end\n\n  @spec raise_ttl_error!() :: no_return()\n  defp raise_ttl_error!(),\n    do: Config.raise_error(\"`:ttl` configuration option is required for #{inspect(__MODULE__)}\")\nend\n```\n\nWe are converting keys to binary keys since we can't directly use the Erlang terms as with ETS and Mnesia.\n\nWe'll need to start the Redix application on our app startup, so in `application.ex` add `{Redix, name: :redix}` to your supervision tree:\n\n```elixir\n# lib/my_app/application.ex\ndefmodule MyApp.Application do\n\n  # ...\n\n  def start(_type, _args) do\n    import Supervisor.Spec\n\n    children = [\n      # ...\n      {Redix, name: :redix}\n    ]\n\n    opts = [strategy: :one_for_one, name: MyApp.Supervisor]\n    Supervisor.start_link(children, opts)\n  end\n\n  # ...\nend\n```\n\nBy default localhost Redis is used, but you can update this by using a Redis URI: `{Redix, {\"redis://:secret@redix.example.com:6380/1\", [name: :redix]}}`\n\nFinally update the config with your new Redis cache backend:\n\n```elixir\n# config/config.ex\nconfig :my_app, :pow,\n  user: MyApp.Users.User,\n  repo: MyApp.Repo,\n  cache_store_backend: MyAppWeb.Pow.RedisCache\n```\n\nAnd now you have a running Redis cache store backend!","ref":"redis_cache_store_backend.html#configuration-options"},{"type":"extras","title":"Test module - Redis cache store backend","doc":"```elixir\n# test/my_app_web/pow/redis_cache_test.exs\ndefmodule MyAppWeb.Pow.RedisCacheTest do\n  use ExUnit.Case\n  doctest MyAppWeb.Pow.RedisCache\n\n  alias MyAppWeb.Pow.RedisCache\n\n  @default_config [namespace: \"test\", ttl: :timer.hours(1)]\n\n  setup do\n    Redix.command!(:redix, [\"FLUSHALL\"])\n\n    :ok\n  end\n\n  test \"can put, get and delete records\" do\n    assert RedisCache.get(@default_config, \"key\") == :not_found\n\n    RedisCache.put(@default_config, {\"key\", \"value\"})\n    assert RedisCache.get(@default_config, \"key\") == \"value\"\n\n    RedisCache.delete(@default_config, \"key\")\n    assert RedisCache.get(@default_config, \"key\") == :not_found\n  end\n\n  test \"with `writes: :async` config option\" do\n    config = Keyword.put(@default_config, :writes, :async)\n\n    assert RedisCache.get(config, \"key\") == :not_found\n\n    RedisCache.put(config, {\"key\", \"value\"})\n    assert RedisCache.get(config, \"key\") == :not_found\n    :timer.sleep(100)\n    assert RedisCache.get(config, \"key\") == \"value\"\n\n    RedisCache.delete(config, \"key\")\n    assert RedisCache.get(config, \"key\") == \"value\"\n    :timer.sleep(100)\n    assert RedisCache.get(config, \"key\") == :not_found\n  end\n\n  test \"delete removes from redis sets\" do\n    RedisCache.put(@default_config, {[\"namespace\", \"key1\"], \"value\"})\n    RedisCache.put(@default_config, {[\"namespace\", \"key2\"], \"value\"})\n    assert redix_zmembers_decoded(\"namespace\") == [\"key1\", \"key2\"]\n\n    RedisCache.delete(@default_config, [\"namespace\", \"key1\"])\n    assert redix_zmembers_decoded(\"namespace\") == [\"key2\"]\n  end\n\n  describe \"with redis errors\" do\n    setup do\n      [\"maxmemory\", value] = Redix.command!(:redix, [\"CONFIG\", \"GET\", \"maxmemory\"])\n\n      Redix.command!(:redix, [\"CONFIG\", \"SET\", \"maxmemory\", \"10\"])\n\n      on_exit(fn ->\n        Redix.command!(:redix, [\"CONFIG\", \"SET\", \"maxmemory\", value])\n      end)\n    end\n\n    test \"raises error\" do\n      expected_error_message =\n        \"Redix received unexpected response [{%Redix.Error{message: \\\"OOM command not allowed when used memory > 'maxmemory'.\\\"}, \"\n\n      assert_raise RuntimeError, ~r/#{Regex.escape(expected_error_message)}/, fn ->\n        RedisCache.put(@default_config, {\"key\", \"value\"})\n      end\n    end\n  end\n\n  test \"can put multiple records at once\" do\n    RedisCache.put(@default_config, [{\"key1\", \"1\"}, {\"key2\", \"2\"}])\n    assert RedisCache.get(@default_config, \"key1\") == \"1\"\n    assert RedisCache.get(@default_config, \"key2\") == \"2\"\n  end\n\n  test \"can match fetch all\" do\n    assert RedisCache.all(@default_config, :_) == []\n\n    for number <- 1..11, do: RedisCache.put(@default_config, {\"key#{number}\", \"value\"})\n    items = RedisCache.all(@default_config, :_)\n\n    assert Enum.find(items, fn {key, \"value\"} -> key == \"key1\" end)\n    assert Enum.find(items, fn {key, \"value\"} -> key == \"key2\" end)\n    assert length(items) == 11\n\n    RedisCache.put(@default_config, {[\"namespace\", \"key\"], \"value\"})\n    RedisCache.put(@default_config, {[\"namespace\", \"key\", \"key2\"], \"value\"})\n    assert RedisCache.all(@default_config, [\"namespace\", :_]) == [{[\"namespace\", \"key\"], \"value\"}]\n  end\n\n  test \"records auto purge\" do\n    config = Keyword.put(@default_config, :ttl, 50)\n\n    RedisCache.put(config, {\"key\", \"value\"})\n    RedisCache.put(config, [{\"key1\", \"1\"}, {[\"namespace\", \"key2\"], \"2\"}])\n    assert RedisCache.get(config, \"key\") == \"value\"\n    assert RedisCache.get(config, \"key1\") == \"1\"\n    assert RedisCache.get(config, [\"namespace\", \"key2\"]) == \"2\"\n    assert redix_zmembers_decoded(\"namespace\") == [\"key2\"]\n    RedisCache.put(Keyword.put(@default_config, :ttl, 150), [{[\"namespace\", \"key3\"], \"3\"}])\n    assert redix_zmembers_decoded(\"namespace\") == [\"key2\", \"key3\"]\n    :timer.sleep(100)\n    assert RedisCache.get(config, \"key\") == :not_found\n    assert RedisCache.get(config, \"key1\") == :not_found\n    assert RedisCache.get(config, [\"namespace\", \"key2\"]) == :not_found\n    assert RedisCache.get(config, [\"namespace\", \"key3\"]) == \"3\"\n    RedisCache.put(Keyword.put(@default_config, :ttl, 100), [{[\"namespace\", \"key4\"], \"4\"}])\n    assert redix_zmembers_decoded(\"namespace\") == [\"key3\", \"key4\"]\n    :timer.sleep(100)\n    assert RedisCache.get(config, [\"namespace\", \"key3\"]) == :not_found\n    assert RedisCache.all(config, [\"namespace\", :_]) ==  []\n    assert redix_zmembers_decoded(\"namespace\") == []\n  end\n\n  defp redix_zmembers_decoded(key) do\n    encoded_prefix =\n      [@default_config[:namespace]]\n      |> Kernel.++(List.wrap(key))\n      |> Enum.map(fn part ->\n        part\n        |> :erlang.term_to_binary()\n        |> Base.url_encode64(padding: false)\n      end)\n      |> Enum.join(\":\")\n\n    :redix\n    |> Redix.command!([\"ZRANGEBYSCORE\", \"_index:#{encoded_prefix}\", \"-inf\", \"+inf\"])\n    |> Enum.map(fn encoded_key ->\n      encoded_key\n      |> String.split(\":\")\n      |> Enum.map(fn part ->\n        part\n        |> Base.url_decode64!(padding: false)\n        |> :erlang.binary_to_term()\n      end)\n      |> case do\n        [key] -> key\n        key   -> key\n      end\n    end)\n  end\nend\n```","ref":"redis_cache_store_backend.html#test-module"},{"type":"extras","title":"Pow in an umbrella project","doc":"# Pow in an umbrella project\n\nAdding Pow to an umbrella project is near identical to a single app setup.\n\nInstead of running `mix pow.install`, you should run `mix pow.ecto.install` inside your ecto app, and `mix pow.phoenix.install` inside your phoenix app(s).\n\nYou can follow the rest of the [README](../README.md#phoenix-app) instructions with the following caveats in mind:\n\n- Run all mix ecto tasks inside the ecto app\n- Run all mix phoenix tasks inside the phoenix app(s)\n- For a project generated with `mix phx.new --umbrella` use `:my_app_web` instead of `:my_app`","ref":"umbrella_project.html"},{"type":"extras","title":"Multitenancy with Pow","doc":"# Multitenancy with Pow\n\nYou can pass repo options to the functions used in `Pow.Ecto.Context` by using the `:repo_opts` configuration option. This makes it possible to pass on the prefix option used in multitenancy apps, so you can do the following:\n\n```elixir\nconfig :my_app, :pow,\n  # ...\n  repo_opts: [prefix: \"tenant_a\"]\n```\n\nYou can also pass the prefix option to `Pow.Plug.Session` in your `WEB_PATH/endpoint.ex`:\n\n```elixir\nplug Pow.Plug.Session, otp_app: :my_app, repo_opts: [prefix: \"tenant_a\"]\n```\n\nAnd you can add it as a custom plug to use a dynamic prefix value (in this case the `conn.private[:tenant_prefix]` has been set beforehand):\n\n```elixir\ndefmodule MyAppWeb.Pow.TenantPlug do\n  def init(config), do: config\n\n  def call(conn, config) do\n    prefix = conn.private[:tenant_prefix]\n    config = Keyword.put(config, :repo_opts, [prefix: prefix])\n\n    Pow.Plug.Session.call(conn, config)\n  end\nend\n```","ref":"multitenancy.html"},{"type":"extras","title":"Process dictionary - Multitenancy with Pow","doc":"Another common approach is [to use the process dictionary](https://hexdocs.pm/ecto/3.5.8/multi-tenancy-with-foreign-keys.html). In that case you won't have to pass any repo opts. You just use your modified `MyApp.Repo` module to set and fetch the tenant id in a controller or plug. It could look like:\n\n```elixir\ndefmodule MyAppWeb.SetTenantPlug do\n  def init(opts), do: opts\n\n  def call(conn, _opts_) do\n    MyApp.Repo.put_org_id(conn.private[:tenant_org_id])\n\n    conn\n  end\nend\n```","ref":"multitenancy.html#process-dictionary"},{"type":"extras","title":"Triplex - Multitenancy with Pow","doc":"[Triplex](https://github.com/ateliware/triplex) is a database multitenancy package. Pow can be easily configured to work with Triplex.\n\nUpdate your `WEB_PATH/endpoint.ex` using a custom plug rather than the default `Pow.Plug.Session`:\n\n```elixir\n# lib/my_app_web/endpoint.ex\ndefmodule MyAppWeb.Endpoint do\n  use Phoenix.Endpoint, otp_app: :my_app\n\n  # ...\n\n  # You should load the tenant with Triplex before calling the\n  # `TriplexSessionPlug`. If you use the `ParamPlug` you could add it here:\n  # plug Triplex.ParamPlug, param: :subdomain\n\n  # ...\n\n  plug Plug.Session, @session_options\n  plug MyAppWeb.Pow.TriplexSessionPlug, otp_app: :my_app\n  # ...\nend\n```\n\nThen set up `WEB_PATH/pow/triplex_session_plug.ex`:\n\n```elixir\n# lib/my_app_web/pow/triplex_session_plug.ex\ndefmodule MyAppWeb.Pow.TriplexSessionPlug do\n  def init(config), do: config\n\n  def call(conn, config) do\n    tenant = conn.assigns[:current_tenant] || conn.assigns[:raw_current_tenant]\n    prefix = Triplex.to_prefix(tenant)\n    config = Keyword.put(config, :repo_opts, [prefix: prefix])\n\n    Pow.Plug.Session.call(conn, config)\n  end\nend\n```","ref":"multitenancy.html#triplex"},{"type":"extras","title":"Triplex create tenant migration with user - Multitenancy with Pow","doc":"You may want to create an new tenant with a Pow user as part of account registration.\n\nFirst we'll add the account context module that will create an account with a user using an `Ecto.Multi` transaction:\n\n```elixir\n# test/my_app/accounts.exs\ndefmodule MyApp.Accounts do\n  alias Ecto.Changeset\n  alias MyApp.{Repo, Users.User}\n\n  @otp_app :my_app\n  @tenant_param :tenant\n\n  def create_account(tenant_id, params) do\n    tenant_id\n    |> Triplex.create_schema(Repo, fn (tenant, repo) ->\n      do_create_account(tenant, repo, params)\n    end)\n    |> case do\n      {:ok, tenant} -> {:ok, Repo.one!(User, prefix: tenant)}\n      {:error, %Changeset{} = changeset} -> {:error, changeset}\n      {:error, reason} -> invalid_tenant_changeset_error(params, \"couldn't be created\", reason)\n    end\n  end\n\n  defp do_create_account(tenant, repo, params) do\n    pow_config =\n      [\n        otp_app: @otp_app,\n        repo: repo,\n        user: User,\n        repo_opts: [prefix: tenant]\n      ]\n\n    Ecto.Multi.new()\n    |> Ecto.Multi.run(:triplex_migration, fn repo, %{} ->\n      Triplex.migrate(tenant, repo)\n    end)\n    |> Ecto.Multi.run(:user, fn _, _ ->\n      Pow.Ecto.Context.create(params, pow_config)\n    end)\n    |> repo.transaction()\n    |> case do\n      {:ok, any} ->\n        {:ok, any}\n\n      {:error, :triplex_migration, reason, _} ->\n        invalid_tenant_changeset_error(params, \"couldn't be created\", [reason: reason])\n\n      {:error, :user, changeset, _} ->\n        {:error, changeset}\n    end\n  end\n\n  defp invalid_tenant_changeset_error(params, error, keys) do\n    changeset =\n      %User{}\n      |> User.changeset(params)\n      |> Changeset.add_error(@tenant_param, error, keys)\n\n    {:error, changeset}\n  end\nend\n```\n\nNext we'll add the controller:\n\n```elixir\n# lib/my_app_web/controllers/account_controller.ex\ndefmodule MyAppWeb.AccountController do\n  use MyAppWeb, :controller\n\n  alias MyApp.Accounts\n\n  def new(conn, _params) do\n    render(conn, \"new.html\")\n  end\n\n  def create(conn, %{\"account\" => tenant_id, \"user\" => user_params}) do\n    case Accounts.create_account(tenant_id, user_params) do\n      {:ok, user} ->\n        conn\n        |> Pow.Plug.create(user)\n        |> put_flash(:info, \"Welcome!\")\n        |> redirect(to: ~p\"/\")\n\n      {:error, changeset} ->\n        render(conn, \"new.html\", changeset: changeset)\n    end\n  end\nend\n```\n\nNow all you need is to set up the template, and update your router module.","ref":"multitenancy.html#triplex-create-tenant-migration-with-user"},{"type":"extras","title":"Triplex test modules - Multitenancy with Pow","doc":"```elixir\n# lib/my_app_web/pow/triplex_session_plug_test.exs\ndefmodule MyAppWeb.Pow.TriplexSessionPlugTest do\n  use MyAppWeb.ConnCase\n\n  alias MyAppWeb.Pow.TriplexSessionPlug\n\n  @pow_config [otp_app: :my_app]\n  @tenant_a \"tenant_a\"\n  @tenant_b \"tenant_b\"\n  @valid_user_params %{\n    \"email\" => \"test@example.com\",\n    \"password\" => \"password\",\n    \"password_confirmation\" => \"password\"\n  }\n\n  setup do\n    {:ok, conn: init_conn()}\n  end\n\n  test \"handles Triplex tenants\", %{conn: conn} do\n    opts = TriplexSessionPlug.init(@pow_config)\n    {:ok, _user, _conn} =\n      conn\n      |> set_triplex_tenant(@tenant_a)\n      |> TriplexSessionPlug.call(opts)\n      |> Pow.Plug.create_user(@valid_user_params)\n\n    {:error, _conn} =\n      conn\n      |> set_triplex_tenant(@tenant_b)\n      |> TriplexSessionPlug.call(opts)\n      |> Pow.Plug.authenticate_user(@valid_user_params)\n\n    {:ok, _conn} =\n      conn\n      |> set_triplex_tenant(@tenant_a)\n      |> TriplexSessionPlug.call(opts)\n      |> Pow.Plug.authenticate_user(@valid_user_params)\n  end\n\n  defp init_conn() do\n    :get\n    |> Plug.Test.conn(\"/\")\n    |> Plug.Test.init_test_session(%{})\n    |> fetch_flash()\n  end\n\n  defp set_triplex_tenant(conn, tenant) do\n    conn = %{conn | params: %{\"subdomain\" => tenant}}\n    opts = Triplex.ParamPlug.init(param: :subdomain)\n\n    Triplex.ParamPlug.call(conn, opts)\n  end\nend\n```\n\n```elixir\n# test/my_app/accounts_test.exs\ndefmodule MyApp.AccountsTest do\n  use MyApp.DataCase\n\n  alias MyApp.{Repo, Accounts}\n\n  @tenant_id \"test_tenant\"\n  @tenant_param :tenant\n  @valid_params %{email: \"test@example.com\", password: \"secret1234\", password_confirmation: \"secret1234\"}\n\n  setup do\n    Ecto.Adapters.SQL.Sandbox.mode(Repo, :auto)\n\n    Triplex.drop(@tenant_id, Repo)\n\n    on_exit fn ->\n      Triplex.drop(@tenant_id, Repo)\n    end\n\n    :ok\n  end\n\n  test \"create_account/2\" do\n    assert {:ok, user} = Accounts.create_account(@tenant_id, @valid_params)\n    assert user.__meta__.prefix == @tenant_id\n\n    assert {:error, changeset} = Accounts.create_account(@tenant_id, @valid_params)\n    assert changeset.errors[@tenant_param] == {\"couldn't be created\", \"ERROR 42P06 (duplicate_schema) schema \\\"#{@tenant_id}\\\" already exists\"}\n  end\nend\n```\n\n```elixir\n# test/my_app_web/controllers/account_controller_test.exs\ndefmodule MyAppWeb.AccountControllerTest do\n  use MyAppWeb.ConnCase\n\n  alias MyApp.Repo\n\n  @tenant_id \"test-tenant\"\n\n  setup do\n    Ecto.Adapters.SQL.Sandbox.mode(Repo, :auto)\n\n    Triplex.drop(@tenant_id, Repo)\n\n    on_exit fn ->\n      Triplex.drop(@tenant_id, Repo)\n    end\n\n    :ok\n  end\n\n  describe \"create/2\" do\n    @valid_params %{\"account\" => @tenant_id, \"user\" => %{\"email\" => \"test@example.com\", \"password\" => \"secret1234\", \"password_confirmation\" => \"secret1234\"}}\n    @invalid_params %{\"account\" => @tenant_id, \"user\" => %{\"email\" => \"test@example.com\", \"password\" => \"secret1234\"}}\n\n    test \"with invalid params\", %{conn: conn} do\n      conn = post(conn, ~p\"/account\", @invalid_params)\n\n      assert html_response(conn, 500)\n      refute Pow.Plug.current_user(conn)\n    end\n\n    test \"with valid params\", %{conn: conn} do\n      conn = post(conn, ~p\"/account\", @valid_params)\n\n      assert Phoenix.Flash.get(conn.assigns.flash, :info) == \"Welcome!\"\n      assert redirected_to(conn) == ~p\"/\"\n\n      assert Pow.Plug.current_user(conn)\n    end\n  end\nend\n```","ref":"multitenancy.html#triplex-test-modules"},{"type":"extras","title":"Update cached user credentials","doc":"# Update cached user credentials\n\nYou may want to update the cached user credentials when an action outside of Pow has updated the user. It's very important to understand that the cached user credentials that Pow fetches in `Pow.Plug.current_user/2` is always to be considered out of date since it's a cached object.\n\nIn the following examples, we'll imagine that you've added a `plan` column on your `users` table. We may want to use that `plan` to give them access to certain controller actions. In this case, it's paramount that you load the user from the database.","ref":"sync_user.html"},{"type":"extras","title":"Update `Pow.Store.CredentialsCache` config - Update cached user credentials","doc":"If you wish to load the user object each time it's fetched from the cache, all you have to do is to set `reload: true` for the `Pow.Store.CredentialsCache` config by adding this to your Pow config:\n\n```elixir\ncredentials_cache_store: {Pow.Store.CredentialsCache, reload: true}\n```","ref":"sync_user.html#update-pow-store-credentialscache-config"},{"type":"extras","title":"Reload the user with a plug - Update cached user credentials","doc":"```elixir\ndefmodule MyAppWeb.ProPlanController do\n  # ...\n\n  plug :reload_user\n\n  # ...\n\n  defp reload_user(conn, _opts) do\n    config        = Pow.Plug.fetch_config(conn)\n    user          = Pow.Plug.current_user(conn, config)\n    reloaded_user = MyApp.Repo.get!(MyApp.User, user.id)\n\n    Pow.Plug.assign_current_user(conn, reloaded_user, config)\n  end\nend\n```\n\nThis should always be done for any authorization actions or any other actions that require the actual value to be known. Do note that only the controllers that have the plug will have the reloaded user. In all other controllers, the old cached credentials will be loaded instead.\n\nIf you would like to always fetch the user as it is in the database across all your controllers, you could instead set up a module plug and add it to your endpoint:\n\n```elixir\ndefmodule MyAppWeb.ReloadUserPlug do\n  @doc false\n\n  @spec init(any()) :: any()\n  def init(opts), do: opts\n\n  @doc false\n  @spec call(Conn.t(), atom()) :: Conn.t()\n  def call(conn, _opts) do\n    config = Pow.Plug.fetch_config(conn)\n\n    case Pow.Plug.current_user(conn, config) do\n      nil ->\n        conn\n\n      user ->\n        reloaded_user = MyApp.Repo.get!(MyApp.User, user.id)\n\n        Pow.Plug.assign_current_user(conn, reloaded_user, config)\n    end\n  end\nend\n```\n\n```elixir\ndefmodule MyAppWeb.Endpoint do\n  use Phoenix.Endpoint, otp_app: :my_app\n\n  # ...\n\n  plug Plug.Session, @session_options\n  plug Pow.Plug.Session, otp_app: :my_app\n  plug MyAppWeb.ReloadUserPlug\n  # ...\nend\n```","ref":"sync_user.html#reload-the-user-with-a-plug"},{"type":"extras","title":"Update user in the credentials cache - Update cached user credentials","doc":"Let's say that you want to show the user `plan` on most pages. In this case, we can safely rely on the cached credentials since we don't need to know the actual value in the database. The worst case is that a different plan may be shown if you haven't ensured that all plan update actions use the below function.\n\nWe can use `Pow.Plug.create/2` to call the plug and update the cached credentials.\n\nFirst, we'll make a helper and import it to our controllers:\n\n```elixir\ndefmodule MyAppWeb.Pow.Helper do\n  @spec sync_user(Plug.Conn.t(), map()) :: Plug.Conn.t()\n  def sync_user(conn, user), do: Pow.Plug.create(conn, user)\nend\n```\n\n```elixir\ndefmodule MyAppWeb do\n  # ...\n\n  def controller do\n    quote do\n      use Phoenix.Controller, namespace: MyAppWeb\n\n      # ...\n      import MyAppWeb.Pow.Helper\n    end\n  end\n\n  # ...\nend\n```\n\nNow we can call `sync_user/2` in any controller actions. It could maybe be the update action for your plan controller:\n\n```elixir\ndefmodule MyAppWeb.PlanController do\n  # ...\n\n  def update(conn, %{\"plan\" => plan}) do\n    conn\n    |> Plug.current_user()\n    |> MyApp.Users.update_plan(plan)\n    |> case do\n      {:ok, user} ->\n        conn\n        |> sync_user(user) # Update the user in the credentials cache\n        |> put_flash(:info, \"Plan updated successfully.\")\n        |> redirect(to: ~p\"/profile\")\n\n      {:error, %Ecto.Changeset{} = changeset} ->\n        render(conn, \"plan.html\", changeset: changeset)\n    end\n  end\n\n  # ...\nend\n```\n\nAs you can see in the above, the cached user credentials will be updated after a successful update of the plan for the user. Now any subsequent pages being rendered, you'll have access to the updated `plan` value in the current user assign.\n\nAnother thing to note is that if you're using `Pow.Plug.Session`, then the session id will also be regenerated this way. This is ideal for authorization level change (what the above `plan` change action maybe).\n\nYou may also update the `plan` field in a background task. In this case, you won't have access to any current session, and you would have to use the `Pow.Store.CredentialsCache.put/3` to update the credentials cache. However, since there are some caveats to this, it's instead recommended to find an alternative solution with the above functions.","ref":"sync_user.html#update-user-in-the-credentials-cache"},{"type":"extras","title":"How to use Pow in an API","doc":"# How to use Pow in an API\n\nPow comes with plug n' play support for Phoenix as HTML web interface. API's work differently, and the developer should have full control over the flow in a proper built API. Therefore Pow encourages that you build custom controllers, and use the plug functions for API integration.\n\nTo get you started, here's the first steps to build a Pow enabled API interface.\n\nWe'll set up a [custom authorization plug](../README.md#authorization-plug) where we'll store session tokens with `Pow.Store.CredentialsCache`, and renewal tokens with `PowPersistentSession.Store.PersistentSessionCache`. The session tokens will automatically expire after 30 minutes, whereafter your client should request a new session token with the renewal token.\n\nFirst you should follow the [Getting Started](../README.md#getting-started) section in README until before the `WEB_PATH/endpoint.ex` modification.","ref":"api.html"},{"type":"extras","title":"Routes - How to use Pow in an API","doc":"Modify `WEB_PATH/router.ex` with API pipelines, and API endpoints for session and registration controllers:\n\n```elixir\n# lib/my_app_web/router.ex\ndefmodule MyAppWeb.Router do\n  use MyAppWeb, :router\n\n  # # If you wish to also use Pow in your HTML frontend with session, then you\n  # # should set the `Pow.Plug.Session` plug here rather than in the endpoint:\n  # pipeline :browser do\n  #   plug :accepts, [\"html\"]\n  #   plug :fetch_session\n  #   plug :fetch_flash\n  #   plug Phoenix.LiveView.Flash\n  #   plug :protect_from_forgery\n  #   plug :put_secure_browser_headers\n  #   plug Pow.Plug.Session, otp_app: :my_app\n  # end\n\n  pipeline :api do\n    plug :accepts, [\"json\"]\n    plug MyAppWeb.APIAuthPlug, otp_app: :my_app\n  end\n\n  pipeline :api_protected do\n    plug Pow.Plug.RequireAuthenticated, error_handler: MyAppWeb.APIAuthErrorHandler\n  end\n\n  # ...\n\n  scope \"/api/v1\", MyAppWeb.API.V1, as: :api_v1 do\n    pipe_through :api\n\n    resources \"/registration\", RegistrationController, singleton: true, only: [:create]\n    resources \"/session\", SessionController, singleton: true, only: [:create, :delete]\n    post \"/session/renew\", SessionController, :renew\n  end\n\n  scope \"/api/v1\", MyAppWeb.API.V1, as: :api_v1 do\n    pipe_through [:api, :api_protected]\n\n    # Your protected API endpoints here\n  end\n\n  # ... routes\nend\n```\n\nAs you can see, the above also shows how you can set up the browser pipeline in case you also have a web interface. You should put the `Pow.Plug.Session` plug there instead of in `WEB_PATH/endpoint.ex`.","ref":"api.html#routes"},{"type":"extras","title":"API authorization plug for Pow - How to use Pow in an API","doc":"Create `WEB_PATH/api_auth_plug.ex` with the following:\n\n```elixir\n# lib/my_app_web/api_auth_plug.ex\ndefmodule MyAppWeb.APIAuthPlug do\n  @moduledoc false\n  use Pow.Plug.Base\n\n  alias Plug.Conn\n  alias Pow.{Config, Plug, Store.CredentialsCache}\n  alias PowPersistentSession.Store.PersistentSessionCache\n\n  @doc \"\"\"\n  Fetches the user from access token.\n  \"\"\"\n  @impl true\n  @spec fetch(Conn.t(), Config.t()) :: {Conn.t(), map() | nil}\n  def fetch(conn, config) do\n    with {:ok, signed_token} <- fetch_access_token(conn),\n         {:ok, token}        <- verify_token(conn, signed_token, config),\n         {user, _metadata}   <- CredentialsCache.get(store_config(config), token) do\n      {conn, user}\n    else\n      _any -> {conn, nil}\n    end\n  end\n\n  @doc \"\"\"\n  Creates an access and renewal token for the user.\n\n  The tokens are added to the `conn.private` as `:api_access_token` and\n  `:api_renewal_token`. The renewal token is stored in the access token\n  metadata and vice versa.\n  \"\"\"\n  @impl true\n  @spec create(Conn.t(), map(), Config.t()) :: {Conn.t(), map()}\n  def create(conn, user, config) do\n    store_config  = store_config(config)\n    access_token  = Pow.UUID.generate()\n    renewal_token = Pow.UUID.generate()\n\n    conn =\n      conn\n      |> Conn.put_private(:api_access_token, sign_token(conn, access_token, config))\n      |> Conn.put_private(:api_renewal_token, sign_token(conn, renewal_token, config))\n      |> Conn.register_before_send(fn conn ->\n        # The store caches will use their default `:ttl` setting. To change the\n        # `:ttl`, `Keyword.put(store_config, :ttl, :timer.minutes(10))` can be\n        # passed in as the first argument instead of `store_config`.\n        CredentialsCache.put(store_config, access_token, {user, [renewal_token: renewal_token]})\n        PersistentSessionCache.put(store_config, renewal_token, {user, [access_token: access_token]})\n\n        conn\n      end)\n\n    {conn, user}\n  end\n\n  @doc \"\"\"\n  Delete the access token from the cache.\n\n  The renewal token is deleted by fetching it from the access token metadata.\n  \"\"\"\n  @impl true\n  @spec delete(Conn.t(), Config.t()) :: Conn.t()\n  def delete(conn, config) do\n    store_config = store_config(config)\n\n    with {:ok, signed_token} <- fetch_access_token(conn),\n         {:ok, token}        <- verify_token(conn, signed_token, config),\n         {_user, metadata}   <- CredentialsCache.get(store_config, token) do\n\n      Conn.register_before_send(conn, fn conn ->\n        PersistentSessionCache.delete(store_config, metadata[:renewal_token])\n        CredentialsCache.delete(store_config, token)\n\n        conn\n      end)\n    else\n      _any -> conn\n    end\n  end\n\n  @doc \"\"\"\n  Creates new tokens using the renewal token.\n\n  The access token, if any, will be deleted by fetching it from the renewal\n  token metadata. The renewal token will be deleted from the store after the\n  it has been fetched.\n  \"\"\"\n  @spec renew(Conn.t(), Config.t()) :: {Conn.t(), map() | nil}\n  def renew(conn, config) do\n    store_config = store_config(config)\n\n    with {:ok, signed_token} <- fetch_access_token(conn),\n         {:ok, token}        <- verify_token(conn, signed_token, config),\n         {user, metadata}    <- PersistentSessionCache.get(store_config, token) do\n\n      {conn, user} = create(conn, user, config)\n\n      conn =\n        Conn.register_before_send(conn, fn conn ->\n          CredentialsCache.delete(store_config, metadata[:access_token])\n          PersistentSessionCache.delete(store_config, token)\n\n          conn\n        end)\n\n      {conn, user}\n    else\n      _any -> {conn, nil}\n    end\n  end\n\n  defp sign_token(conn, token, config) do\n    Plug.sign_token(conn, signing_salt(), token, config)\n  end\n\n  defp signing_salt(), do: Atom.to_string(__MODULE__)\n\n  defp fetch_access_token(conn) do\n    case Conn.get_req_header(conn, \"authorization\") do\n      [token | _rest] -> {:ok, token}\n      _any            -> :error\n    end\n  end\n\n  defp verify_token(conn, token, config),\n    do: Plug.verify_token(conn, signing_salt(), token, config)\n\n  defp store_config(config) do\n    backend = Config.get(config, :cache_store_backend, Pow.Store.Backend.EtsCache)\n\n    [backend: backend, pow_config: config]\n  end\nend\n```\n\nThe above module includes renewal logic, and will return both an auth token and renewal token when a session is created.","ref":"api.html#api-authorization-plug-for-pow"},{"type":"extras","title":"API authorization error handler - How to use Pow in an API","doc":"Create `WEB_PATH/api_auth_error_handler.ex` with the following:\n\n```elixir\ndefmodule MyAppWeb.APIAuthErrorHandler do\n  use MyAppWeb, :controller\n  alias Plug.Conn\n\n  @spec call(Conn.t(), :not_authenticated) :: Conn.t()\n  def call(conn, :not_authenticated) do\n    conn\n    |> put_status(401)\n    |> json(%{error: %{code: 401, message: \"Not authenticated\"}})\n  end\nend\n```\n\nNow the protected routes will return a 401 error when an invalid token is used.","ref":"api.html#api-authorization-error-handler"},{"type":"extras","title":"Add API controllers - How to use Pow in an API","doc":"Create `WEB_PATH/controllers/api/v1/registration_controller.ex`:\n\n```elixir\ndefmodule MyAppWeb.API.V1.RegistrationController do\n  use MyAppWeb, :controller\n\n  alias Ecto.Changeset\n  alias Plug.Conn\n  alias MyAppWeb.ErrorHelpers\n\n  @spec create(Conn.t(), map()) :: Conn.t()\n  def create(conn, %{\"user\" => user_params}) do\n    conn\n    |> Pow.Plug.create_user(user_params)\n    |> case do\n      {:ok, _user, conn} ->\n        json(conn, %{data: %{access_token: conn.private.api_access_token, renewal_token: conn.private.api_renewal_token}})\n\n      {:error, changeset, conn} ->\n        errors = Changeset.traverse_errors(changeset, &ErrorHelpers.translate_error/1)\n\n        conn\n        |> put_status(500)\n        |> json(%{error: %{status: 500, message: \"Couldn't create user\", errors: errors}})\n    end\n  end\nend\n```\n\nCreate `WEB_PATH/controllers/api/v1/session_controller.ex`:\n\n```elixir\ndefmodule MyAppWeb.API.V1.SessionController do\n  use MyAppWeb, :controller\n\n  alias MyAppWeb.APIAuthPlug\n  alias Plug.Conn\n\n  @spec create(Conn.t(), map()) :: Conn.t()\n  def create(conn, %{\"user\" => user_params}) do\n    conn\n    |> Pow.Plug.authenticate_user(user_params)\n    |> case do\n      {:ok, conn} ->\n        json(conn, %{data: %{access_token: conn.private.api_access_token, renewal_token: conn.private.api_renewal_token}})\n\n      {:error, conn} ->\n        conn\n        |> put_status(401)\n        |> json(%{error: %{status: 401, message: \"Invalid email or password\"}})\n    end\n  end\n\n  @spec renew(Conn.t(), map()) :: Conn.t()\n  def renew(conn, _params) do\n    config = Pow.Plug.fetch_config(conn)\n\n    conn\n    |> APIAuthPlug.renew(config)\n    |> case do\n      {conn, nil} ->\n        conn\n        |> put_status(401)\n        |> json(%{error: %{status: 401, message: \"Invalid token\"}})\n\n      {conn, _user} ->\n        json(conn, %{data: %{access_token: conn.private.api_access_token, renewal_token: conn.private.api_renewal_token}})\n    end\n  end\n\n  @spec delete(Conn.t(), map()) :: Conn.t()\n  def delete(conn, _params) do\n    conn\n    |> Pow.Plug.delete()\n    |> json(%{data: %{}})\n  end\nend\n```\n\nThat's it!\n\nYou can now set up your client to connect to your API and generate session tokens. The session and renewal token should be send with the `authorization` header. When you receive a 401 error, you should renew the session with the renewal token and then try again.\n\nYou can run the following curl commands to test it out:\n\n```bash\n$ curl -X POST -d \"user[email]=test@example.com&user[password]=secret1234&user[password_confirmation]=secret1234\" http://localhost:4000/api/v1/registration\n{\"data\":{\"renewal_token\":\"RENEW_TOKEN\",\"access_token\":\"AUTH_TOKEN\"}}\n\n$ curl -X POST -d \"user[email]=test@example.com&user[password]=secret1234\" http://localhost:4000/api/v1/session\n{\"data\":{\"renewal_token\":\"RENEW_TOKEN\",\"access_token\":\"AUTH_TOKEN\"}}\n\n$ curl -X DELETE -H \"Authorization: AUTH_TOKEN\" http://localhost:4000/api/v1/session\n{\"data\":{}}\n\n$ curl -X POST -H \"Authorization: RENEW_TOKEN\" http://localhost:4000/api/v1/session/renew\n{\"data\":{\"renewal_token\":\"RENEW_TOKEN\",\"access_token\":\"AUTH_TOKEN\"}}\n```","ref":"api.html#add-api-controllers"},{"type":"extras","title":"OAuth 2.0 - How to use Pow in an API","doc":"You may notice that the renew mechanism looks like refresh tokens in OAuth 2.0, and that's because the above setup is very similar since we use short lived session ids. In some cases it may make more sense to set up an OAuth 2.0 server rather than using the above setup.","ref":"api.html#oauth-2-0"},{"type":"extras","title":"Test modules - How to use Pow in an API","doc":"```elixir\n# test/my_app_web/api_auth_plug_test.exs\ndefmodule MyAppWeb.APIAuthPlugTest do\n  use MyAppWeb.ConnCase\n  doctest MyAppWeb.APIAuthPlug\n\n  alias MyAppWeb.{APIAuthPlug, Endpoint}\n  alias MyApp.{Repo, Users.User}\n  alias Plug.Conn\n\n  @pow_config [otp_app: :my_app]\n\n  setup %{conn: conn} do\n    conn = %{conn | secret_key_base: Endpoint.config(:secret_key_base)}\n    user = Repo.insert!(%User{id: 1, email: \"test@example.com\"})\n\n    {:ok, conn: conn, user: user}\n  end\n\n  test \"can create, fetch, renew, and delete session\", %{conn: conn, user: user} do\n    assert {_res_conn, nil} = run(APIAuthPlug.fetch(conn, @pow_config))\n\n    assert {res_conn, ^user} = run(APIAuthPlug.create(conn, user, @pow_config))\n    assert %{private: %{api_access_token: access_token, api_renewal_token: renewal_token}} = res_conn\n\n    assert {_res_conn, nil} = run(APIAuthPlug.fetch(with_auth_header(conn, \"invalid\"), @pow_config))\n    assert {_res_conn, ^user} = run(APIAuthPlug.fetch(with_auth_header(conn, access_token), @pow_config))\n    assert {res_conn, ^user} = run(APIAuthPlug.renew(with_auth_header(conn, renewal_token), @pow_config))\n    assert %{private: %{api_access_token: renewed_access_token, api_renewal_token: renewed_renewal_token}} = res_conn\n\n    assert {_res_conn, nil} = run(APIAuthPlug.fetch(with_auth_header(conn, access_token), @pow_config))\n    assert {_res_conn, nil} = run(APIAuthPlug.renew(with_auth_header(conn, renewal_token), @pow_config))\n    assert {_res_conn, ^user} = run(APIAuthPlug.fetch(with_auth_header(conn, renewed_access_token), @pow_config))\n\n    assert %Conn{} = run(APIAuthPlug.delete(with_auth_header(conn, \"invalid\"), @pow_config))\n    assert {_res_conn, ^user} = run(APIAuthPlug.fetch(with_auth_header(conn, renewed_access_token), @pow_config))\n\n    assert %Conn{} = run(APIAuthPlug.delete(with_auth_header(conn, renewed_access_token), @pow_config))\n    assert {_res_conn, nil} = run(APIAuthPlug.fetch(with_auth_header(conn, renewed_access_token), @pow_config))\n    assert {_res_conn, nil} = run(APIAuthPlug.renew(with_auth_header(conn, renewed_renewal_token), @pow_config))\n  end\n\n  defp run({conn, value}), do: {run(conn), value}\n  defp run(conn), do: Conn.send_resp(conn, 200, \"\")\n\n  defp with_auth_header(conn, token), do: Plug.Conn.put_req_header(conn, \"authorization\", token)\nend\n```\n\n```elixir\n# test/my_app_web/controllers/api/v1/registration_controller_test.exs\ndefmodule MyAppWeb.API.V1.RegistrationControllerTest do\n  use MyAppWeb.ConnCase\n\n  @password \"secret1234\"\n\n  describe \"create/2\" do\n    @valid_params %{\"user\" => %{\"email\" => \"test@example.com\", \"password\" => @password, \"password_confirmation\" => @password}}\n    @invalid_params %{\"user\" => %{\"email\" => \"invalid\", \"password\" => @password, \"password_confirmation\" => \"\"}}\n\n    test \"with valid params\", %{conn: conn} do\n      conn = post(conn, ~p\"/registration\", @valid_params)\n\n      assert json = json_response(conn, 200)\n      assert json[\"data\"][\"access_token\"]\n      assert json[\"data\"][\"renewal_token\"]\n    end\n\n    test \"with invalid params\", %{conn: conn} do\n      conn = post(conn, ~p\"/registration\", @invalid_params)\n\n      assert json = json_response(conn, 500)\n      assert json[\"error\"][\"message\"] == \"Couldn't create user\"\n      assert json[\"error\"][\"status\"] == 500\n      assert json[\"error\"][\"errors\"][\"password_confirmation\"] == [\"does not match confirmation\"]\n      assert json[\"error\"][\"errors\"][\"email\"] == [\"has invalid format\"]\n    end\n  end\nend\n```\n\n```elixir\n# test/my_app_web/controllers/api/v1/session_controller_test.exs\ndefmodule MyAppWeb.API.V1.SessionControllerTest do\n  use MyAppWeb.ConnCase\n\n  alias MyApp.{Repo, Users.User}\n\n  @password \"secret1234\"\n\n  setup do\n    user =\n      %User{}\n      |> User.changeset(%{email: \"test@example.com\", password: @password, password_confirmation: @password})\n      |> Repo.insert!()\n\n    {:ok, user: user}\n  end\n\n  describe \"create/2\" do\n    @valid_params %{\"user\" => %{\"email\" => \"test@example.com\", \"password\" => @password}}\n    @invalid_params %{\"user\" => %{\"email\" => \"test@example.com\", \"password\" => \"invalid\"}}\n\n    test \"with valid params\", %{conn: conn} do\n      conn = post(conn, ~p\"/api/v1/session\", @valid_params)\n\n      assert json = json_response(conn, 200)\n      assert json[\"data\"][\"access_token\"]\n      assert json[\"data\"][\"renewal_token\"]\n    end\n\n    test \"with invalid params\", %{conn: conn} do\n      conn = post(conn, ~p\"/api/v1/session\", @invalid_params)\n\n      assert json = json_response(conn, 401)\n      assert json[\"error\"][\"message\"] == \"Invalid email or password\"\n      assert json[\"error\"][\"status\"] == 401\n    end\n  end\n\n  describe \"renew/2\" do\n    setup %{conn: conn} do\n      authed_conn = post(conn, ~p\"/api/v1/session\", @valid_params)\n\n      {:ok, renewal_token: authed_conn.private[:api_renewal_token]}\n    end\n\n    test \"with valid authorization header\", %{conn: conn, renewal_token: token} do\n      conn =\n        conn\n        |> Plug.Conn.put_req_header(\"authorization\", token)\n        |> post(~p\"/api/v1/session/renew\")\n\n      assert json = json_response(conn, 200)\n      assert json[\"data\"][\"access_token\"]\n      assert json[\"data\"][\"renewal_token\"]\n    end\n\n    test \"with invalid authorization header\", %{conn: conn} do\n      conn =\n        conn\n        |> Plug.Conn.put_req_header(\"authorization\", \"invalid\")\n        |> post(~p\"/api/v1/session/renew\")\n\n      assert json = json_response(conn, 401)\n      assert json[\"error\"][\"message\"] == \"Invalid token\"\n      assert json[\"error\"][\"status\"] == 401\n    end\n  end\n\n  describe \"delete/2\" do\n    setup %{conn: conn} do\n      authed_conn = post(conn, ~p\"/api/v1/session/\", @valid_params)\n\n      {:ok, access_token: authed_conn.private[:api_access_token]}\n    end\n\n    test \"invalidates\", %{conn: conn, access_token: token} do\n      conn =\n        conn\n        |> Plug.Conn.put_req_header(\"authorization\", token)\n        |> delete( ~p\"/api/v1/session/\")\n\n      assert json = json_response(conn, 200)\n      assert json[\"data\"] == %{}\n    end\n  end\nend\n```","ref":"api.html#test-modules"}],"content_type":"text/markdown"}